/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  struct f_tree *lst = NULL;
  int i;

  if ((fa == ta) || ((fb == 0) && (tb == 0xFFFF)))
    return f_new_pair_item(fa, ta, fb, tb);
  
  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define EC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{ 
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;
  
    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;    
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}



/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

#ifdef OSPFv2
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}
#endif

#ifdef OSPFv3
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if ((ip->autype != OSPF_AUTH_NONE) || (get_passwords() != NULL))
    cf_error("Authentication not supported in OSPFv3");
}
#endif

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only Stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
     backbone = 1;
  }
  cf->abr = areano > 1;

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error( "Vlinks cannot be used on single area router");
}

static inline void
check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
set_instance_id(unsigned id)
{
#ifdef OSPFv3
  OSPF_PATT->instance_id = id;
#else
  cf_error("Instance ID requires OSPFv3");
#endif
}

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

#ifdef IPV6
#define RIP_DEFAULT_TTL_SECURITY 2
#else
#define RIP_DEFAULT_TTL_SECURITY 0
#endif

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;


/* Line 371 of yacc.c  */
#line 555 "cf-parse.tab.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     ELSECOL = 261,
     DDOT = 262,
     GEQ = 263,
     LEQ = 264,
     NEQ = 265,
     AND = 266,
     OR = 267,
     PO = 268,
     PC = 269,
     NUM = 270,
     ENUM = 271,
     RTRID = 272,
     IPA = 273,
     SYM = 274,
     TEXT = 275,
     PREFIX_DUMMY = 276,
     DEFINE = 277,
     ON = 278,
     OFF = 279,
     YES = 280,
     NO = 281,
     LOG = 282,
     SYSLOG = 283,
     ALL = 284,
     DEBUG = 285,
     TRACE = 286,
     INFO = 287,
     REMOTE = 288,
     WARNING = 289,
     ERROR = 290,
     AUTH = 291,
     FATAL = 292,
     BUG = 293,
     STDERR = 294,
     SOFT = 295,
     TIMEFORMAT = 296,
     ISO = 297,
     SHORT = 298,
     LONG = 299,
     BASE = 300,
     NAME = 301,
     CONFIRM = 302,
     UNDO = 303,
     CHECK = 304,
     TIMEOUT = 305,
     CONFIGURE = 306,
     DOWN = 307,
     KERNEL = 308,
     PERSIST = 309,
     SCAN = 310,
     TIME = 311,
     LEARN = 312,
     DEVICE = 313,
     ROUTES = 314,
     KRT_SOURCE = 315,
     KRT_METRIC = 316,
     TABLE = 317,
     KRT_PREFSRC = 318,
     KRT_REALM = 319,
     ROUTER = 320,
     ID = 321,
     PROTOCOL = 322,
     TEMPLATE = 323,
     PREFERENCE = 324,
     DISABLED = 325,
     DIRECT = 326,
     INTERFACE = 327,
     IMPORT = 328,
     EXPORT = 329,
     FILTER = 330,
     NONE = 331,
     STATES = 332,
     FILTERS = 333,
     RECEIVE = 334,
     LIMIT = 335,
     ACTION = 336,
     WARN = 337,
     BLOCK = 338,
     RESTART = 339,
     DISABLE = 340,
     KEEP = 341,
     FILTERED = 342,
     PASSWORD = 343,
     FROM = 344,
     PASSIVE = 345,
     TO = 346,
     EVENTS = 347,
     PACKETS = 348,
     PROTOCOLS = 349,
     INTERFACES = 350,
     PRIMARY = 351,
     STATS = 352,
     COUNT = 353,
     FOR = 354,
     COMMANDS = 355,
     PREEXPORT = 356,
     GENERATE = 357,
     ROA = 358,
     MAX = 359,
     FLUSH = 360,
     LISTEN = 361,
     BGP = 362,
     V6ONLY = 363,
     DUAL = 364,
     ADDRESS = 365,
     PORT = 366,
     PASSWORDS = 367,
     DESCRIPTION = 368,
     SORTED = 369,
     RELOAD = 370,
     IN = 371,
     OUT = 372,
     MRTDUMP = 373,
     MESSAGES = 374,
     RESTRICT = 375,
     MEMORY = 376,
     IGP_METRIC = 377,
     CLASS = 378,
     DSCP = 379,
     SHOW = 380,
     STATUS = 381,
     SUMMARY = 382,
     ROUTE = 383,
     SYMBOLS = 384,
     ADD = 385,
     DELETE = 386,
     DUMP = 387,
     RESOURCES = 388,
     SOCKETS = 389,
     NEIGHBORS = 390,
     ATTRIBUTES = 391,
     EVAL = 392,
     ECHO = 393,
     ENABLE = 394,
     FUNCTION = 395,
     PRINT = 396,
     PRINTN = 397,
     UNSET = 398,
     RETURN = 399,
     ACCEPT = 400,
     REJECT = 401,
     QUITBIRD = 402,
     INT = 403,
     BOOL = 404,
     IP = 405,
     PREFIX = 406,
     PAIR = 407,
     QUAD = 408,
     EC = 409,
     SET = 410,
     STRING = 411,
     BGPMASK = 412,
     BGPPATH = 413,
     CLIST = 414,
     ECLIST = 415,
     IF = 416,
     THEN = 417,
     ELSE = 418,
     CASE = 419,
     TRUE = 420,
     FALSE = 421,
     RT = 422,
     RO = 423,
     UNKNOWN = 424,
     GENERIC = 425,
     GW = 426,
     NET = 427,
     MASK = 428,
     PROTO = 429,
     SOURCE = 430,
     SCOPE = 431,
     CAST = 432,
     DEST = 433,
     LEN = 434,
     DEFINED = 435,
     CONTAINS = 436,
     RESET = 437,
     PREPEND = 438,
     FIRST = 439,
     LAST = 440,
     MATCH = 441,
     ROA_CHECK = 442,
     EMPTY = 443,
     WHERE = 444,
     LOCAL = 445,
     NEIGHBOR = 446,
     AS = 447,
     HOLD = 448,
     CONNECT = 449,
     RETRY = 450,
     KEEPALIVE = 451,
     MULTIHOP = 452,
     STARTUP = 453,
     VIA = 454,
     NEXT = 455,
     HOP = 456,
     SELF = 457,
     DEFAULT = 458,
     PATH = 459,
     METRIC = 460,
     START = 461,
     DELAY = 462,
     FORGET = 463,
     WAIT = 464,
     AFTER = 465,
     BGP_PATH = 466,
     BGP_LOCAL_PREF = 467,
     BGP_MED = 468,
     BGP_ORIGIN = 469,
     BGP_NEXT_HOP = 470,
     BGP_ATOMIC_AGGR = 471,
     BGP_AGGREGATOR = 472,
     BGP_COMMUNITY = 473,
     BGP_EXT_COMMUNITY = 474,
     RR = 475,
     RS = 476,
     CLIENT = 477,
     CLUSTER = 478,
     AS4 = 479,
     ADVERTISE = 480,
     IPV4 = 481,
     CAPABILITIES = 482,
     PREFER = 483,
     OLDER = 484,
     MISSING = 485,
     LLADDR = 486,
     DROP = 487,
     IGNORE = 488,
     REFRESH = 489,
     INTERPRET = 490,
     COMMUNITIES = 491,
     BGP_ORIGINATOR_ID = 492,
     BGP_CLUSTER_LIST = 493,
     IGP = 494,
     GATEWAY = 495,
     RECURSIVE = 496,
     MED = 497,
     TTL = 498,
     SECURITY = 499,
     DETERMINISTIC = 500,
     SECONDARY = 501,
     OSPF = 502,
     AREA = 503,
     OSPF_METRIC1 = 504,
     OSPF_METRIC2 = 505,
     OSPF_TAG = 506,
     OSPF_ROUTER_ID = 507,
     RFC1583COMPAT = 508,
     STUB = 509,
     TICK = 510,
     COST = 511,
     COST2 = 512,
     RETRANSMIT = 513,
     HELLO = 514,
     TRANSMIT = 515,
     PRIORITY = 516,
     DEAD = 517,
     TYPE = 518,
     BROADCAST = 519,
     BCAST = 520,
     NONBROADCAST = 521,
     NBMA = 522,
     POINTOPOINT = 523,
     PTP = 524,
     POINTOMULTIPOINT = 525,
     PTMP = 526,
     SIMPLE = 527,
     AUTHENTICATION = 528,
     STRICT = 529,
     CRYPTOGRAPHIC = 530,
     ELIGIBLE = 531,
     POLL = 532,
     NETWORKS = 533,
     HIDDEN = 534,
     VIRTUAL = 535,
     LINK = 536,
     ONLY = 537,
     RX = 538,
     BUFFER = 539,
     LARGE = 540,
     NORMAL = 541,
     STUBNET = 542,
     TAG = 543,
     EXTERNAL = 544,
     LSADB = 545,
     ECMP = 546,
     WEIGHT = 547,
     NSSA = 548,
     TRANSLATOR = 549,
     STABILITY = 550,
     GLOBAL = 551,
     LSID = 552,
     INSTANCE = 553,
     REAL = 554,
     NETMASK = 555,
     TX = 556,
     TOPOLOGY = 557,
     STATE = 558,
     PIPE = 559,
     PEER = 560,
     MODE = 561,
     OPAQUE = 562,
     TRANSPARENT = 563,
     RIP = 564,
     INFINITY = 565,
     PERIOD = 566,
     GARBAGE = 567,
     MULTICAST = 568,
     QUIET = 569,
     NOLISTEN = 570,
     VERSION1 = 571,
     PLAINTEXT = 572,
     MD5 = 573,
     HONOR = 574,
     NEVER = 575,
     ALWAYS = 576,
     RIP_METRIC = 577,
     RIP_TAG = 578,
     STATIC = 579,
     PROHIBIT = 580,
     MULTIPATH = 581,
     BLACKHOLE = 582,
     UNREACHABLE = 583
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 483 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;


/* Line 387 of yacc.c  */
#line 954 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE cf_lval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int cf_parse (void *YYPARSE_PARAM);
#else
int cf_parse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int cf_parse (void);
#else
int cf_parse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 982 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  66
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2595

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  350
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  235
/* YYNRULES -- Number of rules.  */
#define YYNRULES  772
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1454

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   583

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    31,     2,     2,     2,    30,     2,     2,
     341,   342,    28,    26,   346,    27,    32,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   343,   340,
      23,    22,    24,   347,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   348,     2,   349,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   344,     2,   345,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    19,    21,    25,
      27,    29,    31,    33,    35,    37,    38,    40,    42,    43,
      46,    49,    51,    53,    56,    59,    61,    63,    64,    69,
      72,    73,    75,    78,    80,    82,    86,    88,    92,    94,
      96,    98,   100,   102,   104,   106,   108,   110,   115,   119,
     121,   123,   125,   127,   130,   135,   139,   143,   147,   152,
     158,   162,   166,   171,   174,   175,   177,   178,   180,   183,
     186,   189,   193,   196,   200,   203,   207,   211,   215,   220,
     226,   228,   230,   232,   237,   238,   241,   244,   247,   249,
     251,   252,   254,   258,   262,   263,   272,   274,   279,   281,
     283,   284,   286,   290,   291,   294,   297,   300,   303,   306,
     309,   313,   317,   321,   326,   329,   333,   336,   339,   341,
     343,   345,   346,   349,   352,   355,   358,   361,   363,   365,
     369,   373,   374,   376,   378,   381,   382,   384,   388,   390,
     394,   395,   398,   401,   404,   407,   411,   415,   419,   420,
     424,   426,   428,   432,   434,   438,   440,   442,   444,   446,
     448,   450,   452,   454,   458,   460,   464,   466,   468,   473,
     475,   476,   480,   485,   487,   490,   491,   497,   503,   509,
     515,   520,   524,   528,   533,   539,   541,   542,   546,   551,
     556,   557,   560,   564,   568,   572,   575,   578,   581,   584,
     588,   592,   595,   598,   600,   602,   607,   608,   612,   616,
     620,   621,   623,   625,   630,   631,   634,   637,   640,   643,
     646,   649,   652,   653,   656,   666,   676,   681,   685,   689,
     693,   697,   701,   705,   709,   713,   718,   720,   722,   726,
     727,   729,   733,   737,   741,   745,   750,   755,   760,   765,
     768,   770,   772,   774,   776,   777,   779,   780,   785,   788,
     790,   792,   794,   796,   798,   800,   802,   804,   806,   808,
     810,   812,   815,   818,   819,   823,   825,   829,   831,   833,
     835,   838,   842,   845,   850,   851,   857,   858,   860,   862,
     865,   867,   871,   873,   875,   877,   879,   881,   883,   887,
     889,   891,   893,   895,   897,   901,   903,   909,   921,   923,
     925,   927,   930,   932,   940,   950,   958,   960,   962,   964,
     968,   970,   972,   974,   978,   980,   984,   986,   990,   994,
     996,   999,  1002,  1009,  1011,  1015,  1016,  1021,  1025,  1027,
    1031,  1035,  1039,  1042,  1045,  1048,  1051,  1052,  1055,  1058,
    1059,  1061,  1063,  1065,  1067,  1069,  1071,  1073,  1077,  1081,
    1083,  1085,  1091,  1099,  1100,  1105,  1107,  1109,  1111,  1113,
    1115,  1117,  1119,  1121,  1123,  1127,  1131,  1135,  1139,  1143,
    1147,  1151,  1155,  1159,  1163,  1167,  1171,  1175,  1179,  1182,
    1187,  1189,  1191,  1193,  1195,  1198,  1201,  1205,  1209,  1216,
    1220,  1224,  1228,  1232,  1238,  1245,  1252,  1259,  1266,  1271,
    1280,  1285,  1287,  1289,  1291,  1293,  1295,  1297,  1299,  1300,
    1302,  1306,  1308,  1312,  1313,  1315,  1320,  1327,  1332,  1336,
    1342,  1348,  1353,  1360,  1364,  1367,  1373,  1379,  1388,  1397,
    1406,  1415,  1418,  1422,  1426,  1432,  1439,  1447,  1454,  1459,
    1464,  1470,  1477,  1484,  1490,  1494,  1499,  1505,  1511,  1517,
    1523,  1529,  1534,  1539,  1545,  1551,  1557,  1563,  1569,  1575,
    1581,  1587,  1594,  1601,  1610,  1617,  1624,  1630,  1635,  1641,
    1646,  1652,  1657,  1663,  1668,  1674,  1680,  1683,  1687,  1691,
    1693,  1696,  1700,  1703,  1708,  1711,  1713,  1716,  1721,  1722,
    1726,  1729,  1731,  1734,  1738,  1742,  1746,  1750,  1753,  1757,
    1758,  1764,  1765,  1771,  1774,  1777,  1779,  1784,  1786,  1788,
    1789,  1793,  1796,  1799,  1802,  1808,  1811,  1812,  1816,  1817,
    1820,  1823,  1827,  1830,  1833,  1837,  1840,  1843,  1846,  1848,
    1852,  1855,  1858,  1861,  1864,  1867,  1870,  1874,  1877,  1880,
    1883,  1886,  1889,  1892,  1895,  1898,  1902,  1906,  1910,  1913,
    1917,  1920,  1924,  1928,  1933,  1936,  1939,  1942,  1946,  1950,
    1954,  1957,  1961,  1965,  1970,  1972,  1973,  1976,  1980,  1982,
    1983,  1985,  1988,  1989,  1992,  1993,  1995,  1999,  2000,  2001,
    2004,  2005,  2009,  2010,  2014,  2019,  2021,  2022,  2027,  2034,
    2041,  2048,  2056,  2063,  2071,  2077,  2078,  2081,  2085,  2088,
    2092,  2096,  2099,  2103,  2106,  2109,  2113,  2117,  2123,  2128,
    2133,  2136,  2140,  2144,  2149,  2154,  2159,  2165,  2171,  2176,
    2180,  2185,  2190,  2195,  2200,  2202,  2204,  2206,  2208,  2210,
    2212,  2214,  2216,  2217,  2220,  2223,  2226,  2230,  2234,  2239,
    2240,  2244,  2245,  2249,  2250,  2254,  2257,  2261,  2265,  2271,
    2277,  2281,  2284,  2288,  2292,  2294,  2297,  2302,  2306,  2310,
    2314,  2317,  2320,  2323,  2326,  2329,  2334,  2336,  2338,  2340,
    2342,  2344,  2346,  2348,  2350,  2352,  2354,  2356,  2358,  2360,
    2362,  2364,  2366,  2368,  2370,  2372,  2374,  2376,  2378,  2380,
    2382,  2384,  2386,  2388,  2390,  2392,  2394,  2396,  2398,  2400,
    2402,  2404,  2406,  2408,  2410,  2412,  2414,  2416,  2418,  2420,
    2422,  2424,  2426,  2428,  2430,  2432,  2434,  2436,  2438,  2440,
    2442,  2444,  2446,  2448,  2450,  2452,  2455,  2458,  2461,  2464,
    2467,  2470,  2473,  2476,  2480,  2484,  2488,  2492,  2496,  2500,
    2504,  2506,  2508,  2510,  2512,  2514,  2516,  2518,  2520,  2522,
    2524,  2526,  2528,  2530,  2532,  2534,  2536,  2538,  2540,  2542,
    2544,  2546,  2548
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     351,     0,    -1,   352,     3,    -1,     4,   580,    -1,    -1,
     352,   579,    -1,    33,    19,    22,   512,   340,    -1,    15,
      -1,   341,   512,   342,    -1,    19,    -1,   354,    -1,    34,
      -1,    36,    -1,    35,    -1,    37,    -1,    -1,    18,    -1,
      19,    -1,    -1,    30,    19,    -1,   356,   360,    -1,   358,
      -1,   356,    -1,    29,   354,    -1,   343,   356,    -1,    20,
      -1,    20,    -1,    -1,    38,   365,   366,   340,    -1,    57,
      20,    -1,    -1,    20,    -1,    39,   364,    -1,    50,    -1,
      40,    -1,   344,   367,   345,    -1,   368,    -1,   367,   346,
     368,    -1,    41,    -1,    42,    -1,    43,    -1,    44,    -1,
      45,    -1,    46,    -1,    47,    -1,    48,    -1,    49,    -1,
     129,   105,   419,   340,    -1,   129,    20,   340,    -1,   139,
      -1,    78,    -1,    56,    -1,    38,    -1,   370,    20,    -1,
     370,    20,   354,    20,    -1,   370,    53,    54,    -1,   370,
      53,    55,    -1,    52,   371,   340,    -1,    62,   379,   380,
       3,    -1,    62,    51,   379,   380,     3,    -1,    62,    58,
       3,    -1,    62,    59,     3,    -1,    62,    60,   379,     3,
      -1,    63,     3,    -1,    -1,    20,    -1,    -1,    61,    -1,
      61,   354,    -1,   396,    64,    -1,    65,   355,    -1,    66,
      67,   354,    -1,    68,   355,    -1,    69,    70,   355,    -1,
     396,    69,    -1,    66,    67,   354,    -1,   107,   362,   359,
      -1,    64,    73,   354,    -1,    76,    77,   387,   340,    -1,
      76,    77,   100,   410,   340,    -1,    15,    -1,    17,    -1,
      18,    -1,   117,   118,   389,   340,    -1,    -1,   389,   390,
      -1,   121,   356,    -1,   122,   354,    -1,   119,    -1,   120,
      -1,    -1,   125,    -1,    73,    19,   391,    -1,   114,    73,
      19,    -1,    -1,   394,   114,   358,   115,    15,   203,    15,
     340,    -1,   393,    -1,   393,   344,   394,   345,    -1,    78,
      -1,    79,    -1,    -1,    19,    -1,    19,   100,    19,    -1,
      -1,    80,   354,    -1,    81,   355,    -1,    41,   416,    -1,
     129,   419,    -1,    84,   399,    -1,    85,   399,    -1,    90,
      91,   401,    -1,    84,    91,   401,    -1,    85,    91,   401,
      -1,    84,    97,    98,   355,    -1,    73,   402,    -1,    76,
      77,   387,    -1,   124,    20,    -1,    86,   476,    -1,   477,
      -1,    40,    -1,    87,    -1,    -1,    92,    93,    -1,    92,
      94,    -1,    92,    95,    -1,    92,    96,    -1,   354,   400,
      -1,    35,    -1,    19,    -1,    41,   105,   416,    -1,    41,
     111,   354,    -1,    -1,    20,    -1,   359,    -1,    20,   359,
      -1,    -1,    27,    -1,   404,   406,   405,    -1,   407,    -1,
     408,   346,   407,    -1,    -1,   409,   408,    -1,   134,   354,
      -1,   135,   354,    -1,   396,    82,    -1,   412,   397,   344,
      -1,   413,   398,   340,    -1,   413,   415,   340,    -1,    -1,
      83,   414,   408,    -1,    40,    -1,    35,    -1,   344,   417,
     345,    -1,   418,    -1,   417,   346,   418,    -1,    88,    -1,
      70,    -1,    89,    -1,   106,    -1,   103,    -1,   104,    -1,
      40,    -1,    35,    -1,   344,   420,   345,    -1,   421,    -1,
     420,   346,   421,    -1,    88,    -1,   130,    -1,   123,   344,
     423,   345,    -1,   424,    -1,    -1,   424,   340,   423,    -1,
     425,   344,   426,   345,    -1,   425,    -1,    99,    20,    -1,
      -1,   113,   100,   361,   340,   426,    -1,   113,   102,   361,
     340,   426,    -1,   156,   100,   361,   340,   426,    -1,   156,
     102,   361,   340,   426,    -1,    77,   354,   340,   426,    -1,
     136,   137,     3,    -1,   136,   132,     3,    -1,   136,   105,
     467,     3,    -1,   136,   105,    40,   467,     3,    -1,    19,
      -1,    -1,   136,   106,     3,    -1,   136,   106,   138,     3,
      -1,   136,   139,   435,     3,    -1,    -1,   435,   358,    -1,
     435,   110,   359,    -1,   435,    73,    19,    -1,   435,    86,
     476,    -1,   435,   477,    -1,   435,    40,    -1,   435,   107,
      -1,   435,    98,    -1,   435,   436,    19,    -1,   435,    78,
      19,    -1,   435,   108,    -1,   435,   109,    -1,   112,    -1,
      85,    -1,   136,   114,   438,     3,    -1,    -1,   438,   439,
     358,    -1,   438,   203,    15,    -1,   438,    73,    19,    -1,
      -1,   127,    -1,   110,    -1,   136,   140,   441,     3,    -1,
      -1,   441,    73,    -1,   441,   151,    -1,   441,    86,    -1,
     441,    78,    -1,   441,    79,    -1,   441,   114,    -1,   441,
      19,    -1,    -1,    73,    19,    -1,   141,   114,   358,   115,
      15,   203,    15,   442,     3,    -1,   142,   114,   358,   115,
      15,   203,    15,   442,     3,    -1,   116,   114,   442,     3,
      -1,   143,   144,     3,    -1,   143,   145,     3,    -1,   143,
     106,     3,    -1,   143,   146,     3,    -1,   143,   147,     3,
      -1,   143,    70,     3,    -1,   143,   105,     3,    -1,   148,
     512,     3,    -1,   149,   455,   456,     3,    -1,    40,    -1,
      35,    -1,   344,   367,   345,    -1,    -1,    15,    -1,    96,
     466,     3,    -1,   150,   466,     3,    -1,    95,   466,     3,
      -1,   126,   466,     3,    -1,   126,   127,   466,     3,    -1,
     126,   128,   466,     3,    -1,    41,   466,   416,     3,    -1,
     129,   466,   419,     3,    -1,   131,     3,    -1,    19,    -1,
      40,    -1,    20,    -1,    19,    -1,    -1,    20,    -1,    -1,
      86,    19,   469,   475,    -1,   148,   512,    -1,   159,    -1,
     160,    -1,   161,    -1,   162,    -1,   163,    -1,   164,    -1,
     165,    -1,   167,    -1,   168,    -1,   169,    -1,   170,    -1,
     171,    -1,   471,   166,    -1,   471,    19,    -1,    -1,   472,
     340,   473,    -1,   472,    -1,   472,   340,   474,    -1,   479,
      -1,    19,    -1,   475,    -1,   200,   512,    -1,   341,   474,
     342,    -1,   341,   342,    -1,   473,   344,   482,   345,    -1,
      -1,   151,    19,   481,   478,   479,    -1,    -1,   483,    -1,
     518,    -1,   483,   518,    -1,   518,    -1,   344,   482,   345,
      -1,    18,    -1,   354,    -1,    17,    -1,   485,    -1,    16,
      -1,    15,    -1,   341,   512,   342,    -1,    17,    -1,   485,
      -1,    16,    -1,   512,    -1,   488,    -1,   488,     7,   488,
      -1,    28,    -1,   341,   489,   346,   489,   342,    -1,   341,
     489,   346,   489,   342,     7,   341,   488,   346,   488,   342,
      -1,   512,    -1,   178,    -1,   179,    -1,   180,    15,    -1,
     181,    -1,   341,   492,   346,   491,   346,   491,   342,    -1,
     341,   492,   346,   491,   346,   491,     7,   491,   342,    -1,
     341,   492,   346,   491,   346,    28,   342,    -1,   490,    -1,
     493,    -1,   486,    -1,   486,     7,   486,    -1,   490,    -1,
     493,    -1,   487,    -1,   487,     7,   487,    -1,   494,    -1,
     496,   346,   494,    -1,   495,    -1,   497,   346,   495,    -1,
      18,    29,    15,    -1,   498,    -1,   498,    26,    -1,   498,
      27,    -1,   498,   344,    15,   346,    15,   345,    -1,   499,
      -1,   500,   346,   499,    -1,    -1,   501,   497,   343,   482,
      -1,   501,     6,   482,    -1,   510,    -1,   341,   512,   342,
      -1,    13,   504,    14,    -1,    29,   505,    29,    -1,    15,
     504,    -1,    28,   504,    -1,   347,   504,    -1,   502,   504,
      -1,    -1,    15,   505,    -1,   347,   505,    -1,    -1,    15,
      -1,   176,    -1,   177,    -1,    20,    -1,   485,    -1,   498,
      -1,    17,    -1,   348,   496,   349,    -1,   348,   500,   349,
      -1,    16,    -1,   503,    -1,   341,   512,   346,   512,   342,
      -1,   341,   492,   346,   512,   346,   512,   342,    -1,    -1,
      19,   341,   517,   342,    -1,    19,    -1,   100,    -1,   182,
      -1,   183,    -1,   185,    -1,   186,    -1,   187,    -1,   188,
      -1,   189,    -1,   341,   512,   342,    -1,   512,    26,   512,
      -1,   512,    27,   512,    -1,   512,    28,   512,    -1,   512,
      29,   512,    -1,   512,    11,   512,    -1,   512,    12,   512,
      -1,   512,    22,   512,    -1,   512,    10,   512,    -1,   512,
      23,   512,    -1,   512,     9,   512,    -1,   512,    24,   512,
      -1,   512,     8,   512,    -1,   512,    25,   512,    -1,    31,
     512,    -1,   191,   341,   512,   342,    -1,   510,    -1,   506,
      -1,   507,    -1,    80,    -1,   508,   511,    -1,   508,   584,
      -1,   512,    32,   161,    -1,   512,    32,   190,    -1,   512,
      32,   184,   341,   512,   342,    -1,   512,    32,   195,    -1,
     512,    32,   196,    -1,    26,   199,    26,    -1,    27,   199,
      27,    -1,    27,    27,   199,    27,    27,    -1,   194,   341,
     512,   346,   512,   342,    -1,   141,   341,   512,   346,   512,
     342,    -1,   142,   341,   512,   346,   512,   342,    -1,    86,
     341,   512,   346,   512,   342,    -1,   198,   341,    19,   342,
      -1,   198,   341,    19,   346,   512,   346,   512,   342,    -1,
      19,   341,   517,   342,    -1,   158,    -1,   156,    -1,   157,
      -1,    46,    -1,   152,    -1,   153,    -1,   512,    -1,    -1,
     514,    -1,   514,   346,   515,    -1,   512,    -1,   512,   346,
     516,    -1,    -1,   516,    -1,   172,   512,   173,   484,    -1,
     172,   512,   173,   484,   174,   484,    -1,    19,    22,   512,
     340,    -1,   155,   512,   340,    -1,   508,   584,    22,   512,
     340,    -1,   508,   511,    22,   512,   340,    -1,    80,    22,
     512,   340,    -1,   154,   341,   508,   584,   342,   340,    -1,
     513,   515,   340,    -1,   509,   340,    -1,   175,   512,   344,
     501,   345,    -1,   508,   584,    32,   199,   340,    -1,   508,
     584,    32,   194,   341,   512,   342,   340,    -1,   508,   584,
      32,   141,   341,   512,   342,   340,    -1,   508,   584,    32,
     142,   341,   512,   342,   340,    -1,   508,   584,    32,    86,
     341,   512,   342,   340,    -1,   396,   118,    -1,   519,   397,
     344,    -1,   520,   398,   340,    -1,   520,   201,   203,   354,
     340,    -1,   520,   201,   356,   203,   354,   340,    -1,   520,
     202,   356,   357,   203,   354,   340,    -1,   520,   231,   234,
      77,   387,   340,    -1,   520,   231,   233,   340,    -1,   520,
     232,   233,   340,    -1,   520,   204,    67,   354,   340,    -1,
     520,   209,   204,    67,   354,   340,    -1,   520,   205,   206,
      67,   354,   340,    -1,   520,   207,    67,   354,   340,    -1,
     520,   208,   340,    -1,   520,   208,   354,   340,    -1,   520,
     211,   212,   213,   340,    -1,   520,   211,   212,    97,   340,
      -1,   520,   241,   242,   213,   340,    -1,   520,   241,   242,
     243,   340,    -1,   520,   241,   242,   244,   340,    -1,   520,
     251,    82,   340,    -1,   520,   251,   252,   340,    -1,   520,
     215,   216,   355,   340,    -1,   520,   253,   216,   355,   340,
      -1,   520,   250,   216,   355,   340,    -1,   520,   239,   240,
     355,   340,    -1,   520,   256,   253,   355,   340,    -1,   520,
     214,   224,   354,   340,    -1,   520,   214,   223,   354,   340,
      -1,   520,   186,   121,   356,   340,    -1,   520,   217,   218,
      67,   354,   340,    -1,   520,    46,   219,    67,   354,   340,
      -1,   520,    46,   220,    67,   354,   346,   354,   340,    -1,
     520,    96,   221,    46,   355,   340,    -1,   520,   150,   139,
     245,   355,   340,    -1,   520,   150,   235,   355,   340,    -1,
     520,   238,   355,   340,    -1,   520,   236,   237,   355,   340,
      -1,   520,    99,    20,   340,    -1,   520,   139,    91,   354,
     340,    -1,   520,   101,   355,   340,    -1,   520,   246,   247,
     355,   340,    -1,   520,   257,   355,   340,    -1,   520,   250,
      73,   402,   340,    -1,   520,   254,   255,   355,   340,    -1,
     396,   258,    -1,   521,   397,   344,    -1,   522,   523,   340,
      -1,   398,    -1,   264,   355,    -1,   265,    76,   355,    -1,
     302,   355,    -1,   302,   355,    91,   354,    -1,   266,   354,
      -1,   525,    -1,   259,   387,    -1,   524,   344,   526,   345,
      -1,    -1,   526,   527,   340,    -1,   265,   355,    -1,   304,
      -1,   138,   355,    -1,   214,   304,   355,    -1,   214,   267,
     354,    -1,   214,   268,   354,    -1,   265,   267,   354,    -1,
     305,   355,    -1,   305,   306,   354,    -1,    -1,   289,   528,
     344,   539,   345,    -1,    -1,   300,   529,   344,   539,   345,
      -1,   298,   530,    -1,    83,   550,    -1,   534,    -1,   531,
     344,   532,   345,    -1,   531,    -1,   358,    -1,    -1,   532,
     533,   340,    -1,   290,   355,    -1,   138,   355,    -1,   267,
     354,    -1,   537,   547,   344,   535,   345,    -1,   537,   547,
      -1,    -1,   535,   536,   340,    -1,    -1,   270,   354,    -1,
     269,   354,    -1,   271,   218,   354,    -1,   220,   354,    -1,
     273,   354,    -1,   273,   109,   354,    -1,   284,    87,    -1,
     284,   283,    -1,   284,   286,    -1,   422,    -1,   291,   292,
     387,    -1,   267,   354,    -1,   270,   354,    -1,   288,   354,
      -1,   269,   354,    -1,   220,   354,    -1,   273,   354,    -1,
     273,   109,   354,    -1,   274,   275,    -1,   274,   276,    -1,
     274,   277,    -1,   274,   278,    -1,   274,   279,    -1,   274,
     280,    -1,   274,   281,    -1,   274,   282,    -1,   310,   275,
     355,    -1,   280,   311,   355,    -1,   271,   218,   354,    -1,
     272,   354,    -1,   285,   277,   355,    -1,   265,   355,    -1,
      60,   292,   355,    -1,   302,   303,   354,    -1,   146,   344,
     543,   345,    -1,   284,    87,    -1,   284,   283,    -1,   284,
     286,    -1,   294,   295,   296,    -1,   294,   295,   297,    -1,
     294,   295,   354,    -1,   312,   411,    -1,   312,   272,   354,
      -1,   254,   255,   355,    -1,   254,   255,   312,   293,    -1,
     422,    -1,    -1,   539,   540,    -1,   541,   542,   340,    -1,
     358,    -1,    -1,   290,    -1,   299,   354,    -1,    -1,   543,
     545,    -1,    -1,   287,    -1,    18,   544,   340,    -1,    -1,
      -1,   309,   354,    -1,    -1,   548,   538,   340,    -1,    -1,
     344,   548,   345,    -1,   546,   408,   547,   549,    -1,    20,
      -1,    -1,   136,   258,   431,     3,    -1,   136,   258,   146,
     431,   551,     3,    -1,   136,   258,    83,   431,   551,     3,
      -1,   136,   258,   313,   431,   551,     3,    -1,   136,   258,
     313,    40,   431,   551,     3,    -1,   136,   258,   314,   431,
     551,     3,    -1,   136,   258,   314,    40,   431,   551,     3,
      -1,   136,   258,   301,   560,     3,    -1,    -1,   560,   307,
      -1,   560,   259,   387,    -1,   560,   292,    -1,   560,   274,
      15,    -1,   560,   308,   387,    -1,   560,   213,    -1,   560,
      76,   387,    -1,   560,    19,    -1,   396,   315,    -1,   561,
     397,   344,    -1,   562,   398,   340,    -1,   562,   316,    73,
      19,   340,    -1,   562,   317,   318,   340,    -1,   562,   317,
     319,   340,    -1,   396,   320,    -1,   563,   397,   344,    -1,
     564,   398,   340,    -1,   564,   321,   354,   340,    -1,   564,
     122,   354,   340,    -1,   564,   322,   354,   340,    -1,   564,
     323,    67,   354,   340,    -1,   564,    61,    67,   354,   340,
      -1,   564,   284,   565,   340,    -1,   564,   422,   340,    -1,
     564,   330,   332,   340,    -1,   564,   330,   202,   340,    -1,
     564,   330,   331,   340,    -1,   564,    83,   571,   340,    -1,
     328,    -1,   329,    -1,    87,    -1,   275,    -1,   324,    -1,
     325,    -1,   326,    -1,   327,    -1,    -1,   216,   354,    -1,
     317,   566,    -1,   312,   411,    -1,   312,   272,   354,    -1,
     254,   255,   355,    -1,   254,   255,   312,   293,    -1,    -1,
     568,   567,   340,    -1,    -1,   344,   568,   345,    -1,    -1,
     570,   408,   569,    -1,   396,   335,    -1,   572,   397,   344,
      -1,   573,   398,   340,    -1,   573,    60,   292,   355,   340,
      -1,   573,   250,    73,   402,   340,    -1,   573,   577,   340,
      -1,   139,   358,    -1,   210,   356,   357,    -1,   575,   303,
     354,    -1,   575,    -1,   576,   575,    -1,   574,   210,   356,
     357,    -1,   574,   210,    20,    -1,   574,   337,   576,    -1,
     574,   252,   356,    -1,   574,   243,    -1,   574,   157,    -1,
     574,   338,    -1,   574,   339,    -1,   574,   336,    -1,   136,
     335,   431,     3,    -1,   340,    -1,   353,    -1,   363,    -1,
     369,    -1,   372,    -1,   386,    -1,   388,    -1,   392,    -1,
     395,    -1,   581,    -1,   403,    -1,   468,    -1,   470,    -1,
     480,    -1,   373,    -1,   374,    -1,   375,    -1,   376,    -1,
     377,    -1,   378,    -1,   427,    -1,   428,    -1,   429,    -1,
     430,    -1,   432,    -1,   433,    -1,   434,    -1,   437,    -1,
     440,    -1,   443,    -1,   444,    -1,   445,    -1,   446,    -1,
     447,    -1,   448,    -1,   449,    -1,   450,    -1,   451,    -1,
     452,    -1,   453,    -1,   454,    -1,   457,    -1,   458,    -1,
     459,    -1,   460,    -1,   461,    -1,   462,    -1,   463,    -1,
     464,    -1,   465,    -1,   552,    -1,   553,    -1,   554,    -1,
     555,    -1,   556,    -1,   557,    -1,   558,    -1,   559,    -1,
     578,    -1,   582,   345,    -1,   583,   345,    -1,   413,   345,
      -1,   520,   345,    -1,   522,   345,    -1,   562,   345,    -1,
     564,   345,    -1,   573,   345,    -1,   381,   397,   344,    -1,
     582,   398,   340,    -1,   582,   382,   340,    -1,   582,   385,
     340,    -1,   383,   397,   344,    -1,   583,   398,   340,    -1,
     583,   384,   340,    -1,    71,    -1,    72,    -1,    74,    -1,
      75,    -1,   133,    -1,     5,    -1,   225,    -1,   222,    -1,
     226,    -1,   224,    -1,   223,    -1,   227,    -1,   228,    -1,
     229,    -1,   248,    -1,   249,    -1,   230,    -1,   260,    -1,
     261,    -1,   262,    -1,   263,    -1,   333,    -1,   334,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   659,   659,   660,   663,   665,   673,   682,   683,   684,
     694,   695,   696,   697,   698,   699,   705,   706,   713,   714,
     718,   725,   726,   730,   734,   741,   749,   750,   756,   765,
     766,   770,   775,   776,   780,   781,   785,   786,   790,   791,
     792,   793,   794,   795,   796,   797,   798,   804,   805,   814,
     815,   816,   817,   820,   821,   822,   823,   827,   834,   837,
     844,   847,   850,   853,   857,   858,   862,   863,   864,   872,
     877,   878,   882,   889,   895,   900,   904,   918,   932,   933,
     937,   938,   939,   950,   952,   954,   958,   959,   960,   961,
     968,   969,   973,   981,   985,   987,   993,   994,  1001,  1002,
    1006,  1012,  1016,  1026,  1028,  1032,  1033,  1034,  1035,  1036,
    1037,  1038,  1039,  1040,  1041,  1042,  1043,  1047,  1048,  1049,
    1050,  1054,  1055,  1056,  1057,  1058,  1062,  1068,  1072,  1080,
    1081,  1089,  1097,  1098,  1099,  1103,  1104,  1108,  1113,  1114,
    1117,  1125,  1129,  1130,  1136,  1143,  1144,  1145,  1149,  1157,
    1163,  1164,  1165,  1169,  1170,  1174,  1175,  1176,  1177,  1178,
    1179,  1185,  1186,  1187,  1191,  1192,  1196,  1197,  1203,  1204,
    1207,  1209,  1213,  1214,  1218,  1236,  1237,  1238,  1239,  1240,
    1241,  1249,  1252,  1255,  1258,  1262,  1263,  1266,  1269,  1273,
    1277,  1282,  1288,  1295,  1300,  1305,  1310,  1314,  1318,  1322,
    1332,  1340,  1344,  1351,  1352,  1357,  1361,  1368,  1375,  1379,
    1387,  1388,  1389,  1394,  1398,  1401,  1402,  1403,  1404,  1405,
    1406,  1407,  1412,  1417,  1425,  1432,  1439,  1447,  1449,  1451,
    1453,  1455,  1457,  1459,  1462,  1466,  1472,  1473,  1474,  1478,
    1479,  1485,  1487,  1489,  1491,  1493,  1495,  1499,  1503,  1506,
    1510,  1511,  1512,  1516,  1517,  1518,  1526,  1526,  1536,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1573,  1584,  1585,  1592,  1593,  1600,  1609,  1613,
    1617,  1641,  1642,  1646,  1659,  1659,  1675,  1676,  1679,  1680,
    1684,  1687,  1696,  1709,  1710,  1711,  1712,  1716,  1717,  1718,
    1719,  1720,  1724,  1727,  1728,  1729,  1733,  1736,  1745,  1748,
    1749,  1750,  1751,  1755,  1756,  1757,  1761,  1762,  1763,  1764,
    1768,  1769,  1770,  1771,  1775,  1776,  1780,  1781,  1785,  1792,
    1793,  1794,  1795,  1802,  1803,  1806,  1807,  1814,  1826,  1827,
    1831,  1832,  1836,  1837,  1838,  1839,  1840,  1844,  1845,  1846,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1864,  1865,  1875,  1879,  1902,  1916,  1918,  1919,  1920,
    1921,  1922,  1923,  1924,  1928,  1929,  1930,  1931,  1932,  1933,
    1934,  1935,  1936,  1937,  1938,  1939,  1940,  1941,  1942,  1943,
    1945,  1946,  1947,  1949,  1951,  1953,  1955,  1956,  1957,  1958,
    1959,  1969,  1970,  1971,  1972,  1973,  1974,  1975,  1977,  1978,
    1983,  2006,  2007,  2008,  2009,  2010,  2011,  2015,  2018,  2019,
    2020,  2028,  2035,  2044,  2045,  2049,  2055,  2065,  2074,  2080,
    2085,  2092,  2097,  2103,  2104,  2105,  2113,  2114,  2115,  2116,
    2117,  2123,  2144,  2145,  2146,  2147,  2148,  2158,  2159,  2160,
    2161,  2162,  2163,  2164,  2165,  2166,  2167,  2168,  2169,  2170,
    2171,  2172,  2173,  2174,  2175,  2176,  2177,  2178,  2179,  2180,
    2181,  2182,  2183,  2184,  2185,  2186,  2187,  2188,  2189,  2190,
    2191,  2196,  2197,  2198,  2199,  2200,  2211,  2221,  2222,  2226,
    2227,  2228,  2229,  2230,  2231,  2232,  2235,  2250,  2253,  2255,
    2259,  2260,  2261,  2262,  2263,  2264,  2265,  2266,  2267,  2268,
    2268,  2269,  2269,  2270,  2271,  2272,  2276,  2277,  2281,  2289,
    2291,  2295,  2296,  2297,  2301,  2302,  2305,  2307,  2310,  2311,
    2312,  2313,  2314,  2315,  2316,  2317,  2318,  2319,  2320,  2323,
    2345,  2346,  2347,  2348,  2349,  2350,  2351,  2352,  2353,  2354,
    2355,  2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,
    2365,  2366,  2367,  2368,  2369,  2370,  2371,  2372,  2373,  2374,
    2375,  2376,  2377,  2378,  2379,  2382,  2384,  2387,  2389,  2398,
    2400,  2401,  2404,  2406,  2410,  2411,  2414,  2424,  2447,  2449,
    2452,  2454,  2457,  2459,  2463,  2467,  2468,  2473,  2476,  2479,
    2484,  2487,  2492,  2495,  2499,  2503,  2506,  2507,  2508,  2509,
    2510,  2511,  2512,  2513,  2519,  2526,  2527,  2528,  2533,  2534,
    2540,  2547,  2548,  2549,  2550,  2551,  2552,  2553,  2554,  2555,
    2556,  2557,  2558,  2559,  2563,  2564,  2565,  2570,  2571,  2572,
    2573,  2574,  2577,  2578,  2579,  2580,  2581,  2582,  2583,  2586,
    2588,  2591,  2593,  2597,  2609,  2616,  2623,  2624,  2625,  2626,
    2627,  2630,  2639,  2647,  2654,  2655,  2659,  2664,  2670,  2673,
    2678,  2679,  2680,  2681,  2682,  2685,  2692,  2692,  2692,  2692,
    2692,  2692,  2692,  2692,  2692,  2692,  2692,  2692,  2692,  2692,
    2693,  2693,  2693,  2693,  2693,  2693,  2693,  2693,  2693,  2693,
    2693,  2693,  2693,  2693,  2693,  2693,  2693,  2693,  2693,  2693,
    2693,  2693,  2693,  2693,  2693,  2693,  2693,  2693,  2693,  2693,
    2693,  2693,  2693,  2693,  2693,  2693,  2693,  2693,  2693,  2693,
    2693,  2693,  2693,  2693,  2693,  2694,  2694,  2694,  2694,  2694,
    2694,  2694,  2694,  2695,  2695,  2695,  2695,  2696,  2696,  2696,
    2697,  2697,  2697,  2697,  2697,  2698,  2698,  2699,  2700,  2701,
    2702,  2703,  2704,  2705,  2706,  2707,  2708,  2709,  2709,  2709,
    2709,  2709,  2709
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'", "DEFINE",
  "ON", "OFF", "YES", "NO", "LOG", "SYSLOG", "ALL", "DEBUG", "TRACE",
  "INFO", "REMOTE", "WARNING", "ERROR", "AUTH", "FATAL", "BUG", "STDERR",
  "SOFT", "TIMEFORMAT", "ISO", "SHORT", "LONG", "BASE", "NAME", "CONFIRM",
  "UNDO", "CHECK", "TIMEOUT", "CONFIGURE", "DOWN", "KERNEL", "PERSIST",
  "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES", "KRT_SOURCE", "KRT_METRIC",
  "TABLE", "KRT_PREFSRC", "KRT_REALM", "ROUTER", "ID", "PROTOCOL",
  "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT", "INTERFACE", "IMPORT",
  "EXPORT", "FILTER", "NONE", "STATES", "FILTERS", "RECEIVE", "LIMIT",
  "ACTION", "WARN", "BLOCK", "RESTART", "DISABLE", "KEEP", "FILTERED",
  "PASSWORD", "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS",
  "INTERFACES", "PRIMARY", "STATS", "COUNT", "FOR", "COMMANDS",
  "PREEXPORT", "GENERATE", "ROA", "MAX", "FLUSH", "LISTEN", "BGP",
  "V6ONLY", "DUAL", "ADDRESS", "PORT", "PASSWORDS", "DESCRIPTION",
  "SORTED", "RELOAD", "IN", "OUT", "MRTDUMP", "MESSAGES", "RESTRICT",
  "MEMORY", "IGP_METRIC", "CLASS", "DSCP", "SHOW", "STATUS", "SUMMARY",
  "ROUTE", "SYMBOLS", "ADD", "DELETE", "DUMP", "RESOURCES", "SOCKETS",
  "NEIGHBORS", "ATTRIBUTES", "EVAL", "ECHO", "ENABLE", "FUNCTION", "PRINT",
  "PRINTN", "UNSET", "RETURN", "ACCEPT", "REJECT", "QUITBIRD", "INT",
  "BOOL", "IP", "PREFIX", "PAIR", "QUAD", "EC", "SET", "STRING", "BGPMASK",
  "BGPPATH", "CLIST", "ECLIST", "IF", "THEN", "ELSE", "CASE", "TRUE",
  "FALSE", "RT", "RO", "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO",
  "SOURCE", "SCOPE", "CAST", "DEST", "LEN", "DEFINED", "CONTAINS", "RESET",
  "PREPEND", "FIRST", "LAST", "MATCH", "ROA_CHECK", "EMPTY", "WHERE",
  "LOCAL", "NEIGHBOR", "AS", "HOLD", "CONNECT", "RETRY", "KEEPALIVE",
  "MULTIHOP", "STARTUP", "VIA", "NEXT", "HOP", "SELF", "DEFAULT", "PATH",
  "METRIC", "START", "DELAY", "FORGET", "WAIT", "AFTER", "BGP_PATH",
  "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "OSPF", "AREA", "OSPF_METRIC1",
  "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB",
  "TICK", "COST", "COST2", "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY",
  "DEAD", "TYPE", "BROADCAST", "BCAST", "NONBROADCAST", "NBMA",
  "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP", "SIMPLE",
  "AUTHENTICATION", "STRICT", "CRYPTOGRAPHIC", "ELIGIBLE", "POLL",
  "NETWORKS", "HIDDEN", "VIRTUAL", "LINK", "ONLY", "RX", "BUFFER", "LARGE",
  "NORMAL", "STUBNET", "TAG", "EXTERNAL", "LSADB", "ECMP", "WEIGHT",
  "NSSA", "TRANSLATOR", "STABILITY", "GLOBAL", "LSID", "INSTANCE", "REAL",
  "NETMASK", "TX", "TOPOLOGY", "STATE", "PIPE", "PEER", "MODE", "OPAQUE",
  "TRANSPARENT", "RIP", "INFINITY", "PERIOD", "GARBAGE", "MULTICAST",
  "QUIET", "NOLISTEN", "VERSION1", "PLAINTEXT", "MD5", "HONOR", "NEVER",
  "ALWAYS", "RIP_METRIC", "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH",
  "BLACKHOLE", "UNREACHABLE", "';'", "'('", "')'", "':'", "'{'", "'}'",
  "','", "'?'", "'['", "']'", "$accept", "config", "conf_entries",
  "definition", "expr", "bool", "ipa", "ipa_scope", "prefix",
  "prefix_or_ipa", "pxlen", "datetime", "text_or_none", "log_config",
  "syslog_name", "log_file", "log_mask", "log_mask_list", "log_cat",
  "mrtdump_base", "timeformat_which", "timeformat_spec", "timeformat_base",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM",
  "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_CHECK", "cmd_DOWN", "cfg_name",
  "cfg_timeout", "kern_proto_start", "kern_item", "kif_proto_start",
  "kif_item", "kern_sys_item", "rtrid", "idval", "listen", "listen_opts",
  "listen_opt", "tab_sorted", "newtab", "roa_table_start",
  "roa_table_opts", "roa_table", "proto_start", "proto_name", "proto_item",
  "imexport", "limit_action", "limit_spec", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "iface_patt_init", "iface_patt",
  "tos", "dev_proto_start", "dev_proto", "dev_iface_init",
  "dev_iface_patt", "debug_mask", "debug_list", "debug_flag",
  "mrtdump_mask", "mrtdump_list", "mrtdump_flag", "password_list",
  "password_items", "password_item", "password_item_begin",
  "password_item_params", "cmd_SHOW_STATUS", "cmd_SHOW_MEMORY",
  "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL", "optsym",
  "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE",
  "r_args", "export_or_preexport", "cmd_SHOW_ROA", "roa_args", "roa_mode",
  "cmd_SHOW_SYMBOLS", "sym_args", "roa_table_arg", "cmd_ADD_ROA",
  "cmd_DELETE_ROA", "cmd_FLUSH_ROA", "cmd_DUMP_RESOURCES",
  "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS",
  "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS",
  "cmd_EVAL", "cmd_ECHO", "echo_mask", "echo_size", "cmd_DISABLE",
  "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD", "cmd_RELOAD_IN",
  "cmd_RELOAD_OUT", "cmd_DEBUG", "cmd_MRTDUMP", "cmd_RESTRICT",
  "proto_patt", "proto_patt2", "filter_def", "$@1", "filter_eval", "type",
  "one_decl", "decls", "declsn", "filter_body", "filter", "where_filter",
  "function_params", "function_body", "function_def", "$@2", "cmds",
  "cmds_int", "block", "fipa", "set_atom", "switch_atom", "pair_expr",
  "pair_atom", "pair_item", "ec_expr", "ec_kind", "ec_item", "set_item",
  "switch_item", "set_items", "switch_items", "fprefix_s", "fprefix",
  "fprefix_set", "switch_body", "bgp_path_expr", "bgp_path",
  "bgp_path_tail1", "bgp_path_tail2", "constant", "constructor", "rtadot",
  "function_call", "symbol", "static_attr", "term", "break_command",
  "print_one", "print_list", "var_listn", "var_list", "cmd",
  "bgp_proto_start", "bgp_proto", "ospf_proto_start", "ospf_proto",
  "ospf_proto_item", "ospf_area_start", "ospf_area", "ospf_area_opts",
  "ospf_area_item", "$@3", "$@4", "ospf_stubnet", "ospf_stubnet_start",
  "ospf_stubnet_opts", "ospf_stubnet_item", "ospf_vlink",
  "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_base", "pref_opt",
  "nbma_list", "nbma_eligible", "nbma_item", "ospf_iface_start",
  "ospf_instance_id", "ospf_iface_opts", "ospf_iface_opt_list",
  "ospf_iface", "opttext", "cmd_SHOW_OSPF", "cmd_SHOW_OSPF_NEIGHBORS",
  "cmd_SHOW_OSPF_INTERFACE", "cmd_SHOW_OSPF_TOPOLOGY",
  "cmd_SHOW_OSPF_TOPOLOGY_ALL", "cmd_SHOW_OSPF_STATE",
  "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB", "lsadb_args",
  "pipe_proto_start", "pipe_proto", "rip_cfg_start", "rip_cfg", "rip_auth",
  "rip_mode", "rip_iface_item", "rip_iface_opts", "rip_iface_opt_list",
  "rip_iface_init", "rip_iface", "static_proto_start", "static_proto",
  "stat_route0", "stat_multipath1", "stat_multipath", "stat_route",
  "cmd_SHOW_STATIC", "conf", "cli_cmd", "proto", "kern_proto", "kif_proto",
  "dynamic_attr", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,    43,    45,    42,    47,
      37,    33,    46,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
      59,    40,    41,    58,   123,   125,    44,    63,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   350,   351,   351,   352,   352,   353,   354,   354,   354,
     355,   355,   355,   355,   355,   355,   356,   356,   357,   357,
     358,   359,   359,   360,   360,   361,   362,   362,   363,   364,
     364,   365,   365,   365,   366,   366,   367,   367,   368,   368,
     368,   368,   368,   368,   368,   368,   368,   369,   369,   370,
     370,   370,   370,   371,   371,   371,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   379,   380,   380,   380,   381,
     382,   382,   382,   382,   383,   384,   384,   385,   386,   386,
     387,   387,   387,   388,   389,   389,   390,   390,   390,   390,
     391,   391,   392,   393,   394,   394,   395,   395,   396,   396,
     397,   397,   397,   398,   398,   398,   398,   398,   398,   398,
     398,   398,   398,   398,   398,   398,   398,   399,   399,   399,
     399,   400,   400,   400,   400,   400,   401,   401,   402,   403,
     403,   404,   405,   405,   405,   406,   406,   407,   408,   408,
     409,   410,   411,   411,   412,   413,   413,   413,   414,   415,
     416,   416,   416,   417,   417,   418,   418,   418,   418,   418,
     418,   419,   419,   419,   420,   420,   421,   421,   422,   422,
     423,   423,   424,   424,   425,   426,   426,   426,   426,   426,
     426,   427,   428,   429,   430,   431,   431,   432,   433,   434,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   436,   436,   437,   438,   438,   438,   438,
     439,   439,   439,   440,   441,   441,   441,   441,   441,   441,
     441,   441,   442,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   455,   455,   456,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   466,   466,   467,   467,   467,   469,   468,   470,   471,
     471,   471,   471,   471,   471,   471,   471,   471,   471,   471,
     471,   471,   472,   473,   473,   474,   474,   475,   476,   476,
     477,   478,   478,   479,   481,   480,   482,   482,   483,   483,
     484,   484,   485,   486,   486,   486,   486,   487,   487,   487,
     487,   487,   488,   489,   489,   489,   490,   490,   491,   492,
     492,   492,   492,   493,   493,   493,   494,   494,   494,   494,
     495,   495,   495,   495,   496,   496,   497,   497,   498,   499,
     499,   499,   499,   500,   500,   501,   501,   501,   502,   502,
     503,   503,   504,   504,   504,   504,   504,   505,   505,   505,
     506,   506,   506,   506,   506,   506,   506,   506,   506,   506,
     506,   507,   507,   508,   509,   510,   511,   511,   511,   511,
     511,   511,   511,   511,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   513,   513,   513,   513,   513,   513,   514,   515,   515,
     515,   516,   516,   517,   517,   518,   518,   518,   518,   518,
     518,   518,   518,   518,   518,   518,   518,   518,   518,   518,
     518,   519,   520,   520,   520,   520,   520,   520,   520,   520,
     520,   520,   520,   520,   520,   520,   520,   520,   520,   520,
     520,   520,   520,   520,   520,   520,   520,   520,   520,   520,
     520,   520,   520,   520,   520,   520,   520,   520,   520,   520,
     520,   520,   520,   520,   520,   520,   521,   522,   522,   523,
     523,   523,   523,   523,   523,   523,   524,   525,   526,   526,
     527,   527,   527,   527,   527,   527,   527,   527,   527,   528,
     527,   529,   527,   527,   527,   527,   530,   530,   531,   532,
     532,   533,   533,   533,   534,   534,   535,   535,   536,   536,
     536,   536,   536,   536,   536,   536,   536,   536,   536,   537,
     538,   538,   538,   538,   538,   538,   538,   538,   538,   538,
     538,   538,   538,   538,   538,   538,   538,   538,   538,   538,
     538,   538,   538,   538,   538,   538,   538,   538,   538,   538,
     538,   538,   538,   538,   538,   539,   539,   540,   541,   542,
     542,   542,   543,   543,   544,   544,   545,   546,   547,   547,
     548,   548,   549,   549,   550,   551,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   560,   560,   560,   560,
     560,   560,   560,   560,   561,   562,   562,   562,   562,   562,
     563,   564,   564,   564,   564,   564,   564,   564,   564,   564,
     564,   564,   564,   564,   565,   565,   565,   566,   566,   566,
     566,   566,   567,   567,   567,   567,   567,   567,   567,   568,
     568,   569,   569,   570,   571,   572,   573,   573,   573,   573,
     573,   574,   575,   575,   576,   576,   577,   577,   577,   577,
     577,   577,   577,   577,   577,   578,   579,   579,   579,   579,
     579,   579,   579,   579,   579,   579,   579,   579,   579,   579,
     580,   580,   580,   580,   580,   580,   580,   580,   580,   580,
     580,   580,   580,   580,   580,   580,   580,   580,   580,   580,
     580,   580,   580,   580,   580,   580,   580,   580,   580,   580,
     580,   580,   580,   580,   580,   580,   580,   580,   580,   580,
     580,   580,   580,   580,   580,   581,   581,   581,   581,   581,
     581,   581,   581,   582,   582,   582,   582,   583,   583,   583,
     584,   584,   584,   584,   584,   584,   584,   584,   584,   584,
     584,   584,   584,   584,   584,   584,   584,   584,   584,   584,
     584,   584,   584
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       1,     1,     1,     1,     1,     0,     1,     1,     0,     2,
       2,     1,     1,     2,     2,     1,     1,     0,     4,     2,
       0,     1,     2,     1,     1,     3,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     3,     1,
       1,     1,     1,     2,     4,     3,     3,     3,     4,     5,
       3,     3,     4,     2,     0,     1,     0,     1,     2,     2,
       2,     3,     2,     3,     2,     3,     3,     3,     4,     5,
       1,     1,     1,     4,     0,     2,     2,     2,     1,     1,
       0,     1,     3,     3,     0,     8,     1,     4,     1,     1,
       0,     1,     3,     0,     2,     2,     2,     2,     2,     2,
       3,     3,     3,     4,     2,     3,     2,     2,     1,     1,
       1,     0,     2,     2,     2,     2,     2,     1,     1,     3,
       3,     0,     1,     1,     2,     0,     1,     3,     1,     3,
       0,     2,     2,     2,     2,     3,     3,     3,     0,     3,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     1,     1,     4,     1,
       0,     3,     4,     1,     2,     0,     5,     5,     5,     5,
       4,     3,     3,     4,     5,     1,     0,     3,     4,     4,
       0,     2,     3,     3,     3,     2,     2,     2,     2,     3,
       3,     2,     2,     1,     1,     4,     0,     3,     3,     3,
       0,     1,     1,     4,     0,     2,     2,     2,     2,     2,
       2,     2,     0,     2,     9,     9,     4,     3,     3,     3,
       3,     3,     3,     3,     3,     4,     1,     1,     3,     0,
       1,     3,     3,     3,     3,     4,     4,     4,     4,     2,
       1,     1,     1,     1,     0,     1,     0,     4,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     0,     3,     1,     3,     1,     1,     1,
       2,     3,     2,     4,     0,     5,     0,     1,     1,     2,
       1,     3,     1,     1,     1,     1,     1,     1,     3,     1,
       1,     1,     1,     1,     3,     1,     5,    11,     1,     1,
       1,     2,     1,     7,     9,     7,     1,     1,     1,     3,
       1,     1,     1,     3,     1,     3,     1,     3,     3,     1,
       2,     2,     6,     1,     3,     0,     4,     3,     1,     3,
       3,     3,     2,     2,     2,     2,     0,     2,     2,     0,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     1,
       1,     5,     7,     0,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     4,
       1,     1,     1,     1,     2,     2,     3,     3,     6,     3,
       3,     3,     3,     5,     6,     6,     6,     6,     4,     8,
       4,     1,     1,     1,     1,     1,     1,     1,     0,     1,
       3,     1,     3,     0,     1,     4,     6,     4,     3,     5,
       5,     4,     6,     3,     2,     5,     5,     8,     8,     8,
       8,     2,     3,     3,     5,     6,     7,     6,     4,     4,
       5,     6,     6,     5,     3,     4,     5,     5,     5,     5,
       5,     4,     4,     5,     5,     5,     5,     5,     5,     5,
       5,     6,     6,     8,     6,     6,     5,     4,     5,     4,
       5,     4,     5,     4,     5,     5,     2,     3,     3,     1,
       2,     3,     2,     4,     2,     1,     2,     4,     0,     3,
       2,     1,     2,     3,     3,     3,     3,     2,     3,     0,
       5,     0,     5,     2,     2,     1,     4,     1,     1,     0,
       3,     2,     2,     2,     5,     2,     0,     3,     0,     2,
       2,     3,     2,     2,     3,     2,     2,     2,     1,     3,
       2,     2,     2,     2,     2,     2,     3,     2,     2,     2,
       2,     2,     2,     2,     2,     3,     3,     3,     2,     3,
       2,     3,     3,     4,     2,     2,     2,     3,     3,     3,
       2,     3,     3,     4,     1,     0,     2,     3,     1,     0,
       1,     2,     0,     2,     0,     1,     3,     0,     0,     2,
       0,     3,     0,     3,     4,     1,     0,     4,     6,     6,
       6,     7,     6,     7,     5,     0,     2,     3,     2,     3,
       3,     2,     3,     2,     2,     3,     3,     5,     4,     4,
       2,     3,     3,     4,     4,     4,     5,     5,     4,     3,
       4,     4,     4,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     2,     2,     2,     3,     3,     4,     0,
       3,     0,     3,     0,     3,     2,     3,     3,     5,     5,
       3,     2,     3,     3,     1,     2,     4,     3,     3,     3,
       2,     2,     2,     2,     2,     4,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     2,     2,     2,
       2,     2,     2,     3,     3,     3,     3,     3,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    64,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   363,     0,     0,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,     3,     1,     2,     0,     0,
       0,     0,     0,     0,    98,    99,     0,     0,     0,     0,
     363,     0,   676,   677,   678,   679,   680,   100,   100,   681,
     682,   683,    96,   684,     0,   686,   100,   103,   687,   688,
     689,   100,   103,   100,   103,   100,   103,   100,   103,   100,
     103,     5,   685,   103,   103,   250,   252,   251,     0,    65,
      64,     0,     0,    64,    66,    63,     0,     0,   222,     0,
       0,     0,     0,   249,   254,     0,   206,     0,     0,   190,
     214,   186,   186,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   346,   350,   359,   356,   292,   365,   353,     0,
       0,   349,   363,   393,     0,     0,     0,   351,   352,     0,
       0,     0,   363,     0,   354,   355,   360,   391,   392,     0,
     390,     0,   237,   236,     0,   239,     0,     0,    31,    30,
      33,     0,     0,     0,    52,    51,    50,    49,     0,     0,
      90,     0,   256,     0,    84,     0,     0,   258,   284,   101,
       0,     0,    94,    69,    74,   144,   441,   486,   614,   620,
     655,     0,     0,     0,     0,     0,    15,   148,     0,     0,
       0,     0,     0,   737,     0,     0,     0,     0,     0,     0,
      15,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    15,     0,
       0,     0,     0,     0,     0,     0,     0,    15,   738,     0,
       0,     0,    15,     0,     0,    15,   739,   489,     0,     0,
     495,     0,     0,     0,   740,     0,     0,     0,   653,     0,
       0,     0,     0,     0,     0,     0,     0,   741,     0,     0,
     169,   173,     0,     0,     0,     0,   742,     0,     0,     0,
       0,    15,     0,    15,     0,   735,     0,     0,     0,     0,
      27,   736,     0,     0,   151,   150,     0,     0,    66,    60,
      61,     0,    67,     0,   243,   241,     0,     0,     0,     0,
     244,   162,   161,     0,     0,   253,   255,   254,     0,   187,
       0,   210,   182,   181,     0,     0,   185,   186,   186,   605,
     186,   186,     0,     0,    16,    17,     0,     0,     0,   232,
     233,   229,   227,   228,   230,   231,   346,   365,   346,   363,
     346,   346,     0,   338,     0,   363,     0,     0,     0,   349,
     349,     0,   388,   363,   363,   363,   363,   363,     0,   309,
     310,     0,   312,     0,     0,     7,   296,   294,     9,   363,
     293,   295,   318,   316,   317,   324,     0,   329,   333,     0,
     755,   750,   751,   752,   753,   366,   754,   367,   368,   369,
     370,   371,   372,   373,   757,   760,   759,   756,   758,   761,
     762,   763,   766,   764,   765,   767,   768,   769,   770,   771,
     772,   394,   395,   234,   363,   363,   363,   363,   363,   363,
     363,   363,   363,   363,   363,   363,   363,     0,    38,    39,
      40,    41,    42,    43,    44,    45,    46,     0,    36,   240,
       0,   242,   363,     0,    32,    34,     0,     0,   129,   363,
     130,    53,     0,    57,    91,    92,    80,    81,    82,   140,
       0,   273,    93,     0,    48,     0,     0,     0,   743,   747,
       0,   145,   106,   128,   114,     0,   104,    11,    13,    12,
      14,    10,   105,   131,   119,   273,   120,     0,     0,   363,
     108,   118,     0,   109,     0,   116,   107,   146,   147,   442,
       0,     0,     0,     0,     0,     0,     0,    15,     0,     0,
       0,    18,     0,     0,     0,   454,     0,     0,     0,     0,
       0,    15,     0,     0,     0,     0,    15,     0,    15,     0,
      15,     0,    15,     0,     0,    15,    15,    15,     0,   443,
     487,   496,   490,    15,   494,   492,   488,   498,   615,     0,
       0,     0,   616,   621,     0,   131,     0,   174,     0,   170,
     636,   634,   635,     0,     0,     0,     0,     0,     0,     0,
     622,   629,   175,   656,    15,   661,     0,   657,   671,     0,
     670,     0,   674,     0,   672,   673,   660,     0,    70,     0,
      72,    15,   745,   746,   744,     0,    26,     0,   749,   748,
     156,   155,   157,   159,   160,   158,     0,   153,   247,     0,
      62,    68,    58,   223,   226,   245,   246,   166,   167,     0,
     164,   248,     0,   183,   188,   205,     0,   212,   211,     0,
       0,   189,   196,     0,     0,   204,   273,   198,   197,   201,
     202,     0,   203,   191,     0,   195,   213,   221,   215,   218,
     219,   217,   220,   216,   596,   596,     0,   186,   596,   186,
     596,   597,   675,     0,     0,    20,     0,     0,   342,   343,
       0,   344,   345,   340,   328,   421,   424,     0,   401,     0,
     402,   347,   348,   341,     0,     0,     0,     0,     0,     0,
     311,   363,   374,   363,   305,   303,     0,     0,   302,     0,
       0,   357,   330,   331,     0,     0,   358,   386,   384,   382,
     379,   380,   381,   383,   385,   387,   375,   376,   377,   378,
     396,     0,   397,   399,   400,   238,     0,   235,     0,    29,
       0,    28,     0,     0,    55,    56,   131,     0,    78,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,     0,     0,     0,   257,   277,    88,    89,     0,     0,
      83,    85,    47,     0,   273,   102,     0,    97,   115,   135,
     138,   149,   278,   279,   117,   127,   121,   111,    15,   280,
     112,   110,     0,     0,    15,   479,   481,     0,    15,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   455,     0,
       0,     0,     0,     0,     0,     0,   448,     0,   449,     0,
     477,     0,     0,     0,     0,     0,     0,     0,   461,   462,
       0,     0,     0,   483,   491,     0,     0,     0,   618,   619,
       0,   651,   633,   624,     0,     0,   628,   623,   625,     0,
     631,   632,   630,     0,     0,     0,     0,     0,     0,   667,
      18,   669,     0,   664,   668,    77,    71,    73,    75,    22,
      21,    76,   152,     0,    59,   163,     0,   184,   209,   208,
     207,   193,   200,   194,   192,   199,   595,     0,     0,   604,
     613,     0,   611,     0,     0,   608,   606,     0,   596,     0,
     596,     0,    23,    24,     0,     0,   339,   363,   410,     0,
     363,   363,   363,   389,   363,   408,   363,     0,     0,   363,
     363,   363,     8,   292,   319,   325,     0,     0,   334,   363,
      37,     6,    35,    54,   141,    79,   272,   271,   273,   363,
      86,    87,   282,   275,     0,   285,     0,   136,     0,   131,
       0,   126,   113,     0,     0,     0,   480,     0,   476,   470,
     444,     0,    19,     0,   450,     0,   453,     0,   457,   456,
     469,   468,   463,     0,     0,   478,   466,   458,   459,   460,
     482,   484,   465,   464,   485,   467,   493,   587,    15,     0,
      15,   509,     0,     0,   511,   501,    15,   497,     0,   515,
     588,   617,   627,   649,   654,   168,   170,   626,     0,     0,
       0,     0,     0,   172,   658,   659,   666,    18,     0,   665,
     154,   165,   599,   598,   612,   607,   609,   610,     0,   600,
       0,   602,     0,     0,   422,   403,     0,     0,     0,     0,
       0,   363,   361,   304,   302,     0,     0,   308,     0,     0,
     274,     0,   414,     0,   415,   416,     0,   363,   412,   413,
     411,   363,   363,     0,   363,     0,     0,   363,   288,     0,
     281,     0,   132,   133,   137,   139,   122,   123,   124,   125,
     472,     0,   474,   475,   445,     0,   452,   451,   471,   447,
     131,   514,   502,     0,     0,    15,     0,   500,     0,     0,
     518,   513,   517,     0,     0,   507,   499,     0,   525,   642,
     171,   175,    25,     0,     0,     0,     0,   662,   663,   601,
     603,   222,   222,   407,   405,   406,   404,   363,     0,   306,
     363,     0,   398,   363,   363,   363,   363,     0,     0,     0,
     283,   289,     0,     0,   434,   417,   419,     0,   276,     0,
     134,     0,   446,   588,   504,   505,   503,   506,   575,   539,
     519,   575,   508,   589,   526,     0,     0,     0,     0,   652,
       0,   180,   175,   175,   175,   175,     0,     0,     0,   362,
       0,     0,     0,   332,     0,     0,     0,     0,   428,   363,
     335,   363,   363,     0,   363,   433,     0,   473,   592,     0,
       0,     0,   528,   643,    15,     0,     0,     0,   645,   637,
     638,   639,   640,   641,   644,   650,   176,   177,   178,   179,
     224,   225,   409,   363,   315,   363,   313,   427,   364,   431,
       0,   363,   425,   290,     0,     0,     0,     0,     0,     0,
       0,     0,   420,     0,   590,   594,   510,   578,   576,   579,
      15,     0,    15,   516,     0,   512,     0,     0,     0,     0,
       0,     0,   524,   538,     0,     0,   647,   142,   143,   646,
       0,     0,     0,     0,   363,   363,   297,   301,   299,   363,
     435,   300,   322,   320,   321,   326,     0,   430,   429,   363,
     363,   363,   363,   436,    95,     0,   580,     0,     0,   522,
     523,   521,   520,   532,   530,   529,     0,     0,   533,   535,
     536,   537,   527,   648,   363,   314,   432,   291,   426,   337,
     302,     0,   363,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    15,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   593,   574,
       0,   581,   577,   531,   534,     0,   298,   363,   323,   336,
     327,     0,     0,     0,     0,    15,   582,   544,    15,   560,
     540,   543,   541,     0,   558,     0,   545,   547,   548,   549,
     550,   551,   552,   553,   554,    15,   564,   565,   566,    15,
     542,     0,     0,    15,     0,   570,   591,   307,     0,   440,
     438,   439,   437,   561,     0,     0,   572,   557,   546,   556,
     559,   567,   568,   569,   562,   555,   571,   584,   563,   583,
     573,   585,     0,   586
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    83,   521,   522,   366,   834,   900,   901,
     705,  1143,   637,    84,   484,   191,   487,   477,   478,    85,
     198,   199,    86,    20,    21,    22,    23,    24,    25,   124,
     333,    87,   316,    88,   322,   317,    89,   500,    90,   503,
     801,   495,    91,    92,   510,    93,    94,   210,   234,   530,
     981,   817,   514,    95,   809,  1104,   978,   810,   811,   776,
     777,  1238,    96,    97,   523,   235,   327,   646,   647,   344,
     659,   660,   299,   874,   300,   301,   886,    26,    27,    28,
      29,   362,    30,    31,    32,   354,   684,    33,   351,   670,
      34,   355,   337,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,   185,   480,    47,    48,    49,
      50,    51,    52,    53,    54,    55,   118,   348,    98,   501,
      99,   791,   792,   793,   974,   813,   814,   531,   804,   795,
     100,   506,  1093,  1094,  1262,   174,   412,  1312,   735,   736,
     413,  1076,   737,   414,   415,  1315,   416,  1316,   175,   418,
     419,  1264,   381,   176,   382,   391,   177,   178,   179,  1096,
     180,   451,  1074,  1097,  1176,  1177,   716,   717,  1098,   101,
     102,   103,   104,   278,   279,   280,   866,  1028,  1128,  1133,
    1131,  1132,  1230,  1284,  1029,  1232,  1294,  1030,  1380,  1229,
    1278,  1279,  1328,  1434,  1452,  1449,  1120,  1138,  1325,  1275,
    1121,   917,    56,    57,    58,    59,    60,    61,    62,    63,
     696,   105,   106,   107,   108,   603,  1244,  1200,  1139,  1034,
     595,   596,   109,   110,   308,   893,   894,   309,    64,   111,
      65,   112,   113,   114,   452
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1144
static const yytype_int16 yypact[] =
{
      69,  2358,    48,   601,   618,   859,   110,   618,   618,     6,
     670,   618,   180,   410,    98,   198,   708,  1345,    70,   618,
   -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144,
   -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144,
   -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144,
   -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144,
   -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144,   316,   382,
     314,   378,   331,   298, -1144, -1144,   369,   337,   333,    91,
    1345,   451, -1144, -1144, -1144, -1144, -1144,   455,   455, -1144,
   -1144, -1144,   150, -1144,   531, -1144,   455,  2233, -1144, -1144,
   -1144,   455,  2031,   455,  1886,   455,  2053,   455,  1870,   455,
    2213, -1144, -1144,  1849,  2171, -1144, -1144, -1144,    84, -1144,
     490,   523,   528,   490,   483, -1144,   549,   566,   505,   618,
     618,   581,    87, -1144,   631,    38, -1144,   591,   614, -1144,
   -1144,   399,   636,   142,   142,   654,   658,   669,   675,   698,
     703,   706,    18, -1144, -1144, -1144,   688,   403, -1144,   560,
      -2,     5,  1345, -1144,   422,   425,   449, -1144, -1144,   452,
     463,   471,   814,   125, -1144, -1144, -1144, -1144, -1144,  1835,
   -1144,  2501, -1144, -1144,  1252,   712,   773,   729, -1144,   744,
   -1144,    17,    84,     0, -1144, -1144, -1144, -1144,   119,   482,
     690,   626, -1144,   809, -1144,   497,    87,  2527, -1144,   739,
     498,   514, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144,
   -1144,   527,    84,   856,   800,     0,   166, -1144,   488,   427,
     787,   860,    87, -1144,   541,   555,   539,    19,   680,   896,
     166,   830,   -53,   801,    85,   142,   861,   720,   863,    23,
     732,   727,   424,   724,   734,   460,   721,   716,   166,   719,
     722,   714,   101,   -43,   747,   710,   692,   166, -1144,   633,
     632,   652,   166,   899,     0,   166, -1144, -1144,   637,   634,
   -1144,   635,   909,   385, -1144,   643,   659,   929, -1144,   984,
       0,   662,   -38,     0,     0,   940,   -79, -1144,   691,   700,
   -1144,   665,   666,   723,   142,   968, -1144,   704,   548,   707,
     970,   166,   978,   166,   976, -1144,   709,   717,   725,   985,
    1031, -1144,   726,   731, -1144, -1144,   910,  1053,   483, -1144,
   -1144,  1056,     0,  1059, -1144, -1144,  1044,  1061,  1064,  1066,
   -1144, -1144, -1144,   172,  1074, -1144, -1144,   705,  1075, -1144,
    1076,   398, -1144, -1144,  2340,   982, -1144,   636,   636, -1144,
     341,   435,  1078,  1079, -1144, -1144,    53,   971,   979, -1144,
   -1144, -1144, -1144, -1144, -1144, -1144,    18, -1144,    18,  1345,
      18,    18,  1069, -1144,  1070,   931,  1077,   902,  1089,     5,
       5,  1073,  1072,  1345,  1345,  1345,  1345,  1345,  1086, -1144,
   -1144,  1091, -1144,   777,   218, -1144, -1144, -1144, -1144,   790,
   -1144, -1144,  1117, -1144, -1144, -1144,    37,    63, -1144,   213,
   -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144,
   -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144,
   -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144,
   -1144, -1144, -1144, -1144,  1345,  1345,  1345,  1345,  1345,  1345,
    1345,  1345,  1345,  1345,  1345,  1345,  1345,   677, -1144, -1144,
   -1144, -1144, -1144, -1144, -1144, -1144, -1144,   386, -1144, -1144,
    1123, -1144,  1345,  1107, -1144, -1144,  1252,   788, -1144,  1345,
   -1144,     0,   642, -1144, -1144, -1144, -1144, -1144, -1144, -1144,
     792,   950, -1144,   358, -1144,   794,   795,  1116, -1144, -1144,
     -67, -1144, -1144, -1144, -1144,   652, -1144, -1144, -1144, -1144,
   -1144, -1144, -1144, -1144, -1144,  2308, -1144,   270,  1039,  1345,
   -1144, -1144,   270, -1144,   270, -1144, -1144, -1144, -1144, -1144,
    1085,  1087,  1093,   802,   805,     0,   916,   166,   142,     0,
     938,  1134,     0,  1098,     0, -1144,   827,  1101,   -14,     0,
       0,   166,  1102,   838,  1105,   844,   166,   846,   166,    49,
     166,   856,   166,   848,   849,   166,   166,   166,   852, -1144,
   -1144, -1144, -1144,   166, -1144,  1094, -1144, -1144, -1144,  1174,
     862,   866, -1144, -1144,     0, -1144,   876, -1144,   877,  1104,
   -1144, -1144, -1144,   879,   881,   884,     0,   885,   889,   892,
   -1144, -1144,   474, -1144,   166, -1144,   856, -1144, -1144,   579,
   -1144,   142, -1144,   991, -1144, -1144, -1144,     0, -1144,     0,
   -1144,   166, -1144, -1144, -1144,     0, -1144,   142, -1144, -1144,
   -1144, -1144, -1144, -1144, -1144, -1144,   396, -1144, -1144,  1217,
   -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144,   402,
   -1144, -1144,  1230, -1144, -1144, -1144,  1215, -1144, -1144,  1220,
     142, -1144, -1144,  1218,  1221, -1144,  2308, -1144, -1144, -1144,
   -1144,   142, -1144, -1144,  1228, -1144, -1144, -1144, -1144, -1144,
   -1144, -1144, -1144, -1144,  1229,  1229,   552,   636,  1229,   636,
    1229, -1144, -1144,     0,   142, -1144,  1233,  1235, -1144, -1144,
     711, -1144, -1144, -1144, -1144,   106, -1144,   914, -1144,  1224,
   -1144, -1144, -1144, -1144,   247,   272,   299,   745,   477,   122,
   -1144,  1345, -1144,  1345, -1144,  1251,   918,   923,   880,   132,
     200, -1144, -1144, -1144,  1245,  1244, -1144,  2538,  2538,  2538,
    2563,  2563,  2538,  2538,  2538,  2538,   544,   544,  1072,  1072,
   -1144,   933, -1144, -1144, -1144, -1144,  1252, -1144,  1729, -1144,
     450, -1144,   880,  1255, -1144, -1144, -1144,   936, -1144, -1144,
   -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144,
   -1144,    45,   937,   934, -1144, -1144, -1144, -1144,   142,     0,
   -1144, -1144, -1144,  1866,   950, -1144,   142, -1144, -1144,  1253,
   -1144,   935, -1144, -1144, -1144, -1144,  1190, -1144,   166,  2527,
   -1144, -1144,     0,     0,   166, -1144, -1144,   943,   166,   946,
     948,   949,     0,  1271,  1088,   967,     0,   969, -1144,     0,
     980,   981,   983,   986,   990,     0, -1144,   652, -1144,   992,
   -1144,   999,  1000,  1001,  1002,  1003,  1008,  1011, -1144, -1144,
    1013,  1014,  1015, -1144, -1144,     0,  2112,  1016, -1144, -1144,
    1017,   137, -1144, -1144,   963,  1019, -1144, -1144, -1144,  1026,
   -1144, -1144, -1144,     0,   359,   510,   965,  1029,  1033, -1144,
    1134, -1144,   142,  1025,   991, -1144, -1144, -1144, -1144,    53,
   -1144, -1144, -1144,   910, -1144, -1144,   172, -1144, -1144, -1144,
   -1144, -1144, -1144, -1144, -1144, -1144, -1144,  1316,  1319, -1144,
   -1144,   652, -1144,   652,  1335, -1144, -1144,   652,  1229,  1372,
    1229,  1374, -1144, -1144,  1176,  1177, -1144,  1345, -1144,  1354,
    1345,  1345,  1345, -1144,  1345, -1144,  1345,   511,  1010,  1345,
    1226,  1345, -1144, -1144, -1144, -1144,  1036,   688, -1144,  1345,
   -1144, -1144, -1144, -1144,   935, -1144, -1144, -1144,   950,   627,
   -1144, -1144, -1144,  1043,  1045, -1144,  1270, -1144,   845, -1144,
     754, -1144, -1144,  1046,  1042,  1049, -1144,  1050, -1144, -1144,
   -1144,  1057, -1144,     0, -1144,  1060, -1144,  1081, -1144, -1144,
   -1144, -1144, -1144,  1082,  1083, -1144, -1144, -1144, -1144, -1144,
   -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144,   166,   348,
      65, -1144,  1109,   142, -1144, -1144,   156, -1144,  1090, -1144,
    1110, -1144, -1144, -1144, -1144, -1144,  1104, -1144,  1097,  1376,
    1376,  1376,  1376, -1144, -1144, -1144, -1144,  1134,     0,  1025,
   -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144,  1396, -1144,
    1410, -1144,  1399,  1401, -1144, -1144,  1148,  1186,  1383,  1424,
     597,  1345, -1144, -1144,  2527,  1084,  1092,  2527,  1403,  1456,
   -1144,     1, -1144,  1405, -1144, -1144,  1100,  1345, -1144, -1144,
   -1144,  1345,  1345,  1099,    12,  1835,  1103,  1298, -1144,   950,
   -1144,  1413,   142, -1144, -1144, -1144, -1144, -1144, -1144, -1144,
   -1144,     0, -1144, -1144, -1144,  1114, -1144, -1144, -1144, -1144,
   -1144, -1144, -1144,     0,     0,   166,     0, -1144,  1111,   652,
   -1144, -1144,  1113,  1118,     0, -1144, -1144,     0,  1119,   475,
   -1144,   474, -1144,  1121,  1129,  1130,  1131, -1144, -1144, -1144,
   -1144,   505,   505, -1144, -1144, -1144, -1144,  1345,  1522,  1422,
    1318,  1127, -1144,  1345,   931,  1345, -1144,  1759,  2322,    43,
   -1144, -1144,  1420,   404, -1144,  2527,  1112,  1133, -1144,  1242,
   -1144,  1136, -1144,    89, -1144, -1144, -1144, -1144, -1144, -1144,
   -1144, -1144, -1144, -1144, -1144,     0,  1222,   -58,   357, -1144,
    1151, -1144,   474,   474,   474,   474,  1490,  1494,  1553, -1144,
    1158,  1156,     7, -1144,  1784,  1159,  1809,  1825, -1144,  1828,
   -1144,  1345,  1345,   441,  1298, -1144,  1485, -1144,  1160,     3,
     291,    26,   491, -1144,    72,     0,     0,     0, -1144, -1144,
   -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144,
   -1144, -1144, -1144,  1345, -1144,  1345, -1144, -1144, -1144, -1144,
    1161,   627,  1328, -1144,    44,  1834,  1859,  1164,  1165,  1166,
    1167,  1170, -1144,  1171, -1144, -1144, -1144, -1144, -1144,   -13,
     166,     0,   166, -1144,  1173, -1144,     0,     0,     0,  1296,
     318,   -63, -1144, -1144,  1175,  1225, -1144, -1144, -1144, -1144,
    1178,  1181,  1179,  1172,  1828,    79, -1144, -1144, -1144,   790,
   -1144, -1144,  1513, -1144, -1144, -1144,   245, -1144, -1144,  1345,
    1345,  1345,  1345, -1144, -1144,  2120, -1144,     0,  1185, -1144,
   -1144, -1144, -1144, -1144, -1144, -1144,     0,     0, -1144, -1144,
   -1144, -1144, -1144, -1144,  1345, -1144, -1144, -1144, -1144, -1144,
    1578,   189,    79,   248,  1603,  1645,  1672,  1704,  1234,  1183,
       0,  1274,   166,     0,     0,     0,  1317,     0,   351,   748,
    1227,    86,  1260,     0,  1246,  1237,  1267,   239, -1144, -1144,
    1212, -1144, -1144, -1144, -1144,  1211, -1144,  1345, -1144, -1144,
   -1144,  1216,  1219,  1231,  1232,   166, -1144, -1144,   143, -1144,
   -1144, -1144, -1144,     0, -1144,     0, -1144, -1144, -1144, -1144,
   -1144, -1144, -1144, -1144, -1144,   166, -1144, -1144, -1144,   166,
   -1144,    59,     0,   166,     0, -1144, -1144, -1144,  1578, -1144,
   -1144, -1144, -1144, -1144,    -6,  1262, -1144, -1144, -1144, -1144,
   -1144, -1144, -1144, -1144, -1144, -1144, -1144,  1273, -1144, -1144,
   -1144, -1144,  1243, -1144
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1144, -1144, -1144, -1144,  -137,  -232,  -228,  -858,  -141,  -672,
   -1144,  -127, -1144, -1144, -1144, -1144, -1144,  1071,   803, -1144,
   -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144,   543,
    1238, -1144, -1144, -1144, -1144, -1144, -1144,  -267, -1144, -1144,
   -1144, -1144, -1144, -1144, -1144, -1144, -1144,   988,  1157,  1329,
   -1144,    99,  -213, -1144, -1144, -1144, -1144,   589,  -588, -1144,
   -1144,   193, -1144, -1144, -1144, -1144,   241, -1144,   681,   -80,
   -1144,   667, -1139,   556,  -586, -1144,  -306, -1144, -1144, -1144,
   -1144,  -136, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144,
   -1144, -1144,  -327, -1144, -1144, -1144, -1144, -1144, -1144, -1144,
   -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144,
   -1144, -1144, -1144, -1144, -1144, -1144,   546,  1247, -1144, -1144,
   -1144, -1144,  -769,   623,   494,  1095,   919,  1254, -1144,   793,
   -1144, -1144,  -894, -1144,   294,  -172,   870,   265,  -939,   649,
   -1143, -1006,  1445, -1066,   878,   266, -1144, -1144,  -168,   875,
   -1144, -1144, -1144, -1144,   557,   479, -1144, -1144,  -958, -1144,
     115,   526,   -17, -1144, -1144,   400,   685,   459,  -900, -1144,
   -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144,
   -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144,   442,
   -1144, -1144, -1144, -1144, -1144, -1144, -1144,   453, -1144, -1144,
   -1144,  -382, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144,
   -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144, -1144,
   -1144, -1144, -1144, -1144, -1144,   740, -1144, -1144, -1144, -1144,
   -1144, -1144, -1144, -1144,  -949
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -424
static const yytype_int16 yytable[] =
{
     181,   411,   367,   368,   581,   417,   363,   871,   544,   914,
    1073,  1095,  1447,   875,  1255,   405,   550,   551,  -287,   408,
     389,   364,   365,  1163,  1339,   387,   567,  -287,  -287,  -287,
    -287,  1081,  1046,   376,   973,   578,   410,   377,   405,   573,
     582,   349,   408,   585,   364,   365,   378,   806,    66,   600,
    1305,   454,   455,   456,   457,   458,   490,   485,  1082,  1306,
    1307,  1308,   953,   207,   966,   459,   460,   461,   462,   463,
     464,   465,   466,     1,   405,   467,  1235,  1236,   408,   628,
     405,   630,   703,   840,   408,  -286,   546,   405,   516,   742,
     743,   408,  1083,  1293,  -286,  -286,  -286,  -286,  1081,   517,
     518,   519,   520,   364,   365,   182,   517,   518,   519,   520,
     183,   205,   556,   125,   454,   455,   456,   457,   458,   324,
     128,  1313,   341,   607,   325,  1082,   505,   342,   459,   460,
     461,   462,   463,   464,   465,   466,  1095,   584,   467,   491,
     405,   406,   407,   156,   408,   392,  1173,   405,   406,   407,
     953,   408,   536,   598,  1212,   404,   604,   605,   405,  1083,
     364,   365,   408,   615,  1084,  1085,  1086,  1087,  1088,  1089,
    1090,   405,   492,  1416,   571,   408,   350,   517,   518,   519,
     520,   405,   547,   133,  1091,   408,  1379,  1092,   964,  1147,
     517,   518,   519,   520,  1171,   651,   206,   388,  1314,   841,
     517,   518,   519,   520,  1306,  1307,  1308,   953,  1217,   574,
    1313,   967,   143,   683,  1237,   405,   406,   407,   953,   408,
    1340,   694,   695,  1341,   698,   700,   454,   455,   456,   457,
     458,  1084,  1085,  1086,  1087,  1088,  1089,  1090,   540,   541,
     459,   460,   461,   462,   463,   464,   465,   466,   808,  1301,
     467,  1091,   608,   609,  1092,   454,   455,   456,   457,   458,
     657,  1095,   852,  1306,  1307,  1308,   953,   383,  1260,   459,
     460,   461,   462,   463,   464,   465,   466,  1326,   807,   467,
     454,   455,   456,   457,   458,   405,  1327,  1314,   549,   408,
     601,   602,   853,   854,   459,   460,   461,   462,   463,   464,
     465,   466,   658,  1095,   467,   815,  1103,   454,   455,   456,
     457,   458,   144,   918,  1300,   829,   929,   572,   931,  1263,
     830,   459,   460,   461,   462,   463,   464,   465,   466,   844,
     973,   467,  1126,   405,   849,   187,   851,   408,   855,  1448,
     857,   489,  1164,   860,   861,   862,  1095,  1095,  1276,  1256,
     200,   864,   390,  -287,   773,  1441,  1442,  -287,   856,   379,
     356,   486,   710,   555,   489,   380,   405,  1303,   715,  1417,
     408,  1285,  1418,  1235,  1236,   201,   724,   725,   726,   727,
     728,   697,   887,   740,  1295,  1309,   741,  1220,   202,  1310,
     816,   890,   738,   891,  1095,   816,   704,   816,  1137,   897,
     489,   665,   188,   888,  1263,  1385,   489,   744,   827,   899,
     203,  1349,   831,   489,   184,   835,   194,   837,   356,   192,
    -286,   189,   842,   843,  -286,   193,  1222,  1337,   326,  1280,
    1180,   343,   190,   488,   195,   979,  1223,   747,   748,   749,
     750,   751,   752,   753,   754,   755,   756,   757,   758,   759,
     875,   204,   937,   899,   356,  1435,   196,   870,  1389,  1039,
    1405,  1040,  1134,   512,   945,   768,   409,   524,   946,   879,
     208,   666,   772,   489,   209,   699,   933,   796,   797,   798,
     799,  1033,   357,   979,   489,   454,   455,   456,   457,   458,
     895,   383,   896,   383,   212,   383,   383,   489,   898,   459,
     460,   461,   462,   463,   464,   465,   466,   489,   667,   467,
     119,  1424,   819,   525,   526,   134,   135,   197,   532,   454,
     455,   456,   457,   458,   136,   668,   329,  1267,   524,   910,
    1387,   330,  1183,   459,   460,   461,   462,   463,   464,   465,
     466,   409,   137,   467,   332,   358,  1058,   138,  1060,   139,
     140,   883,   334,   126,   127,   919,   131,   132,  1281,   745,
     732,   928,   746,   930,   733,   186,   932,   411,   411,   335,
     970,   920,   465,   466,   525,   526,   467,   417,   336,   527,
    1004,  1282,  1268,  1269,   340,   528,   982,   884,  1352,  1309,
     289,  1353,   985,   940,   352,   213,   987,   364,   365,   889,
     214,   669,   410,   410,    67,   454,   455,   456,   457,   458,
    1041,   489,  1042,   215,   291,  1123,  1124,   353,   941,   459,
     460,   461,   462,   463,   464,   465,   466,   529,   921,   467,
     885,   820,  1239,   821,    68,  1270,  1283,   115,   116,    69,
    1271,   496,    70,   497,   498,   942,  1081,   559,   560,   216,
     345,   346,  1125,    71,  1054,   356,  1055,   369,   117,   489,
    1057,   370,   971,   328,  1047,   976,   331,   496,   141,   497,
     498,   347,   371,  1082,    72,   338,   339,    73,   372,    74,
      75,  1240,  1241,  1242,  1243,   983,   984,    76,   529,   115,
     116,  1195,   489,   563,   564,   991,   774,   775,   800,   995,
     359,   373,   997,   590,   591,   618,   374,  1083,  1003,   375,
     117,  1286,   360,   361,   947,    77,   948,   384,    78,   454,
     455,   456,   457,   458,   345,   346,   499,   479,  1016,  1196,
      79,   765,   766,   459,   460,   461,   462,   463,   464,   465,
     466,   902,   903,   467,   385,   142,  1038,   905,   906,    80,
     899,   482,    81,   454,   455,   456,   457,   458,   619,   386,
    1287,  1288,  1289,   393,  1290,   922,   394,   459,   460,   461,
     462,   463,   464,   465,   466,  1291,   481,   467,   145,  1084,
    1085,  1086,  1087,  1088,  1089,  1090,  1122,  1197,  1127,   217,
     395,   620,  1198,   396,  1135,   962,   766,   129,   130,  1091,
     621,   483,  1092,   152,   397,   153,   154,   155,   156,   157,
     158,   923,   398,   146,   147,   494,   159,   160,   734,   161,
    1199,   162,   493,   944,  1206,  1207,   924,   152,   502,   153,
     154,   155,   156,   157,   158,  1201,  1292,   504,   760,   507,
     159,   160,   508,   161,   925,   162,   218,  1106,  1107,  1108,
    1109,   219,   148,   149,   150,   151,  1115,  1071,   509,   926,
     927,   761,  1189,   364,   365,  1102,   220,   762,   721,   722,
     163,   511,   763,   764,   899,   513,   164,   515,   534,   119,
     535,   537,  1130,   539,   622,   623,   624,   625,   454,   455,
     456,   457,   458,  1186,   163,   538,  1246,  1247,  1248,  1249,
     164,   542,   459,   460,   461,   462,   463,   464,   465,   466,
     120,  1148,   467,  1144,  1145,  1146,   543,   121,   122,   123,
     715,   545,   548,  1066,  1067,  1068,   553,  1069,   552,  1070,
     554,   165,   166,   708,  1077,   709,   557,   711,   712,   558,
     561,    82,  1079,  1157,   152,   577,   153,   154,   155,   156,
     157,   158,   562,   566,   565,   165,   166,   159,   160,   568,
     161,   570,   162,   575,   569,   576,   167,   168,   399,   400,
     401,   402,  -286,   579,  1181,   583,   580,   586,   587,   588,
     640,   169,   589,   592,   170,   686,  1184,  1185,   171,  1187,
     167,   168,   399,   400,   401,   402,   594,  1192,   641,   642,
    1193,   687,  1296,   593,   597,   169,   599,   606,   170,   612,
     613,   163,   171,   643,   644,   614,   645,   164,   454,   455,
     456,   457,   458,  1407,  1408,  1409,  1410,  1411,  1412,  1413,
    1414,   610,   459,   460,   461,   462,   463,   464,   465,   466,
     611,   616,   467,   627,   617,   629,   631,   626,  1329,   632,
    1331,   636,   635,   936,  1158,   688,   648,   633,  1233,   650,
     689,   690,   652,   653,   654,   634,   638,   655,   691,   656,
    1167,   639,   165,   166,  1168,  1169,   211,   661,   663,   664,
    1175,   701,   702,   713,   221,   714,   706,   943,  1277,   236,
    1277,   270,  1311,   281,   707,   286,   692,   302,  1297,  1298,
    1299,   719,   723,   718,   467,   729,   730,   167,   168,   779,
     780,   781,   782,   783,   784,   785,   720,   786,   787,   788,
     789,   790,   169,   731,   739,   170,   767,   769,   771,   171,
    1399,   172,   778,   693,   802,   805,   803,   818,   173,   824,
    1208,   832,   825,  1077,  1330,   826,  1214,   715,  1216,  1333,
    1334,  1335,   822,  1338,   823,   172,   454,   455,   456,   457,
     458,   828,   173,  1433,   833,   836,  1436,   838,   839,   845,
     459,   460,   461,   462,   463,   464,   465,   466,   846,  1311,
     467,  1311,   847,  1439,   848,   865,   850,  1440,   858,   859,
    1381,  1445,   863,   867,   454,   455,   456,   457,   458,  1383,
    1384,   892,   868,   289,  1265,  1266,   869,  1175,   459,   460,
     461,   462,   463,   464,   465,   466,   872,   873,   467,   876,
     904,   877,   952,  1397,   878,   880,  1400,  1401,  1402,   881,
    1404,  1406,   882,   907,   908,   909,  1420,   911,  1077,   152,
     912,   153,   154,   155,   156,   157,   158,   915,   934,   916,
     935,   939,   159,   160,   734,   161,   938,   162,   949,   269,
     956,   277,   957,   285,   950,   298,  1437,   307,  1438,   951,
     318,   323,   172,  -423,   959,   963,   965,   968,   969,   173,
     977,   979,   980,   986,  1443,  1444,   988,  1446,   989,   990,
     992,   993,  1350,   468,   469,   470,   471,   472,   473,   474,
     475,   476,  1354,  1355,  1356,  1357,   163,   994,  1035,   996,
    1043,   152,   164,   153,   154,   155,   156,   157,   158,  1052,
     998,   999,  1053,  1000,   159,   160,  1001,   161,  1048,   162,
    1002,   152,  1005,   153,   154,   155,   156,   157,   158,  1006,
    1007,  1008,  1009,  1010,   159,   160,  1211,   161,  1011,   162,
    1056,  1012,  1072,  1013,  1014,  1015,  1031,  1032,   152,  1036,
     153,   154,   155,   156,   157,   158,  1037,   165,   166,  1044,
    1428,   159,   160,  1045,   161,  1059,   162,  1061,   163,  1062,
    1063,  1065,  1078,  1099,   164,  1101,  1110,  1100,  1111,  1112,
    1113,   454,   455,   456,   457,   458,  1142,  1114,   163,  1149,
    1116,  1129,   167,   168,   164,   459,   460,   461,   462,   463,
     464,   465,   466,  1150,  1151,   467,  1152,   169,  1161,  1137,
     170,  1117,  1118,  1119,   171,   163,  1159,  1165,  1179,  1210,
    1136,   164,   454,   455,   456,   457,   458,  1141,  1160,   165,
     166,  1166,  1221,  1174,  1170,  1226,   459,   460,   461,   462,
     463,   464,   465,   466,  1182,  1188,   467,  1190,  1224,   165,
     166,  1202,  1191,  1194,   454,   455,   456,   457,   458,  1203,
    1204,  1205,  1213,  1225,   167,   168,  1227,  1234,   459,   460,
     461,   462,   463,   464,   465,   466,   165,   166,   467,   169,
    1153,  1245,   170,  1250,   167,   168,   171,  1251,  1254,  1253,
    1273,  1258,  1304,  1302,  1274,  1319,  1320,  1321,  1322,   169,
    1323,  1324,   170,  1332,  1336,  1342,   171,  1347,  1343,  1346,
    1351,   167,   168,  1345,  1344,  1382,  1395,  1396,  1154,  1398,
     454,   455,   456,   457,   458,  1403,   169,  1419,  1415,   170,
    1422,  1421,  1423,   171,   459,   460,   461,   462,   463,   464,
     465,   466,  1426,  1427,   467,  1450,  1429,   770,   533,  1430,
    1451,   454,   455,   456,   457,   458,   649,   172,  1105,   960,
    1425,  1431,  1432,  1051,   173,   459,   460,   461,   462,   463,
     464,   465,   466,  1453,  1050,   467,   454,   455,   456,   457,
     458,  1080,  1140,  1178,   662,   913,   794,   975,  1348,  1075,
     459,   460,   461,   462,   463,   464,   465,   466,   685,   954,
     467,   454,   455,   456,   457,   458,  1388,   403,   955,  1390,
     958,  1172,  1064,  1215,  1272,   459,   460,   461,   462,   463,
     464,   465,   466,  1231,  1049,   467,  1228,     0,  -418,   172,
       0,     0,     0,     0,     0,     0,   173,     0,     0,     0,
       0,     0,     0,   454,   455,   456,   457,   458,     0,   172,
       0,     0,     0,     0,     0,     0,   173,   459,   460,   461,
     462,   463,   464,   465,   466,     0,     0,   467,     0,     0,
     454,   455,   456,   457,   458,     0,   172,     0,     0,     0,
       0,     0,     0,   173,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,     0,     0,     0,     0,     0,
       0,     0,   454,   455,   456,   457,   458,     0,     0,     0,
       0,     0,     0,     0,     0,  1155,   459,   460,   461,   462,
     463,   464,   465,   466,     0,     0,   467,   454,   455,   456,
     457,   458,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   459,   460,   461,   462,   463,   464,   465,   466,     0,
       0,   467,     0,     0,     0,     0,  1156,   454,   455,   456,
     457,   458,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   459,   460,   461,   462,   463,   464,   465,   466,     0,
       0,   467,   454,   455,   456,   457,   458,     0,  1162,     0,
       0,     0,     0,     0,     0,     0,   459,   460,   461,   462,
     463,   464,   465,   466,     0,     0,   467,   454,   455,   456,
     457,   458,     0,     0,     0,     0,     0,     0,     0,     0,
     420,   459,   460,   461,   462,   463,   464,   465,   466,     0,
     420,   467,   454,   455,   456,   457,   458,  1081,     0,     0,
       0,     0,     0,     0,     0,     0,   459,   460,   461,   462,
     463,   464,   465,   466,  1209,     0,   467,   454,   455,   456,
     457,   458,     0,     0,  1082,     0,     0,     0,     0,     0,
       0,   459,   460,   461,   462,   463,   464,   465,   466,     0,
     222,   467,     0,     0,     0,  1252,   421,   422,     0,   423,
     424,     0,     0,     0,     0,     0,   421,   422,  1083,   423,
     424,   222,     0,   310,   311,   312,     0,   313,   314,     0,
    1386,     0,   223,     0,     0,   224,     0,   222,     0,   225,
     226,   287,     0,   228,   229,   425,     0,     0,     0,   230,
       0,     0,     0,   223,     0,  1391,   224,     0,     0,     0,
     225,   226,     0,   288,   228,   229,     0,     0,   426,   223,
     230,     0,   224,     0,     0,     0,   225,   226,   426,   289,
     228,   229,     0,   231,     0,     0,   230,     0,   232,     0,
    1084,  1085,  1086,  1087,  1088,  1089,  1090,  1392,     0,     0,
       0,     0,   290,   291,   231,     0,     0,     0,     0,   232,
    1091,     0,     0,  1092,     0,     0,     0,     0,     0,     0,
     231,     0,     0,     0,  1393,   232,     0,   427,   428,     0,
     429,   430,   431,   432,   433,   779,   780,   781,   782,   783,
     784,   785,     0,   786,   787,   788,   789,   790,     0,     0,
       0,     0,     0,     0,     0,     0,  1394,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,     0,     0,   961,
       0,     0,   222,   443,   444,     0,     0,   237,     0,     0,
       0,     0,     0,   443,   444,   445,   446,   447,   448,     0,
       0,     0,     0,     0,   222,   445,   446,   447,   448,  1218,
       0,     0,     0,     0,   223,     0,     0,   224,     0,     0,
       0,   225,   226,     0,     0,   228,   229,     0,     0,     0,
       0,   230,     0,     0,  1257,     0,   223,   238,     0,   224,
     239,     0,   240,   225,   226,     0,     0,   228,   229,     0,
       0,     0,     0,   230,     0,   271,     0,     0,     0,  1259,
     272,   273,   274,     0,   292,   231,     0,     0,   449,   450,
     232,     0,     0,     0,     0,     0,     0,     0,   449,   450,
     241,     0,  1261,     0,  1317,     0,     0,   231,     0,     0,
    1358,   242,   232,     0,     0,     0,     0,     0,   275,     0,
       0,   293,   294,   295,   315,  1017,     0,     0,     0,  1318,
     296,     0,     0,     0,     0,     0,     0,     0,   972,     0,
       0,     0,   222,     0,     0,   297,     0,   243,     0,   289,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   276,   244,   245,     0,   246,   247,   319,   248,   249,
     250,     0,   251,   291,   223,   252,   253,   224,   254,     0,
    1018,   225,   226,     0,   222,   228,   229,     0,     0,     0,
       0,   230,   255,   256,     0,     0,  1359,   257,     0,   258,
     259,     0,   260,   303,   222,     0,     0,   261,   320,     0,
       0,   262,   263,     0,   264,   265,   223,   266,   267,   224,
       0,     0,     0,   225,   226,   231,     0,   228,   229,     0,
     232,     0,     0,   230,     0,     0,   223,     0,     0,   224,
       0,     0,     0,   225,   226,     0,   227,   228,   229,     0,
       0,     0,     0,   230,     0,     0,  1019,   812,     0,     0,
     454,   455,   456,   457,   458,     0,     0,   231,     0,     0,
    1360,     0,   232,   671,   459,   460,   461,   462,   463,   464,
     465,   466,   304,     0,   467,     0,     0,   231,   364,   365,
       0,     0,   232,     0,     0,     0,     0,     0,     0,   282,
     283,     0,     0,     0,  1361,     0,   268,  1020,     0,     0,
     672,     0,     0,     0,     0,  1362,     0,  1363,     0,  1364,
    1365,  1366,  1367,  1368,  1369,     0,     0,     0,   284,     4,
    1370,  1021,     0,  1022,  1371,  1372,     0,     0,  1373,     0,
    1023,     0,  1024,   673,  1374,     0,  1025,  1026,   674,     0,
       5,     6,  1375,     0,     0,   675,   676,     0,     0,     0,
    1376,     0,  1377,     0,     0,     0,     0,     0,   677,     0,
       0,     0,     0,     0,     0,     0,     0,   678,   679,   680,
     681,     0,   682,     7,     8,     0,     0,  1027,     0,     0,
       0,     0,     0,   305,     0,  1378,     0,   779,   780,   781,
     782,   783,   784,   785,     9,   786,   787,   788,   789,   790,
       0,     0,     0,     0,    10,     0,     0,    11,     0,    12,
       0,     0,     0,     0,    13,  1219,     0,     0,     0,    14,
      15,    16,     0,     0,   453,     0,    17,    18,    19,   454,
     455,   456,   457,   458,     0,     0,   321,     0,     0,     0,
       0,     0,     0,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,     0,   454,   455,   456,   457,   458,
     529,     0,     0,     0,     0,     0,  -424,  -424,  -424,   459,
     460,   461,   462,   463,   464,   465,   466,     0,   306,   467,
    -424,  -424,  -424,  -424,   463,   464,   465,   466,     0,     0,
     467,   454,   455,   456,     0,     0,     0,     0,   233,     0,
       0,     0,     0,     0,     0,   459,   460,   461,   462,   463,
     464,   465,   466,     0,     0,   467
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1144)))

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-424)))

static const yytype_int16 yycheck[] =
{
      17,   173,   143,   144,   271,   173,   142,   595,   240,   681,
     949,   969,    18,   599,     7,    15,   244,   245,     6,    19,
      15,    18,    19,    22,    87,    27,   258,    15,    16,    17,
      18,    19,   890,    15,   803,   267,   173,    19,    15,    82,
     272,     3,    19,   275,    18,    19,    28,   114,     0,    87,
       6,     8,     9,    10,    11,    12,   193,    40,    46,    15,
      16,    17,    18,    80,    19,    22,    23,    24,    25,    26,
      27,    28,    29,     4,    15,    32,   134,   135,    19,   311,
      15,   313,    29,    97,    19,     6,   139,    15,   225,    26,
      27,    19,    80,  1232,    15,    16,    17,    18,    19,    34,
      35,    36,    37,    18,    19,    35,    34,    35,    36,    37,
      40,    20,   249,     3,     8,     9,    10,    11,    12,    35,
     114,  1264,    35,   202,    40,    46,   206,    40,    22,    23,
      24,    25,    26,    27,    28,    29,  1094,   274,    32,    20,
      15,    16,    17,    18,    19,   162,  1095,    15,    16,    17,
      18,    19,   232,   290,  1160,   172,   293,   294,    15,    80,
      18,    19,    19,   304,   152,   153,   154,   155,   156,   157,
     158,    15,    53,    87,    73,    19,   138,    34,    35,    36,
      37,    15,   235,     3,   172,    19,  1325,   175,   776,  1047,
      34,    35,    36,    37,  1094,   332,   105,   199,  1264,   213,
      34,    35,    36,    37,    15,    16,    17,    18,  1166,   252,
    1353,   166,   114,   354,   272,    15,    16,    17,    18,    19,
     283,   357,   358,   286,   360,   361,     8,     9,    10,    11,
      12,   152,   153,   154,   155,   156,   157,   158,   219,   220,
      22,    23,    24,    25,    26,    27,    28,    29,   515,  1255,
      32,   172,   331,   332,   175,     8,     9,    10,    11,    12,
      88,  1219,   213,    15,    16,    17,    18,   152,  1217,    22,
      23,    24,    25,    26,    27,    28,    29,   290,   345,    32,
       8,     9,    10,    11,    12,    15,   299,  1353,   203,    19,
     328,   329,   243,   244,    22,    23,    24,    25,    26,    27,
      28,    29,   130,  1261,    32,    35,   978,     8,     9,    10,
      11,    12,   114,   695,  1253,   547,   698,   216,   700,  1219,
     548,    22,    23,    24,    25,    26,    27,    28,    29,   561,
    1099,    32,   267,    15,   566,    19,   568,    19,   570,   345,
     572,   341,   341,   575,   576,   577,  1304,  1305,   345,   342,
      19,   583,   347,   341,   491,   296,   297,   345,   571,   341,
      19,   344,   379,   340,   341,   347,    15,  1261,   385,   283,
      19,   345,   286,   134,   135,    77,   393,   394,   395,   396,
     397,    40,   614,   346,   312,   341,   349,   344,    19,   345,
     527,   619,   409,   621,  1352,   532,   343,   534,   309,   631,
     341,     3,    20,   616,  1304,  1344,   341,   344,   545,   637,
      73,  1305,   549,   341,   344,   552,    38,   554,    19,   105,
     341,    39,   559,   560,   345,   111,    22,   109,   344,   138,
    1102,   344,    50,   192,    56,   346,    32,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
    1036,   118,   346,   681,    19,   312,    78,   594,  1352,   100,
     109,   102,   306,   222,   342,   482,   341,    40,   346,   606,
      19,    73,   489,   341,    19,    40,   704,   119,   120,   121,
     122,   344,    83,   346,   341,     8,     9,    10,    11,    12,
     627,   376,   629,   378,   344,   380,   381,   341,   635,    22,
      23,    24,    25,    26,    27,    28,    29,   341,   110,    32,
      20,   272,   529,    86,    87,   105,   106,   139,    91,     8,
       9,    10,    11,    12,   114,   127,     3,    86,    40,   670,
     341,     3,  1120,    22,    23,    24,    25,    26,    27,    28,
      29,   341,   132,    32,    61,   146,   928,   137,   930,   139,
     140,    77,     3,     7,     8,     3,    10,    11,   267,   346,
     342,   697,   349,   699,   346,    19,   703,   739,   740,     3,
     798,    19,    28,    29,    86,    87,    32,   745,    73,    91,
     847,   290,   141,   142,     3,    97,   818,   113,   343,   341,
      99,   346,   824,   346,     3,    64,   828,    18,    19,    20,
      69,   203,   739,   740,     3,     8,     9,    10,    11,    12,
     100,   341,   102,    82,   123,   267,   268,     3,   346,    22,
      23,    24,    25,    26,    27,    28,    29,   200,    76,    32,
     156,   532,   275,   534,    33,   194,   345,    19,    20,    38,
     199,    15,    41,    17,    18,   346,    19,   223,   224,   118,
      19,    20,   304,    52,   921,    19,   923,     3,    40,   341,
     927,     3,   799,   120,   892,   806,   123,    15,   258,    17,
      18,    40,     3,    46,    73,   129,   130,    76,     3,    78,
      79,   324,   325,   326,   327,   822,   823,    86,   200,    19,
      20,   216,   341,   233,   234,   832,    54,    55,   340,   836,
     301,     3,   839,   318,   319,   157,     3,    80,   845,     3,
      40,   220,   313,   314,   731,   114,   733,    29,   117,     8,
       9,    10,    11,    12,    19,    20,   100,    15,   865,   254,
     129,   345,   346,    22,    23,    24,    25,    26,    27,    28,
      29,   345,   346,    32,   341,   335,   883,   345,   346,   148,
     978,    22,   151,     8,     9,    10,    11,    12,   210,   199,
     269,   270,   271,   341,   273,   213,   341,    22,    23,    24,
      25,    26,    27,    28,    29,   284,     3,    32,    70,   152,
     153,   154,   155,   156,   157,   158,  1018,   312,  1020,   258,
     341,   243,   317,   341,  1026,   345,   346,   127,   128,   172,
     252,    57,   175,    13,   341,    15,    16,    17,    18,    19,
      20,   259,   341,   105,   106,   125,    26,    27,    28,    29,
     345,    31,   340,   346,  1151,  1152,   274,    13,    19,    15,
      16,    17,    18,    19,    20,  1141,   345,   340,   161,   100,
      26,    27,   344,    29,   292,    31,   315,    93,    94,    95,
      96,   320,   144,   145,   146,   147,   993,   346,   344,   307,
     308,   184,  1129,    18,    19,    20,   335,   190,   389,   390,
      80,   344,   195,   196,  1102,    19,    86,    77,    91,    20,
      20,   340,  1023,   344,   336,   337,   338,   339,     8,     9,
      10,    11,    12,  1125,    80,   340,  1202,  1203,  1204,  1205,
      86,   221,    22,    23,    24,    25,    26,    27,    28,    29,
      51,  1048,    32,  1040,  1041,  1042,    20,    58,    59,    60,
     937,    91,   121,   940,   941,   942,   206,   944,    67,   946,
      67,   141,   142,   376,   951,   378,   204,   380,   381,   212,
     216,   340,   959,   346,    13,   253,    15,    16,    17,    18,
      19,    20,   218,   237,   233,   141,   142,    26,    27,   240,
      29,   247,    31,   216,   242,   255,   176,   177,   178,   179,
     180,   181,   345,   340,  1111,    76,   344,   340,   344,   344,
      70,   191,    73,   340,   194,     3,  1123,  1124,   198,  1126,
     176,   177,   178,   179,   180,   181,    67,  1134,    88,    89,
    1137,    19,  1234,   344,    20,   191,   344,    67,   194,   344,
     344,    80,   198,   103,   104,   292,   106,    86,     8,     9,
      10,    11,    12,   275,   276,   277,   278,   279,   280,   281,
     282,   340,    22,    23,    24,    25,    26,    27,    28,    29,
     340,    73,    32,    73,   340,    67,    70,   340,  1280,   340,
    1282,    20,    67,   342,  1071,    73,     3,   340,  1195,     3,
      78,    79,     3,    19,     3,   340,   340,     3,    86,     3,
    1087,   340,   141,   142,  1091,  1092,    88,     3,     3,     3,
    1097,     3,     3,    14,    96,    15,   115,   342,  1229,   101,
    1231,   103,  1264,   105,   115,   107,   114,   109,  1235,  1236,
    1237,   199,    29,    26,    32,    19,    15,   176,   177,   159,
     160,   161,   162,   163,   164,   165,    27,   167,   168,   169,
     170,   171,   191,   346,     7,   194,     3,    20,   340,   198,
    1362,   341,   340,   151,   340,    19,   341,    98,   348,    46,
    1157,   203,   340,  1160,  1281,   340,  1163,  1164,  1165,  1286,
    1287,  1288,    67,  1290,    67,   341,     8,     9,    10,    11,
      12,   245,   348,  1395,    30,    67,  1398,   340,    67,    67,
      22,    23,    24,    25,    26,    27,    28,    29,   340,  1351,
      32,  1353,    77,  1415,   340,    91,   340,  1419,   340,   340,
    1327,  1423,   340,    19,     8,     9,    10,    11,    12,  1336,
    1337,   210,   340,    99,  1221,  1222,   340,  1224,    22,    23,
      24,    25,    26,    27,    28,    29,   340,   340,    32,   340,
       3,   340,   342,  1360,   340,   340,  1363,  1364,  1365,   340,
    1367,  1368,   340,     3,    19,    15,  1373,    19,  1255,    13,
      19,    15,    16,    17,    18,    19,    20,    19,    15,    20,
      15,    27,    26,    27,    28,    29,   342,    31,     7,   102,
      15,   104,    18,   106,   346,   108,  1403,   110,  1405,   346,
     113,   114,   341,   342,   341,    20,   340,   340,   344,   348,
      27,   346,    92,   340,  1421,  1422,   340,  1424,   340,   340,
      19,   203,  1309,    41,    42,    43,    44,    45,    46,    47,
      48,    49,  1319,  1320,  1321,  1322,    80,   340,   345,   340,
     345,    13,    86,    15,    16,    17,    18,    19,    20,     3,
     340,   340,     3,   340,    26,    27,   340,    29,   303,    31,
     340,    13,   340,    15,    16,    17,    18,    19,    20,   340,
     340,   340,   340,   340,    26,    27,    28,    29,   340,    31,
      15,   340,   342,   340,   340,   340,   340,   340,    13,   340,
      15,    16,    17,    18,    19,    20,   340,   141,   142,   340,
    1387,    26,    27,   340,    29,     3,    31,     3,    80,   203,
     203,    27,   346,   340,    86,   115,   340,   342,   346,   340,
     340,     8,     9,    10,    11,    12,    20,   340,    80,     3,
     340,   292,   176,   177,    86,    22,    23,    24,    25,    26,
      27,    28,    29,     3,    15,    32,    15,   191,    15,   309,
     194,   340,   340,   340,   198,    80,   342,    22,    15,     7,
     340,    86,     8,     9,    10,    11,    12,   340,   346,   141,
     142,   341,    22,   340,   345,   203,    22,    23,    24,    25,
      26,    27,    28,    29,   340,   344,    32,   344,   346,   141,
     142,   340,   344,   344,     8,     9,    10,    11,    12,   340,
     340,   340,   345,   340,   176,   177,   340,   255,    22,    23,
      24,    25,    26,    27,    28,    29,   141,   142,    32,   191,
     342,   340,   194,     3,   176,   177,   198,     3,   342,   341,
      15,   342,   174,   342,   344,   341,   341,   341,   341,   191,
     340,   340,   194,   340,   218,   340,   198,   345,   293,   340,
       7,   176,   177,   342,   346,   340,   292,   344,   342,   255,
       8,     9,    10,    11,    12,   218,   191,   277,   311,   194,
     303,   295,   275,   198,    22,    23,    24,    25,    26,    27,
      28,    29,   340,   342,    32,   293,   340,   486,   229,   340,
     287,     8,     9,    10,    11,    12,   328,   341,   979,   766,
    1377,   340,   340,   906,   348,    22,    23,    24,    25,    26,
      27,    28,    29,   340,   903,    32,     8,     9,    10,    11,
      12,   968,  1036,  1099,   347,   676,   501,   804,  1304,   950,
      22,    23,    24,    25,    26,    27,    28,    29,   354,   739,
      32,     8,     9,    10,    11,    12,  1351,   172,   740,  1353,
     745,  1095,   937,  1164,  1224,    22,    23,    24,    25,    26,
      27,    28,    29,  1191,   894,    32,  1183,    -1,   340,   341,
      -1,    -1,    -1,    -1,    -1,    -1,   348,    -1,    -1,    -1,
      -1,    -1,    -1,     8,     9,    10,    11,    12,    -1,   341,
      -1,    -1,    -1,    -1,    -1,    -1,   348,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    32,    -1,    -1,
       8,     9,    10,    11,    12,    -1,   341,    -1,    -1,    -1,
      -1,    -1,    -1,   348,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   342,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    32,    -1,    -1,    -1,    -1,   342,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    32,     8,     9,    10,    11,    12,    -1,   342,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       5,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
       5,    32,     8,     9,    10,    11,    12,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,   342,    -1,    32,     8,     9,    10,
      11,    12,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      41,    32,    -1,    -1,    -1,   342,    71,    72,    -1,    74,
      75,    -1,    -1,    -1,    -1,    -1,    71,    72,    80,    74,
      75,    41,    -1,    64,    65,    66,    -1,    68,    69,    -1,
     342,    -1,    73,    -1,    -1,    76,    -1,    41,    -1,    80,
      81,    61,    -1,    84,    85,   100,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    73,    -1,   342,    76,    -1,    -1,    -1,
      80,    81,    -1,    83,    84,    85,    -1,    -1,   133,    73,
      90,    -1,    76,    -1,    -1,    -1,    80,    81,   133,    99,
      84,    85,    -1,   124,    -1,    -1,    90,    -1,   129,    -1,
     152,   153,   154,   155,   156,   157,   158,   342,    -1,    -1,
      -1,    -1,   122,   123,   124,    -1,    -1,    -1,    -1,   129,
     172,    -1,    -1,   175,    -1,    -1,    -1,    -1,    -1,    -1,
     124,    -1,    -1,    -1,   342,   129,    -1,   182,   183,    -1,
     185,   186,   187,   188,   189,   159,   160,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,   170,   171,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   342,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,    -1,    -1,   340,
      -1,    -1,    41,   248,   249,    -1,    -1,    46,    -1,    -1,
      -1,    -1,    -1,   248,   249,   260,   261,   262,   263,    -1,
      -1,    -1,    -1,    -1,    41,   260,   261,   262,   263,   340,
      -1,    -1,    -1,    -1,    73,    -1,    -1,    76,    -1,    -1,
      -1,    80,    81,    -1,    -1,    84,    85,    -1,    -1,    -1,
      -1,    90,    -1,    -1,   340,    -1,    73,    96,    -1,    76,
      99,    -1,   101,    80,    81,    -1,    -1,    84,    85,    -1,
      -1,    -1,    -1,    90,    -1,   259,    -1,    -1,    -1,   340,
     264,   265,   266,    -1,   284,   124,    -1,    -1,   333,   334,
     129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   333,   334,
     139,    -1,   344,    -1,   340,    -1,    -1,   124,    -1,    -1,
      60,   150,   129,    -1,    -1,    -1,    -1,    -1,   302,    -1,
      -1,   321,   322,   323,   345,    83,    -1,    -1,    -1,   340,
     330,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   342,    -1,
      -1,    -1,    41,    -1,    -1,   345,    -1,   186,    -1,    99,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   345,   201,   202,    -1,   204,   205,    66,   207,   208,
     209,    -1,   211,   123,    73,   214,   215,    76,   217,    -1,
     138,    80,    81,    -1,    41,    84,    85,    -1,    -1,    -1,
      -1,    90,   231,   232,    -1,    -1,   146,   236,    -1,   238,
     239,    -1,   241,    60,    41,    -1,    -1,   246,   107,    -1,
      -1,   250,   251,    -1,   253,   254,    73,   256,   257,    76,
      -1,    -1,    -1,    80,    81,   124,    -1,    84,    85,    -1,
     129,    -1,    -1,    90,    -1,    -1,    73,    -1,    -1,    76,
      -1,    -1,    -1,    80,    81,    -1,    83,    84,    85,    -1,
      -1,    -1,    -1,    90,    -1,    -1,   214,    19,    -1,    -1,
       8,     9,    10,    11,    12,    -1,    -1,   124,    -1,    -1,
     220,    -1,   129,     3,    22,    23,    24,    25,    26,    27,
      28,    29,   139,    -1,    32,    -1,    -1,   124,    18,    19,
      -1,    -1,   129,    -1,    -1,    -1,    -1,    -1,    -1,   316,
     317,    -1,    -1,    -1,   254,    -1,   345,   265,    -1,    -1,
      40,    -1,    -1,    -1,    -1,   265,    -1,   267,    -1,   269,
     270,   271,   272,   273,   274,    -1,    -1,    -1,   345,    41,
     280,   289,    -1,   291,   284,   285,    -1,    -1,   288,    -1,
     298,    -1,   300,    73,   294,    -1,   304,   305,    78,    -1,
      62,    63,   302,    -1,    -1,    85,    86,    -1,    -1,    -1,
     310,    -1,   312,    -1,    -1,    -1,    -1,    -1,    98,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   107,   108,   109,
     110,    -1,   112,    95,    96,    -1,    -1,   345,    -1,    -1,
      -1,    -1,    -1,   250,    -1,   345,    -1,   159,   160,   161,
     162,   163,   164,   165,   116,   167,   168,   169,   170,   171,
      -1,    -1,    -1,    -1,   126,    -1,    -1,   129,    -1,   131,
      -1,    -1,    -1,    -1,   136,   173,    -1,    -1,    -1,   141,
     142,   143,    -1,    -1,     3,    -1,   148,   149,   150,     8,
       9,    10,    11,    12,    -1,    -1,   345,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,    -1,     8,     9,    10,    11,    12,
     200,    -1,    -1,    -1,    -1,    -1,     8,     9,    10,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,   345,    32,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,     8,     9,    10,    -1,    -1,    -1,    -1,   345,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   351,   352,    41,    62,    63,    95,    96,   116,
     126,   129,   131,   136,   141,   142,   143,   148,   149,   150,
     373,   374,   375,   376,   377,   378,   427,   428,   429,   430,
     432,   433,   434,   437,   440,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   552,   553,   554,   555,
     556,   557,   558,   559,   578,   580,     0,     3,    33,    38,
      41,    52,    73,    76,    78,    79,    86,   114,   117,   129,
     148,   151,   340,   353,   363,   369,   372,   381,   383,   386,
     388,   392,   393,   395,   396,   403,   412,   413,   468,   470,
     480,   519,   520,   521,   522,   561,   562,   563,   564,   572,
     573,   579,   581,   582,   583,    19,    20,    40,   466,    20,
      51,    58,    59,    60,   379,     3,   466,   466,   114,   127,
     128,   466,   466,     3,   105,   106,   114,   132,   137,   139,
     140,   258,   335,   114,   114,    70,   105,   106,   144,   145,
     146,   147,    13,    15,    16,    17,    18,    19,    20,    26,
      27,    29,    31,    80,    86,   141,   142,   176,   177,   191,
     194,   198,   341,   348,   485,   498,   503,   506,   507,   508,
     510,   512,    35,    40,   344,   455,   466,    19,    20,    39,
      50,   365,   105,   111,    38,    56,    78,   139,   370,   371,
      19,    77,    19,    73,   118,    20,   105,   512,    19,    19,
     397,   397,   344,    64,    69,    82,   118,   258,   315,   320,
     335,   397,    41,    73,    76,    80,    81,    83,    84,    85,
      90,   124,   129,   345,   398,   415,   397,    46,    96,    99,
     101,   139,   150,   186,   201,   202,   204,   205,   207,   208,
     209,   211,   214,   215,   217,   231,   232,   236,   238,   239,
     241,   246,   250,   251,   253,   254,   256,   257,   345,   398,
     397,   259,   264,   265,   266,   302,   345,   398,   523,   524,
     525,   397,   316,   317,   345,   398,   397,    61,    83,    99,
     122,   123,   284,   321,   322,   323,   330,   345,   398,   422,
     424,   425,   397,    60,   139,   250,   345,   398,   574,   577,
      64,    65,    66,    68,    69,   345,   382,   385,   398,    66,
     107,   345,   384,   398,    35,    40,   344,   416,   379,     3,
       3,   379,    61,   380,     3,     3,    73,   442,   466,   466,
       3,    35,    40,   344,   419,    19,    20,    40,   467,     3,
     138,   438,     3,     3,   435,   441,    19,    83,   146,   301,
     313,   314,   431,   431,    18,    19,   356,   358,   358,     3,
       3,     3,     3,     3,     3,     3,    15,    19,    28,   341,
     347,   502,   504,   510,    29,   341,   199,    27,   199,    15,
     347,   505,   512,   341,   341,   341,   341,   341,   341,   178,
     179,   180,   181,   492,   512,    15,    16,    17,    19,   341,
     354,   485,   486,   490,   493,   494,   496,   498,   499,   500,
       5,    71,    72,    74,    75,   100,   133,   182,   183,   185,
     186,   187,   188,   189,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   248,   249,   260,   261,   262,   263,   333,
     334,   511,   584,     3,     8,     9,    10,    11,    12,    22,
      23,    24,    25,    26,    27,    28,    29,    32,    41,    42,
      43,    44,    45,    46,    47,    48,    49,   367,   368,    15,
     456,     3,    22,    57,   364,    40,   344,   366,   416,   341,
     354,    20,    53,   340,   125,   391,    15,    17,    18,   100,
     387,   469,    19,   389,   340,   419,   481,   100,   344,   344,
     394,   344,   416,    19,   402,    77,   354,    34,    35,    36,
      37,   354,   355,   414,    40,    86,    87,    91,    97,   200,
     399,   477,    91,   399,    91,    20,   419,   340,   340,   344,
     219,   220,   221,    20,   355,    91,   139,   235,   121,   203,
     356,   356,    67,   206,    67,   340,   354,   204,   212,   223,
     224,   216,   218,   233,   234,   233,   237,   355,   240,   242,
     247,    73,   216,    82,   252,   216,   255,   253,   355,   340,
     344,   387,   355,    76,   354,   355,   340,   344,   344,    73,
     318,   319,   340,   344,    67,   570,   571,    20,   354,   344,
      87,   328,   329,   565,   354,   354,    67,   202,   331,   332,
     340,   340,   344,   344,   292,   358,    73,   340,   157,   210,
     243,   252,   336,   337,   338,   339,   340,    73,   355,    67,
     355,    70,   340,   340,   340,    67,    20,   362,   340,   340,
      70,    88,    89,   103,   104,   106,   417,   418,     3,   380,
       3,   354,     3,    19,     3,     3,     3,    88,   130,   420,
     421,     3,   467,     3,     3,     3,    73,   110,   127,   203,
     439,     3,    40,    73,    78,    85,    86,    98,   107,   108,
     109,   110,   112,   358,   436,   477,     3,    19,    73,    78,
      79,    86,   114,   151,   431,   431,   560,    40,   431,    40,
     431,     3,     3,    29,   343,   360,   115,   115,   504,   504,
     512,   504,   504,    14,    15,   512,   516,   517,    26,   199,
      27,   505,   505,    29,   512,   512,   512,   512,   512,    19,
      15,   346,   342,   346,    28,   488,   489,   492,   512,     7,
     346,   349,    26,    27,   344,   346,   349,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     161,   184,   190,   195,   196,   345,   346,     3,   512,    20,
     367,   340,   512,   354,    54,    55,   409,   410,   340,   159,
     160,   161,   162,   163,   164,   165,   167,   168,   169,   170,
     171,   471,   472,   473,   475,   479,   119,   120,   121,   122,
     340,   390,   340,   341,   478,    19,   114,   345,   387,   404,
     407,   408,    19,   475,   476,    35,   354,   401,    98,   512,
     401,   401,    67,    67,    46,   340,   340,   354,   245,   355,
     356,   354,   203,    30,   357,   354,    67,   354,   340,    67,
      97,   213,   354,   354,   355,    67,   340,    77,   340,   355,
     340,   355,   213,   243,   244,   355,   402,   355,   340,   340,
     355,   355,   355,   340,   355,    91,   526,    19,   340,   340,
     354,   408,   340,   340,   423,   424,   340,   340,   340,   354,
     340,   340,   340,    77,   113,   156,   426,   355,   402,    20,
     356,   356,   210,   575,   576,   354,   354,   355,   354,   356,
     358,   359,   345,   346,     3,   345,   346,     3,    19,    15,
     358,    19,    19,   476,   359,    19,    20,   551,   551,     3,
      19,    76,   213,   259,   274,   292,   307,   308,   431,   551,
     431,   551,   354,   356,    15,    15,   342,   346,   342,    27,
     346,   346,   346,   342,   346,   342,   346,   512,   512,     7,
     346,   346,   342,    18,   486,   494,    15,    18,   499,   341,
     368,   340,   345,    20,   408,   340,    19,   166,   340,   344,
     356,   354,   342,   472,   474,   479,   358,    27,   406,   346,
      92,   400,   355,   354,   354,   355,   340,   355,   340,   340,
     340,   354,    19,   203,   340,   354,   340,   354,   340,   340,
     340,   340,   340,   354,   387,   340,   340,   340,   340,   340,
     340,   340,   340,   340,   340,   340,   354,    83,   138,   214,
     265,   289,   291,   298,   300,   304,   305,   345,   527,   534,
     537,   340,   340,   344,   569,   345,   340,   340,   354,   100,
     102,   100,   102,   345,   340,   340,   357,   356,   303,   575,
     418,   421,     3,     3,   387,   387,    15,   387,   551,     3,
     551,     3,   203,   203,   516,    27,   512,   512,   512,   512,
     512,   346,   342,   488,   512,   489,   491,   512,   346,   512,
     473,    19,    46,    80,   152,   153,   154,   155,   156,   157,
     158,   172,   175,   482,   483,   508,   509,   513,   518,   340,
     342,   115,    20,   359,   405,   407,    93,    94,    95,    96,
     340,   346,   340,   340,   340,   354,   340,   340,   340,   340,
     546,   550,   355,   267,   268,   304,   267,   355,   528,   292,
     358,   530,   531,   529,   306,   355,   340,   309,   547,   568,
     423,   340,    20,   361,   361,   361,   361,   357,   354,     3,
       3,    15,    15,   342,   342,   342,   342,   346,   512,   342,
     346,    15,   342,    22,   341,    22,   341,   512,   512,   512,
     345,   518,   511,   584,   340,   512,   514,   515,   474,    15,
     359,   354,   340,   408,   354,   354,   355,   354,   344,   387,
     344,   344,   354,   354,   344,   216,   254,   312,   317,   345,
     567,   426,   340,   340,   340,   340,   442,   442,   512,   342,
       7,    28,   491,   345,   512,   517,   512,   508,   340,   173,
     344,    22,    22,    32,   346,   340,   203,   340,   547,   539,
     532,   539,   535,   354,   255,   134,   135,   272,   411,   275,
     324,   325,   326,   327,   566,   340,   426,   426,   426,   426,
       3,     3,   342,   341,   342,     7,   342,   340,   342,   340,
     584,   344,   484,   518,   501,   512,   512,    86,   141,   142,
     194,   199,   515,    15,   344,   549,   345,   358,   540,   541,
     138,   267,   290,   345,   533,   345,   220,   269,   270,   271,
     273,   284,   345,   422,   536,   312,   355,   354,   354,   354,
     488,   491,   342,   482,   174,     6,    15,    16,    17,   341,
     345,   485,   487,   490,   493,   495,   497,   340,   340,   341,
     341,   341,   341,   340,   340,   548,   290,   299,   542,   355,
     354,   355,   340,   354,   354,   354,   218,   109,   354,    87,
     283,   286,   340,   293,   346,   342,   340,   345,   484,   482,
     512,     7,   343,   346,   512,   512,   512,   512,    60,   146,
     220,   254,   265,   267,   269,   270,   271,   272,   273,   274,
     280,   284,   285,   288,   294,   302,   310,   312,   345,   422,
     538,   354,   340,   354,   354,   488,   342,   341,   487,   482,
     495,   342,   342,   342,   342,   292,   344,   354,   255,   355,
     354,   354,   354,   218,   354,   109,   354,   275,   276,   277,
     278,   279,   280,   281,   282,   311,    87,   283,   286,   277,
     354,   295,   303,   275,   272,   411,   340,   342,   512,   340,
     340,   340,   340,   355,   543,   312,   355,   354,   354,   355,
     355,   296,   297,   354,   354,   355,   354,    18,   345,   545,
     293,   287,   544,   340
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1792 of yacc.c  */
#line 659 "cf-parse.y"
    { return 0; }
    break;

  case 3:
/* Line 1792 of yacc.c  */
#line 660 "cf-parse.y"
    { return 0; }
    break;

  case 6:
/* Line 1792 of yacc.c  */
#line 673 "cf-parse.y"
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[(4) - (5)].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_CONSTANT | val->type, val);
   }
    break;

  case 8:
/* Line 1792 of yacc.c  */
#line 683 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 9:
/* Line 1792 of yacc.c  */
#line 684 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[(1) - (1)].s)).i; }
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 694 "cf-parse.y"
    {(yyval.i) = !!(yyvsp[(1) - (1)].i); }
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 695 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 12:
/* Line 1792 of yacc.c  */
#line 696 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 13:
/* Line 1792 of yacc.c  */
#line 697 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 14:
/* Line 1792 of yacc.c  */
#line 698 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 15:
/* Line 1792 of yacc.c  */
#line 699 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 17:
/* Line 1792 of yacc.c  */
#line 706 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[(1) - (1)].s)).px.ip;
   }
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 713 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 19:
/* Line 1792 of yacc.c  */
#line 714 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 718 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   }
    break;

  case 22:
/* Line 1792 of yacc.c  */
#line 726 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
    break;

  case 23:
/* Line 1792 of yacc.c  */
#line 730 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   }
    break;

  case 24:
/* Line 1792 of yacc.c  */
#line 734 "cf-parse.y"
    {
     (yyval.i) = ipa_mklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   }
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 741 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
    break;

  case 26:
/* Line 1792 of yacc.c  */
#line 749 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); }
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 750 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 756 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  }
    break;

  case 29:
/* Line 1792 of yacc.c  */
#line 765 "cf-parse.y"
    { (yyval.t) = (yyvsp[(2) - (2)].t); }
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 766 "cf-parse.y"
    { (yyval.t) = bird_name; }
    break;

  case 31:
/* Line 1792 of yacc.c  */
#line 770 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = f;
   }
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 775 "cf-parse.y"
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[(2) - (2)].t); }
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 776 "cf-parse.y"
    { (yyval.g) = stderr; }
    break;

  case 34:
/* Line 1792 of yacc.c  */
#line 780 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 35:
/* Line 1792 of yacc.c  */
#line 781 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 785 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); }
    break;

  case 37:
/* Line 1792 of yacc.c  */
#line 786 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); }
    break;

  case 38:
/* Line 1792 of yacc.c  */
#line 790 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; }
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 791 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; }
    break;

  case 40:
/* Line 1792 of yacc.c  */
#line 792 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; }
    break;

  case 41:
/* Line 1792 of yacc.c  */
#line 793 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; }
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 794 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; }
    break;

  case 43:
/* Line 1792 of yacc.c  */
#line 795 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; }
    break;

  case 44:
/* Line 1792 of yacc.c  */
#line 796 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; }
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 797 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; }
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 798 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; }
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 804 "cf-parse.y"
    { new_config->proto_default_mrtdump = (yyvsp[(3) - (4)].i); }
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 805 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(2) - (3)].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[(2) - (3)].t));
     new_config->mrtdump_file = fileno(f);
   }
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 814 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_route; }
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 815 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_proto; }
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 816 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_base; }
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 817 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_log; }
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 820 "cf-parse.y"
    { *(yyvsp[(1) - (2)].tf) = (struct timeformat){(yyvsp[(2) - (2)].t), NULL, 0}; }
    break;

  case 54:
/* Line 1792 of yacc.c  */
#line 821 "cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = (struct timeformat){(yyvsp[(2) - (4)].t), (yyvsp[(4) - (4)].t), (yyvsp[(3) - (4)].i)}; }
    break;

  case 55:
/* Line 1792 of yacc.c  */
#line 822 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
    break;

  case 56:
/* Line 1792 of yacc.c  */
#line 823 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%F %T", NULL, 0}; }
    break;

  case 58:
/* Line 1792 of yacc.c  */
#line 835 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (4)].t), RECONFIG_HARD, (yyvsp[(3) - (4)].i)); }
    break;

  case 59:
/* Line 1792 of yacc.c  */
#line 838 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (5)].t), RECONFIG_SOFT, (yyvsp[(4) - (5)].i)); }
    break;

  case 60:
/* Line 1792 of yacc.c  */
#line 845 "cf-parse.y"
    { cmd_reconfig_confirm(); }
    break;

  case 61:
/* Line 1792 of yacc.c  */
#line 848 "cf-parse.y"
    { cmd_reconfig_undo(); }
    break;

  case 62:
/* Line 1792 of yacc.c  */
#line 851 "cf-parse.y"
    { cmd_check_config((yyvsp[(3) - (4)].t)); }
    break;

  case 63:
/* Line 1792 of yacc.c  */
#line 854 "cf-parse.y"
    { cmd_shutdown(); }
    break;

  case 64:
/* Line 1792 of yacc.c  */
#line 857 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 66:
/* Line 1792 of yacc.c  */
#line 862 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 863 "cf-parse.y"
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 864 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 69:
/* Line 1792 of yacc.c  */
#line 872 "cf-parse.y"
    { this_proto = krt_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 70:
/* Line 1792 of yacc.c  */
#line 877 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); }
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 878 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 882 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   }
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 889 "cf-parse.y"
    { THIS_KRT->devroutes = (yyvsp[(3) - (3)].i); }
    break;

  case 74:
/* Line 1792 of yacc.c  */
#line 895 "cf-parse.y"
    { this_proto = kif_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 75:
/* Line 1792 of yacc.c  */
#line 900 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 76:
/* Line 1792 of yacc.c  */
#line 904 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
    break;

  case 77:
/* Line 1792 of yacc.c  */
#line 918 "cf-parse.y"
    {
	if ((yyvsp[(3) - (3)].i) <= 0 || (yyvsp[(3) - (3)].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->sys.table_id = (yyvsp[(3) - (3)].i);
   }
    break;

  case 78:
/* Line 1792 of yacc.c  */
#line 932 "cf-parse.y"
    { new_config->router_id = (yyvsp[(3) - (4)].i32); }
    break;

  case 79:
/* Line 1792 of yacc.c  */
#line 933 "cf-parse.y"
    { new_config->router_id_from = this_ipatt; }
    break;

  case 80:
/* Line 1792 of yacc.c  */
#line 937 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); }
    break;

  case 82:
/* Line 1792 of yacc.c  */
#line 939 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
    break;

  case 86:
/* Line 1792 of yacc.c  */
#line 958 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); }
    break;

  case 87:
/* Line 1792 of yacc.c  */
#line 959 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); }
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 960 "cf-parse.y"
    { new_config->listen_bgp_flags = 0; }
    break;

  case 89:
/* Line 1792 of yacc.c  */
#line 961 "cf-parse.y"
    { new_config->listen_bgp_flags = 1; }
    break;

  case 90:
/* Line 1792 of yacc.c  */
#line 968 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 91:
/* Line 1792 of yacc.c  */
#line 969 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 92:
/* Line 1792 of yacc.c  */
#line 973 "cf-parse.y"
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[(2) - (3)].s));
   cf->sorted = (yyvsp[(3) - (3)].i);
   }
    break;

  case 93:
/* Line 1792 of yacc.c  */
#line 981 "cf-parse.y"
    {
  this_roa_table = roa_new_table_config((yyvsp[(3) - (3)].s));
}
    break;

  case 95:
/* Line 1792 of yacc.c  */
#line 987 "cf-parse.y"
    {
     roa_add_item_config(this_roa_table, (yyvsp[(3) - (8)].px).addr, (yyvsp[(3) - (8)].px).len, (yyvsp[(5) - (8)].i), (yyvsp[(7) - (8)].i));
   }
    break;

  case 98:
/* Line 1792 of yacc.c  */
#line 1001 "cf-parse.y"
    { (yyval.i) = SYM_PROTO; }
    break;

  case 99:
/* Line 1792 of yacc.c  */
#line 1002 "cf-parse.y"
    { (yyval.i) = SYM_TEMPLATE; }
    break;

  case 100:
/* Line 1792 of yacc.c  */
#line 1006 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
    break;

  case 101:
/* Line 1792 of yacc.c  */
#line 1012 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 102:
/* Line 1792 of yacc.c  */
#line 1016 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].s)->class != SYM_TEMPLATE) && ((yyvsp[(3) - (3)].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     cf_define_symbol((yyvsp[(1) - (3)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (3)].s)->name;

     proto_copy_config(this_proto, (yyvsp[(3) - (3)].s)->def);
   }
    break;

  case 104:
/* Line 1792 of yacc.c  */
#line 1028 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   }
    break;

  case 105:
/* Line 1792 of yacc.c  */
#line 1032 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); }
    break;

  case 106:
/* Line 1792 of yacc.c  */
#line 1033 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); }
    break;

  case 107:
/* Line 1792 of yacc.c  */
#line 1034 "cf-parse.y"
    { this_proto->mrtdump = (yyvsp[(2) - (2)].i); }
    break;

  case 108:
/* Line 1792 of yacc.c  */
#line 1035 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 109:
/* Line 1792 of yacc.c  */
#line 1036 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 110:
/* Line 1792 of yacc.c  */
#line 1037 "cf-parse.y"
    { this_proto->rx_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 111:
/* Line 1792 of yacc.c  */
#line 1038 "cf-parse.y"
    { this_proto->in_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 112:
/* Line 1792 of yacc.c  */
#line 1039 "cf-parse.y"
    { this_proto->out_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 113:
/* Line 1792 of yacc.c  */
#line 1040 "cf-parse.y"
    { this_proto->in_keep_filtered = (yyvsp[(4) - (4)].i); }
    break;

  case 114:
/* Line 1792 of yacc.c  */
#line 1041 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); }
    break;

  case 115:
/* Line 1792 of yacc.c  */
#line 1042 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); }
    break;

  case 116:
/* Line 1792 of yacc.c  */
#line 1043 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); }
    break;

  case 117:
/* Line 1792 of yacc.c  */
#line 1047 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); }
    break;

  case 119:
/* Line 1792 of yacc.c  */
#line 1049 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; }
    break;

  case 120:
/* Line 1792 of yacc.c  */
#line 1050 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; }
    break;

  case 121:
/* Line 1792 of yacc.c  */
#line 1054 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 122:
/* Line 1792 of yacc.c  */
#line 1055 "cf-parse.y"
    { (yyval.i) = PLA_WARN; }
    break;

  case 123:
/* Line 1792 of yacc.c  */
#line 1056 "cf-parse.y"
    { (yyval.i) = PLA_BLOCK; }
    break;

  case 124:
/* Line 1792 of yacc.c  */
#line 1057 "cf-parse.y"
    { (yyval.i) = PLA_RESTART; }
    break;

  case 125:
/* Line 1792 of yacc.c  */
#line 1058 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 126:
/* Line 1792 of yacc.c  */
#line 1062 "cf-parse.y"
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[(1) - (2)].i);
     l->action = (yyvsp[(2) - (2)].i);
     (yyval.g) = l;
   }
    break;

  case 127:
/* Line 1792 of yacc.c  */
#line 1068 "cf-parse.y"
    { (yyval.g) = NULL; }
    break;

  case 128:
/* Line 1792 of yacc.c  */
#line 1072 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 129:
/* Line 1792 of yacc.c  */
#line 1080 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 130:
/* Line 1792 of yacc.c  */
#line 1081 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 131:
/* Line 1792 of yacc.c  */
#line 1089 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
    break;

  case 132:
/* Line 1792 of yacc.c  */
#line 1097 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
    break;

  case 133:
/* Line 1792 of yacc.c  */
#line 1098 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; }
    break;

  case 134:
/* Line 1792 of yacc.c  */
#line 1099 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; }
    break;

  case 135:
/* Line 1792 of yacc.c  */
#line 1103 "cf-parse.y"
    { this_ipn->positive = 1; }
    break;

  case 136:
/* Line 1792 of yacc.c  */
#line 1104 "cf-parse.y"
    { this_ipn->positive = 0; }
    break;

  case 140:
/* Line 1792 of yacc.c  */
#line 1117 "cf-parse.y"
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
    break;

  case 142:
/* Line 1792 of yacc.c  */
#line 1129 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i) & 0xfc;        if (((yyvsp[(2) - (2)].i) < 0) || ((yyvsp[(2) - (2)].i) > 255)) cf_error("TX class must be in range 0-255"); }
    break;

  case 143:
/* Line 1792 of yacc.c  */
#line 1130 "cf-parse.y"
    { (yyval.i) = ((yyvsp[(2) - (2)].i) & 0x3f) << 2; if (((yyvsp[(2) - (2)].i) < 0) || ((yyvsp[(2) - (2)].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
    break;

  case 144:
/* Line 1792 of yacc.c  */
#line 1136 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_device, sizeof(struct rt_dev_config), (yyvsp[(1) - (2)].i));
     init_list(&DIRECT_CFG->iface_list);
   }
    break;

  case 148:
/* Line 1792 of yacc.c  */
#line 1149 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
    break;

  case 150:
/* Line 1792 of yacc.c  */
#line 1163 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 151:
/* Line 1792 of yacc.c  */
#line 1164 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 152:
/* Line 1792 of yacc.c  */
#line 1165 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 154:
/* Line 1792 of yacc.c  */
#line 1170 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 155:
/* Line 1792 of yacc.c  */
#line 1174 "cf-parse.y"
    { (yyval.i) = D_STATES; }
    break;

  case 156:
/* Line 1792 of yacc.c  */
#line 1175 "cf-parse.y"
    { (yyval.i) = D_ROUTES; }
    break;

  case 157:
/* Line 1792 of yacc.c  */
#line 1176 "cf-parse.y"
    { (yyval.i) = D_FILTERS; }
    break;

  case 158:
/* Line 1792 of yacc.c  */
#line 1177 "cf-parse.y"
    { (yyval.i) = D_IFACES; }
    break;

  case 159:
/* Line 1792 of yacc.c  */
#line 1178 "cf-parse.y"
    { (yyval.i) = D_EVENTS; }
    break;

  case 160:
/* Line 1792 of yacc.c  */
#line 1179 "cf-parse.y"
    { (yyval.i) = D_PACKETS; }
    break;

  case 161:
/* Line 1792 of yacc.c  */
#line 1185 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 162:
/* Line 1792 of yacc.c  */
#line 1186 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 163:
/* Line 1792 of yacc.c  */
#line 1187 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 165:
/* Line 1792 of yacc.c  */
#line 1192 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 166:
/* Line 1792 of yacc.c  */
#line 1196 "cf-parse.y"
    { (yyval.i) = MD_STATES; }
    break;

  case 167:
/* Line 1792 of yacc.c  */
#line 1197 "cf-parse.y"
    { (yyval.i) = MD_MESSAGES; }
    break;

  case 174:
/* Line 1792 of yacc.c  */
#line 1218 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   }
    break;

  case 175:
/* Line 1792 of yacc.c  */
#line 1236 "cf-parse.y"
    { }
    break;

  case 176:
/* Line 1792 of yacc.c  */
#line 1237 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 177:
/* Line 1792 of yacc.c  */
#line 1238 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); }
    break;

  case 178:
/* Line 1792 of yacc.c  */
#line 1239 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 179:
/* Line 1792 of yacc.c  */
#line 1240 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); }
    break;

  case 180:
/* Line 1792 of yacc.c  */
#line 1241 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); }
    break;

  case 181:
/* Line 1792 of yacc.c  */
#line 1250 "cf-parse.y"
    { cmd_show_status(); }
    break;

  case 182:
/* Line 1792 of yacc.c  */
#line 1253 "cf-parse.y"
    { cmd_show_memory(); }
    break;

  case 183:
/* Line 1792 of yacc.c  */
#line 1256 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_show, 0, 0); }
    break;

  case 184:
/* Line 1792 of yacc.c  */
#line 1259 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(4) - (5)].ps), proto_cmd_show, 0, 1); }
    break;

  case 186:
/* Line 1792 of yacc.c  */
#line 1263 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 187:
/* Line 1792 of yacc.c  */
#line 1267 "cf-parse.y"
    { if_show(); }
    break;

  case 188:
/* Line 1792 of yacc.c  */
#line 1270 "cf-parse.y"
    { if_show_summary(); }
    break;

  case 189:
/* Line 1792 of yacc.c  */
#line 1274 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); }
    break;

  case 190:
/* Line 1792 of yacc.c  */
#line 1277 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
    break;

  case 191:
/* Line 1792 of yacc.c  */
#line 1282 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   }
    break;

  case 192:
/* Line 1792 of yacc.c  */
#line 1288 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   }
    break;

  case 193:
/* Line 1792 of yacc.c  */
#line 1295 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 194:
/* Line 1792 of yacc.c  */
#line 1300 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   }
    break;

  case 195:
/* Line 1792 of yacc.c  */
#line 1305 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   }
    break;

  case 196:
/* Line 1792 of yacc.c  */
#line 1310 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   }
    break;

  case 197:
/* Line 1792 of yacc.c  */
#line 1314 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   }
    break;

  case 198:
/* Line 1792 of yacc.c  */
#line 1318 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->filtered = 1;
   }
    break;

  case 199:
/* Line 1792 of yacc.c  */
#line 1322 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->primary_only = 1;
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 200:
/* Line 1792 of yacc.c  */
#line 1332 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 201:
/* Line 1792 of yacc.c  */
#line 1340 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   }
    break;

  case 202:
/* Line 1792 of yacc.c  */
#line 1344 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   }
    break;

  case 203:
/* Line 1792 of yacc.c  */
#line 1351 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 204:
/* Line 1792 of yacc.c  */
#line 1352 "cf-parse.y"
    { (yyval.i) = 2; }
    break;

  case 205:
/* Line 1792 of yacc.c  */
#line 1358 "cf-parse.y"
    { roa_show((yyvsp[(3) - (4)].ro)); }
    break;

  case 206:
/* Line 1792 of yacc.c  */
#line 1361 "cf-parse.y"
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
    break;

  case 207:
/* Line 1792 of yacc.c  */
#line 1368 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ro)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ro)->mode = (yyvsp[(2) - (3)].i);
   }
    break;

  case 208:
/* Line 1792 of yacc.c  */
#line 1375 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     (yyval.ro)->asn = (yyvsp[(3) - (3)].i);
   }
    break;

  case 209:
/* Line 1792 of yacc.c  */
#line 1379 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyvsp[(3) - (3)].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 210:
/* Line 1792 of yacc.c  */
#line 1387 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_PX; }
    break;

  case 211:
/* Line 1792 of yacc.c  */
#line 1388 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_IN; }
    break;

  case 212:
/* Line 1792 of yacc.c  */
#line 1389 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_FOR; }
    break;

  case 213:
/* Line 1792 of yacc.c  */
#line 1395 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].sd)); }
    break;

  case 214:
/* Line 1792 of yacc.c  */
#line 1398 "cf-parse.y"
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
    break;

  case 215:
/* Line 1792 of yacc.c  */
#line 1401 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TABLE; }
    break;

  case 216:
/* Line 1792 of yacc.c  */
#line 1402 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FUNCTION; }
    break;

  case 217:
/* Line 1792 of yacc.c  */
#line 1403 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FILTER; }
    break;

  case 218:
/* Line 1792 of yacc.c  */
#line 1404 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_PROTO; }
    break;

  case 219:
/* Line 1792 of yacc.c  */
#line 1405 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TEMPLATE; }
    break;

  case 220:
/* Line 1792 of yacc.c  */
#line 1406 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_ROA; }
    break;

  case 221:
/* Line 1792 of yacc.c  */
#line 1407 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->sym = (yyvsp[(2) - (2)].s); }
    break;

  case 222:
/* Line 1792 of yacc.c  */
#line 1412 "cf-parse.y"
    { 
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
    break;

  case 223:
/* Line 1792 of yacc.c  */
#line 1417 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[(2) - (2)].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[(2) - (2)].s)->def)->table;
   }
    break;

  case 224:
/* Line 1792 of yacc.c  */
#line 1426 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 225:
/* Line 1792 of yacc.c  */
#line 1433 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 226:
/* Line 1792 of yacc.c  */
#line 1440 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[(3) - (4)].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 227:
/* Line 1792 of yacc.c  */
#line 1448 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); }
    break;

  case 228:
/* Line 1792 of yacc.c  */
#line 1450 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); }
    break;

  case 229:
/* Line 1792 of yacc.c  */
#line 1452 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); }
    break;

  case 230:
/* Line 1792 of yacc.c  */
#line 1454 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); }
    break;

  case 231:
/* Line 1792 of yacc.c  */
#line 1456 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); }
    break;

  case 232:
/* Line 1792 of yacc.c  */
#line 1458 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); }
    break;

  case 233:
/* Line 1792 of yacc.c  */
#line 1460 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); }
    break;

  case 234:
/* Line 1792 of yacc.c  */
#line 1463 "cf-parse.y"
    { cmd_eval((yyvsp[(2) - (3)].x)); }
    break;

  case 235:
/* Line 1792 of yacc.c  */
#line 1466 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
}
    break;

  case 236:
/* Line 1792 of yacc.c  */
#line 1472 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 237:
/* Line 1792 of yacc.c  */
#line 1473 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 238:
/* Line 1792 of yacc.c  */
#line 1474 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 239:
/* Line 1792 of yacc.c  */
#line 1478 "cf-parse.y"
    { (yyval.i) = 4096; }
    break;

  case 240:
/* Line 1792 of yacc.c  */
#line 1479 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   }
    break;

  case 241:
/* Line 1792 of yacc.c  */
#line 1486 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_disable, 1, 0); }
    break;

  case 242:
/* Line 1792 of yacc.c  */
#line 1488 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_enable, 1, 0); }
    break;

  case 243:
/* Line 1792 of yacc.c  */
#line 1490 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_restart, 1, 0); }
    break;

  case 244:
/* Line 1792 of yacc.c  */
#line 1492 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_reload, 1, CMD_RELOAD); }
    break;

  case 245:
/* Line 1792 of yacc.c  */
#line 1494 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
    break;

  case 246:
/* Line 1792 of yacc.c  */
#line 1496 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
    break;

  case 247:
/* Line 1792 of yacc.c  */
#line 1500 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_debug, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 248:
/* Line 1792 of yacc.c  */
#line 1504 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_mrtdump, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 249:
/* Line 1792 of yacc.c  */
#line 1507 "cf-parse.y"
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
    break;

  case 250:
/* Line 1792 of yacc.c  */
#line 1510 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 251:
/* Line 1792 of yacc.c  */
#line 1511 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 252:
/* Line 1792 of yacc.c  */
#line 1512 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 253:
/* Line 1792 of yacc.c  */
#line 1516 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 254:
/* Line 1792 of yacc.c  */
#line 1517 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 255:
/* Line 1792 of yacc.c  */
#line 1518 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 256:
/* Line 1792 of yacc.c  */
#line 1526 "cf-parse.y"
    { (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[(2) - (2)].s) ); }
    break;

  case 257:
/* Line 1792 of yacc.c  */
#line 1527 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s)->def = (yyvsp[(4) - (4)].f);
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   }
    break;

  case 258:
/* Line 1792 of yacc.c  */
#line 1536 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); }
    break;

  case 259:
/* Line 1792 of yacc.c  */
#line 1540 "cf-parse.y"
    { (yyval.i) = T_INT; }
    break;

  case 260:
/* Line 1792 of yacc.c  */
#line 1541 "cf-parse.y"
    { (yyval.i) = T_BOOL; }
    break;

  case 261:
/* Line 1792 of yacc.c  */
#line 1542 "cf-parse.y"
    { (yyval.i) = T_IP; }
    break;

  case 262:
/* Line 1792 of yacc.c  */
#line 1543 "cf-parse.y"
    { (yyval.i) = T_PREFIX; }
    break;

  case 263:
/* Line 1792 of yacc.c  */
#line 1544 "cf-parse.y"
    { (yyval.i) = T_PAIR; }
    break;

  case 264:
/* Line 1792 of yacc.c  */
#line 1545 "cf-parse.y"
    { (yyval.i) = T_QUAD; }
    break;

  case 265:
/* Line 1792 of yacc.c  */
#line 1546 "cf-parse.y"
    { (yyval.i) = T_EC; }
    break;

  case 266:
/* Line 1792 of yacc.c  */
#line 1547 "cf-parse.y"
    { (yyval.i) = T_STRING; }
    break;

  case 267:
/* Line 1792 of yacc.c  */
#line 1548 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; }
    break;

  case 268:
/* Line 1792 of yacc.c  */
#line 1549 "cf-parse.y"
    { (yyval.i) = T_PATH; }
    break;

  case 269:
/* Line 1792 of yacc.c  */
#line 1550 "cf-parse.y"
    { (yyval.i) = T_CLIST; }
    break;

  case 270:
/* Line 1792 of yacc.c  */
#line 1551 "cf-parse.y"
    { (yyval.i) = T_ECLIST; }
    break;

  case 271:
/* Line 1792 of yacc.c  */
#line 1552 "cf-parse.y"
    { 
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
    break;

  case 272:
/* Line 1792 of yacc.c  */
#line 1573 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   }
    break;

  case 273:
/* Line 1792 of yacc.c  */
#line 1584 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 274:
/* Line 1792 of yacc.c  */
#line 1585 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 275:
/* Line 1792 of yacc.c  */
#line 1592 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); }
    break;

  case 276:
/* Line 1792 of yacc.c  */
#line 1593 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 277:
/* Line 1792 of yacc.c  */
#line 1600 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   }
    break;

  case 278:
/* Line 1792 of yacc.c  */
#line 1609 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 280:
/* Line 1792 of yacc.c  */
#line 1617 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
    break;

  case 281:
/* Line 1792 of yacc.c  */
#line 1641 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); }
    break;

  case 282:
/* Line 1792 of yacc.c  */
#line 1642 "cf-parse.y"
    { (yyval.s)=NULL; }
    break;

  case 283:
/* Line 1792 of yacc.c  */
#line 1646 "cf-parse.y"
    {
     if ((yyvsp[(1) - (4)].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
       (yyval.x)->next = (yyvsp[(3) - (4)].x);
     } else
       (yyval.x) = (yyvsp[(3) - (4)].x);
   }
    break;

  case 284:
/* Line 1792 of yacc.c  */
#line 1659 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   }
    break;

  case 285:
/* Line 1792 of yacc.c  */
#line 1662 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name); 
     cf_pop_scope();
   }
    break;

  case 286:
/* Line 1792 of yacc.c  */
#line 1675 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 287:
/* Line 1792 of yacc.c  */
#line 1676 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x)->next; (yyvsp[(1) - (1)].x)->next = NULL; }
    break;

  case 288:
/* Line 1792 of yacc.c  */
#line 1679 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); (yyvsp[(1) - (1)].x)->next = (yyvsp[(1) - (1)].x); }
    break;

  case 289:
/* Line 1792 of yacc.c  */
#line 1680 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyvsp[(2) - (2)].x)->next = (yyvsp[(1) - (2)].x)->next ; (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x); }
    break;

  case 290:
/* Line 1792 of yacc.c  */
#line 1684 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   }
    break;

  case 291:
/* Line 1792 of yacc.c  */
#line 1687 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   }
    break;

  case 292:
/* Line 1792 of yacc.c  */
#line 1696 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); }
    break;

  case 293:
/* Line 1792 of yacc.c  */
#line 1709 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 294:
/* Line 1792 of yacc.c  */
#line 1710 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 295:
/* Line 1792 of yacc.c  */
#line 1711 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 296:
/* Line 1792 of yacc.c  */
#line 1712 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 297:
/* Line 1792 of yacc.c  */
#line 1716 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 298:
/* Line 1792 of yacc.c  */
#line 1717 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 299:
/* Line 1792 of yacc.c  */
#line 1718 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 300:
/* Line 1792 of yacc.c  */
#line 1719 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 301:
/* Line 1792 of yacc.c  */
#line 1720 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 302:
/* Line 1792 of yacc.c  */
#line 1724 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(1) - (1)].x)); check_u16((yyval.i)); }
    break;

  case 303:
/* Line 1792 of yacc.c  */
#line 1727 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (1)].i), (yyvsp[(1) - (1)].i)); }
    break;

  case 304:
/* Line 1792 of yacc.c  */
#line 1728 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (3)].i), (yyvsp[(3) - (3)].i)); }
    break;

  case 305:
/* Line 1792 of yacc.c  */
#line 1729 "cf-parse.y"
    { (yyval.i32) = 0xFFFF; }
    break;

  case 306:
/* Line 1792 of yacc.c  */
#line 1733 "cf-parse.y"
    {
     (yyval.e) = f_new_pair_set(pair_a((yyvsp[(2) - (5)].i32)), pair_b((yyvsp[(2) - (5)].i32)), pair_a((yyvsp[(4) - (5)].i32)), pair_b((yyvsp[(4) - (5)].i32)));
   }
    break;

  case 307:
/* Line 1792 of yacc.c  */
#line 1736 "cf-parse.y"
    {
     /* Hack: $2 and $4 should be pair_expr, but that would cause shift/reduce conflict */
     if ((pair_a((yyvsp[(2) - (11)].i32)) != pair_b((yyvsp[(2) - (11)].i32))) || (pair_a((yyvsp[(4) - (11)].i32)) != pair_b((yyvsp[(4) - (11)].i32))))
       cf_error("syntax error");
     (yyval.e) = f_new_pair_item(pair_b((yyvsp[(2) - (11)].i32)), (yyvsp[(8) - (11)].i), pair_b((yyvsp[(4) - (11)].i32)), (yyvsp[(10) - (11)].i)); 
   }
    break;

  case 308:
/* Line 1792 of yacc.c  */
#line 1745 "cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(1) - (1)].x)); }
    break;

  case 309:
/* Line 1792 of yacc.c  */
#line 1748 "cf-parse.y"
    { (yyval.i) = EC_RT; }
    break;

  case 310:
/* Line 1792 of yacc.c  */
#line 1749 "cf-parse.y"
    { (yyval.i) = EC_RO; }
    break;

  case 311:
/* Line 1792 of yacc.c  */
#line 1750 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 312:
/* Line 1792 of yacc.c  */
#line 1751 "cf-parse.y"
    { (yyval.i) = EC_GENERIC; }
    break;

  case 313:
/* Line 1792 of yacc.c  */
#line 1755 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 314:
/* Line 1792 of yacc.c  */
#line 1756 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (9)].i), 0, (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 315:
/* Line 1792 of yacc.c  */
#line 1757 "cf-parse.y"
    {  (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), 0, EC_ALL); }
    break;

  case 318:
/* Line 1792 of yacc.c  */
#line 1763 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 319:
/* Line 1792 of yacc.c  */
#line 1764 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 322:
/* Line 1792 of yacc.c  */
#line 1770 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 323:
/* Line 1792 of yacc.c  */
#line 1771 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 325:
/* Line 1792 of yacc.c  */
#line 1776 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 327:
/* Line 1792 of yacc.c  */
#line 1781 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 328:
/* Line 1792 of yacc.c  */
#line 1785 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   }
    break;

  case 329:
/* Line 1792 of yacc.c  */
#line 1792 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 330:
/* Line 1792 of yacc.c  */
#line 1793 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; }
    break;

  case 331:
/* Line 1792 of yacc.c  */
#line 1794 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; }
    break;

  case 332:
/* Line 1792 of yacc.c  */
#line 1795 "cf-parse.y"
    { 
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   }
    break;

  case 333:
/* Line 1792 of yacc.c  */
#line 1802 "cf-parse.y"
    { (yyval.trie) = f_new_trie(cfg_mem); trie_add_fprefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); }
    break;

  case 334:
/* Line 1792 of yacc.c  */
#line 1803 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_fprefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); }
    break;

  case 335:
/* Line 1792 of yacc.c  */
#line 1806 "cf-parse.y"
    { (yyval.e) = NULL; }
    break;

  case 336:
/* Line 1792 of yacc.c  */
#line 1807 "cf-parse.y"
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[(2) - (4)].e); t; t = t->left)
       t->data = (yyvsp[(4) - (4)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (4)].e), (yyvsp[(2) - (4)].e));
   }
    break;

  case 337:
/* Line 1792 of yacc.c  */
#line 1814 "cf-parse.y"
    { 
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[(3) - (3)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), t);
 }
    break;

  case 338:
/* Line 1792 of yacc.c  */
#line 1826 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 339:
/* Line 1792 of yacc.c  */
#line 1827 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 340:
/* Line 1792 of yacc.c  */
#line 1831 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 341:
/* Line 1792 of yacc.c  */
#line 1832 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 342:
/* Line 1792 of yacc.c  */
#line 1836 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 343:
/* Line 1792 of yacc.c  */
#line 1837 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
    break;

  case 344:
/* Line 1792 of yacc.c  */
#line 1838 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; }
    break;

  case 345:
/* Line 1792 of yacc.c  */
#line 1839 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); }
    break;

  case 346:
/* Line 1792 of yacc.c  */
#line 1840 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 347:
/* Line 1792 of yacc.c  */
#line 1844 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 348:
/* Line 1792 of yacc.c  */
#line 1845 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
    break;

  case 349:
/* Line 1792 of yacc.c  */
#line 1846 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 350:
/* Line 1792 of yacc.c  */
#line 1850 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); }
    break;

  case 351:
/* Line 1792 of yacc.c  */
#line 1851 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
    break;

  case 352:
/* Line 1792 of yacc.c  */
#line 1852 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
    break;

  case 353:
/* Line 1792 of yacc.c  */
#line 1853 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); }
    break;

  case 354:
/* Line 1792 of yacc.c  */
#line 1854 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 355:
/* Line 1792 of yacc.c  */
#line 1855 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 356:
/* Line 1792 of yacc.c  */
#line 1856 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 357:
/* Line 1792 of yacc.c  */
#line 1857 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); }
    break;

  case 358:
/* Line 1792 of yacc.c  */
#line 1858 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); }
    break;

  case 359:
/* Line 1792 of yacc.c  */
#line 1859 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; }
    break;

  case 360:
/* Line 1792 of yacc.c  */
#line 1860 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[(1) - (1)].h); (yyval.x)->a1.p = val; }
    break;

  case 361:
/* Line 1792 of yacc.c  */
#line 1864 "cf-parse.y"
    { (yyval.x) = f_generate_dpair((yyvsp[(2) - (5)].x), (yyvsp[(4) - (5)].x)); }
    break;

  case 362:
/* Line 1792 of yacc.c  */
#line 1865 "cf-parse.y"
    { (yyval.x) = f_generate_ec((yyvsp[(2) - (7)].i), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); }
    break;

  case 364:
/* Line 1792 of yacc.c  */
#line 1879 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 365:
/* Line 1792 of yacc.c  */
#line 1902 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();

     switch ((yyvsp[(1) - (1)].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x)->code = 'C'; break;
       case SYM_VARIABLE: (yyval.x)->code = 'V'; break;
       default: cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 366:
/* Line 1792 of yacc.c  */
#line 1916 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, from);   (yyval.x)->a1.i = 1; }
    break;

  case 367:
/* Line 1792 of yacc.c  */
#line 1918 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, gw);     (yyval.x)->a1.i = 1; }
    break;

  case 368:
/* Line 1792 of yacc.c  */
#line 1919 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = 0x12345678; /* This is actually ok - T_PREFIX is special-cased. */ }
    break;

  case 369:
/* Line 1792 of yacc.c  */
#line 1920 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = 0x12345678; /* T_STRING is also special-cased. */ }
    break;

  case 370:
/* Line 1792 of yacc.c  */
#line 1921 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = OFFSETOF(struct rta, source); }
    break;

  case 371:
/* Line 1792 of yacc.c  */
#line 1922 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = OFFSETOF(struct rta, scope);  (yyval.x)->a1.i = 1; }
    break;

  case 372:
/* Line 1792 of yacc.c  */
#line 1923 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = OFFSETOF(struct rta, cast); }
    break;

  case 373:
/* Line 1792 of yacc.c  */
#line 1924 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = OFFSETOF(struct rta, dest);   (yyval.x)->a1.i = 1; }
    break;

  case 374:
/* Line 1792 of yacc.c  */
#line 1928 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 375:
/* Line 1792 of yacc.c  */
#line 1929 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 376:
/* Line 1792 of yacc.c  */
#line 1930 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 377:
/* Line 1792 of yacc.c  */
#line 1931 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 378:
/* Line 1792 of yacc.c  */
#line 1932 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 379:
/* Line 1792 of yacc.c  */
#line 1933 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 380:
/* Line 1792 of yacc.c  */
#line 1934 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 381:
/* Line 1792 of yacc.c  */
#line 1935 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 382:
/* Line 1792 of yacc.c  */
#line 1936 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 383:
/* Line 1792 of yacc.c  */
#line 1937 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 384:
/* Line 1792 of yacc.c  */
#line 1938 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 385:
/* Line 1792 of yacc.c  */
#line 1939 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 386:
/* Line 1792 of yacc.c  */
#line 1940 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 387:
/* Line 1792 of yacc.c  */
#line 1941 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 388:
/* Line 1792 of yacc.c  */
#line 1942 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[(2) - (2)].x); }
    break;

  case 389:
/* Line 1792 of yacc.c  */
#line 1943 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); }
    break;

  case 390:
/* Line 1792 of yacc.c  */
#line 1945 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 391:
/* Line 1792 of yacc.c  */
#line 1946 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 392:
/* Line 1792 of yacc.c  */
#line 1947 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 393:
/* Line 1792 of yacc.c  */
#line 1949 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; }
    break;

  case 394:
/* Line 1792 of yacc.c  */
#line 1951 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = 'a'; }
    break;

  case 395:
/* Line 1792 of yacc.c  */
#line 1953 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = P('e','a'); }
    break;

  case 396:
/* Line 1792 of yacc.c  */
#line 1955 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; }
    break;

  case 397:
/* Line 1792 of yacc.c  */
#line 1956 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 398:
/* Line 1792 of yacc.c  */
#line 1957 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 399:
/* Line 1792 of yacc.c  */
#line 1958 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 400:
/* Line 1792 of yacc.c  */
#line 1959 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 401:
/* Line 1792 of yacc.c  */
#line 1969 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; }
    break;

  case 402:
/* Line 1792 of yacc.c  */
#line 1970 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; }
    break;

  case 403:
/* Line 1792 of yacc.c  */
#line 1971 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; }
    break;

  case 404:
/* Line 1792 of yacc.c  */
#line 1972 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 405:
/* Line 1792 of yacc.c  */
#line 1973 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; }
    break;

  case 406:
/* Line 1792 of yacc.c  */
#line 1974 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; }
    break;

  case 407:
/* Line 1792 of yacc.c  */
#line 1975 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'f'; }
    break;

  case 408:
/* Line 1792 of yacc.c  */
#line 1977 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (4)].s), NULL, NULL); }
    break;

  case 409:
/* Line 1792 of yacc.c  */
#line 1978 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (8)].s), (yyvsp[(5) - (8)].x), (yyvsp[(7) - (8)].x)); }
    break;

  case 410:
/* Line 1792 of yacc.c  */
#line 1983 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 411:
/* Line 1792 of yacc.c  */
#line 2006 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; }
    break;

  case 412:
/* Line 1792 of yacc.c  */
#line 2007 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; }
    break;

  case 413:
/* Line 1792 of yacc.c  */
#line 2008 "cf-parse.y"
    { (yyval.i) = F_REJECT; }
    break;

  case 414:
/* Line 1792 of yacc.c  */
#line 2009 "cf-parse.y"
    { (yyval.i) = F_ERROR; }
    break;

  case 415:
/* Line 1792 of yacc.c  */
#line 2010 "cf-parse.y"
    { (yyval.i) = F_NOP; }
    break;

  case 416:
/* Line 1792 of yacc.c  */
#line 2011 "cf-parse.y"
    { (yyval.i) = F_NONL; }
    break;

  case 417:
/* Line 1792 of yacc.c  */
#line 2015 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; }
    break;

  case 418:
/* Line 1792 of yacc.c  */
#line 2018 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 419:
/* Line 1792 of yacc.c  */
#line 2019 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 420:
/* Line 1792 of yacc.c  */
#line 2020 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   }
    break;

  case 421:
/* Line 1792 of yacc.c  */
#line 2028 "cf-parse.y"
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   }
    break;

  case 422:
/* Line 1792 of yacc.c  */
#line 2035 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   }
    break;

  case 423:
/* Line 1792 of yacc.c  */
#line 2044 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 424:
/* Line 1792 of yacc.c  */
#line 2045 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 425:
/* Line 1792 of yacc.c  */
#line 2049 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   }
    break;

  case 426:
/* Line 1792 of yacc.c  */
#line 2055 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   }
    break;

  case 427:
/* Line 1792 of yacc.c  */
#line 2065 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 428:
/* Line 1792 of yacc.c  */
#line 2074 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   }
    break;

  case 429:
/* Line 1792 of yacc.c  */
#line 2080 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 430:
/* Line 1792 of yacc.c  */
#line 2085 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 431:
/* Line 1792 of yacc.c  */
#line 2092 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 432:
/* Line 1792 of yacc.c  */
#line 2097 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(4) - (6)].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   }
    break;

  case 433:
/* Line 1792 of yacc.c  */
#line 2103 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); }
    break;

  case 434:
/* Line 1792 of yacc.c  */
#line 2104 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); }
    break;

  case 435:
/* Line 1792 of yacc.c  */
#line 2105 "cf-parse.y"
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   }
    break;

  case 436:
/* Line 1792 of yacc.c  */
#line 2113 "cf-parse.y"
    { (yyval.x) = f_generate_empty((yyvsp[(2) - (5)].x)); }
    break;

  case 437:
/* Line 1792 of yacc.c  */
#line 2114 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 438:
/* Line 1792 of yacc.c  */
#line 2115 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 439:
/* Line 1792 of yacc.c  */
#line 2116 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 440:
/* Line 1792 of yacc.c  */
#line 2117 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 441:
/* Line 1792 of yacc.c  */
#line 2123 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config), (yyvsp[(1) - (2)].i));
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
 }
    break;

  case 444:
/* Line 1792 of yacc.c  */
#line 2146 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); }
    break;

  case 445:
/* Line 1792 of yacc.c  */
#line 2147 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(3) - (6)].a); BGP_CFG->local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 446:
/* Line 1792 of yacc.c  */
#line 2148 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     if (!ipa_has_link_scope((yyvsp[(3) - (7)].a)) != !(yyvsp[(4) - (7)].iface))
       cf_error("Link-local address and interface scope must be used together");

     BGP_CFG->remote_ip = (yyvsp[(3) - (7)].a);
     BGP_CFG->iface = (yyvsp[(4) - (7)].iface);
     BGP_CFG->remote_as = (yyvsp[(6) - (7)].i);
   }
    break;

  case 447:
/* Line 1792 of yacc.c  */
#line 2158 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i32); }
    break;

  case 448:
/* Line 1792 of yacc.c  */
#line 2159 "cf-parse.y"
    { BGP_CFG->rr_client = 1; }
    break;

  case 449:
/* Line 1792 of yacc.c  */
#line 2160 "cf-parse.y"
    { BGP_CFG->rs_client = 1; }
    break;

  case 450:
/* Line 1792 of yacc.c  */
#line 2161 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); }
    break;

  case 451:
/* Line 1792 of yacc.c  */
#line 2162 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); }
    break;

  case 452:
/* Line 1792 of yacc.c  */
#line 2163 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); }
    break;

  case 453:
/* Line 1792 of yacc.c  */
#line 2164 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); }
    break;

  case 454:
/* Line 1792 of yacc.c  */
#line 2165 "cf-parse.y"
    { BGP_CFG->multihop = 64; }
    break;

  case 455:
/* Line 1792 of yacc.c  */
#line 2166 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (4)].i); if (((yyvsp[(3) - (4)].i)<1) || ((yyvsp[(3) - (4)].i)>255)) cf_error("Multihop must be in range 1-255"); }
    break;

  case 456:
/* Line 1792 of yacc.c  */
#line 2167 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
    break;

  case 457:
/* Line 1792 of yacc.c  */
#line 2168 "cf-parse.y"
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
    break;

  case 458:
/* Line 1792 of yacc.c  */
#line 2169 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; }
    break;

  case 459:
/* Line 1792 of yacc.c  */
#line 2170 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; }
    break;

  case 460:
/* Line 1792 of yacc.c  */
#line 2171 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
    break;

  case 461:
/* Line 1792 of yacc.c  */
#line 2172 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_DIRECT; }
    break;

  case 462:
/* Line 1792 of yacc.c  */
#line 2173 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
    break;

  case 463:
/* Line 1792 of yacc.c  */
#line 2174 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); }
    break;

  case 464:
/* Line 1792 of yacc.c  */
#line 2175 "cf-parse.y"
    { BGP_CFG->med_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 465:
/* Line 1792 of yacc.c  */
#line 2176 "cf-parse.y"
    { BGP_CFG->igp_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 466:
/* Line 1792 of yacc.c  */
#line 2177 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); }
    break;

  case 467:
/* Line 1792 of yacc.c  */
#line 2178 "cf-parse.y"
    { BGP_CFG->deterministic_med = (yyvsp[(4) - (5)].i); }
    break;

  case 468:
/* Line 1792 of yacc.c  */
#line 2179 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); }
    break;

  case 469:
/* Line 1792 of yacc.c  */
#line 2180 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); }
    break;

  case 470:
/* Line 1792 of yacc.c  */
#line 2181 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); }
    break;

  case 471:
/* Line 1792 of yacc.c  */
#line 2182 "cf-parse.y"
    { BGP_CFG->start_delay_time = (yyvsp[(5) - (6)].i); }
    break;

  case 472:
/* Line 1792 of yacc.c  */
#line 2183 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); }
    break;

  case 473:
/* Line 1792 of yacc.c  */
#line 2184 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); }
    break;

  case 474:
/* Line 1792 of yacc.c  */
#line 2185 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); }
    break;

  case 475:
/* Line 1792 of yacc.c  */
#line 2186 "cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); }
    break;

  case 476:
/* Line 1792 of yacc.c  */
#line 2187 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); }
    break;

  case 477:
/* Line 1792 of yacc.c  */
#line 2188 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); }
    break;

  case 478:
/* Line 1792 of yacc.c  */
#line 2189 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); }
    break;

  case 479:
/* Line 1792 of yacc.c  */
#line 2190 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); }
    break;

  case 480:
/* Line 1792 of yacc.c  */
#line 2191 "cf-parse.y"
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[(4) - (5)].i);
     this_proto->in_limit->action = PLA_RESTART;
   }
    break;

  case 481:
/* Line 1792 of yacc.c  */
#line 2196 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); }
    break;

  case 482:
/* Line 1792 of yacc.c  */
#line 2197 "cf-parse.y"
    { BGP_CFG->interpret_communities = (yyvsp[(4) - (5)].i); }
    break;

  case 483:
/* Line 1792 of yacc.c  */
#line 2198 "cf-parse.y"
    { BGP_CFG->secondary = (yyvsp[(3) - (4)].i); }
    break;

  case 484:
/* Line 1792 of yacc.c  */
#line 2199 "cf-parse.y"
    { BGP_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 485:
/* Line 1792 of yacc.c  */
#line 2200 "cf-parse.y"
    { BGP_CFG->ttl_security = (yyvsp[(4) - (5)].i); }
    break;

  case 486:
/* Line 1792 of yacc.c  */
#line 2211 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config), (yyvsp[(1) - (2)].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  }
    break;

  case 490:
/* Line 1792 of yacc.c  */
#line 2227 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); }
    break;

  case 491:
/* Line 1792 of yacc.c  */
#line 2228 "cf-parse.y"
    { OSPF_CFG->stub_router = (yyvsp[(3) - (3)].i); }
    break;

  case 492:
/* Line 1792 of yacc.c  */
#line 2229 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (2)].i) ? DEFAULT_ECMP_LIMIT : 0; }
    break;

  case 493:
/* Line 1792 of yacc.c  */
#line 2230 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); }
    break;

  case 494:
/* Line 1792 of yacc.c  */
#line 2231 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i); if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); }
    break;

  case 496:
/* Line 1792 of yacc.c  */
#line 2235 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (2)].i32);
  this_area->default_cost = DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
    break;

  case 497:
/* Line 1792 of yacc.c  */
#line 2250 "cf-parse.y"
    { ospf_area_finish(); }
    break;

  case 500:
/* Line 1792 of yacc.c  */
#line 2259 "cf-parse.y"
    { this_area->type = (yyvsp[(2) - (2)].i) ? 0 : OPT_E; /* We should remove the option */ }
    break;

  case 501:
/* Line 1792 of yacc.c  */
#line 2260 "cf-parse.y"
    { this_area->type = OPT_N; }
    break;

  case 502:
/* Line 1792 of yacc.c  */
#line 2261 "cf-parse.y"
    { this_area->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 503:
/* Line 1792 of yacc.c  */
#line 2262 "cf-parse.y"
    { this_area->default_nssa = (yyvsp[(3) - (3)].i); }
    break;

  case 504:
/* Line 1792 of yacc.c  */
#line 2263 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 505:
/* Line 1792 of yacc.c  */
#line 2264 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i) | LSA_EXT_EBIT; check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 506:
/* Line 1792 of yacc.c  */
#line 2265 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i);  check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 507:
/* Line 1792 of yacc.c  */
#line 2266 "cf-parse.y"
    { this_area->translator = (yyvsp[(2) - (2)].i); }
    break;

  case 508:
/* Line 1792 of yacc.c  */
#line 2267 "cf-parse.y"
    { this_area->transint = (yyvsp[(3) - (3)].i); }
    break;

  case 509:
/* Line 1792 of yacc.c  */
#line 2268 "cf-parse.y"
    { this_nets = &this_area->net_list; }
    break;

  case 511:
/* Line 1792 of yacc.c  */
#line 2269 "cf-parse.y"
    { this_nets = &this_area->enet_list; }
    break;

  case 518:
/* Line 1792 of yacc.c  */
#line 2281 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   }
    break;

  case 521:
/* Line 1792 of yacc.c  */
#line 2295 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); }
    break;

  case 522:
/* Line 1792 of yacc.c  */
#line 2296 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 523:
/* Line 1792 of yacc.c  */
#line 2297 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); }
    break;

  case 524:
/* Line 1792 of yacc.c  */
#line 2301 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 525:
/* Line 1792 of yacc.c  */
#line 2302 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 529:
/* Line 1792 of yacc.c  */
#line 2311 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 530:
/* Line 1792 of yacc.c  */
#line 2312 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); }
    break;

  case 531:
/* Line 1792 of yacc.c  */
#line 2313 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 532:
/* Line 1792 of yacc.c  */
#line 2314 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; }
    break;

  case 533:
/* Line 1792 of yacc.c  */
#line 2315 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 534:
/* Line 1792 of yacc.c  */
#line 2316 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 535:
/* Line 1792 of yacc.c  */
#line 2317 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
    break;

  case 536:
/* Line 1792 of yacc.c  */
#line 2318 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
    break;

  case 537:
/* Line 1792 of yacc.c  */
#line 2319 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
    break;

  case 539:
/* Line 1792 of yacc.c  */
#line 2324 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 }
    break;

  case 540:
/* Line 1792 of yacc.c  */
#line 2345 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); }
    break;

  case 541:
/* Line 1792 of yacc.c  */
#line 2346 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 542:
/* Line 1792 of yacc.c  */
#line 2347 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); }
    break;

  case 543:
/* Line 1792 of yacc.c  */
#line 2348 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); }
    break;

  case 544:
/* Line 1792 of yacc.c  */
#line 2349 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; }
    break;

  case 545:
/* Line 1792 of yacc.c  */
#line 2350 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 546:
/* Line 1792 of yacc.c  */
#line 2351 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 547:
/* Line 1792 of yacc.c  */
#line 2352 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 548:
/* Line 1792 of yacc.c  */
#line 2353 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 549:
/* Line 1792 of yacc.c  */
#line 2354 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 550:
/* Line 1792 of yacc.c  */
#line 2355 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 551:
/* Line 1792 of yacc.c  */
#line 2356 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 552:
/* Line 1792 of yacc.c  */
#line 2357 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 553:
/* Line 1792 of yacc.c  */
#line 2358 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 554:
/* Line 1792 of yacc.c  */
#line 2359 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 555:
/* Line 1792 of yacc.c  */
#line 2360 "cf-parse.y"
    { OSPF_PATT->real_bcast = (yyvsp[(3) - (3)].i); if (OSPF_VERSION != 2) cf_error("Real broadcast option requires OSPFv2"); }
    break;

  case 556:
/* Line 1792 of yacc.c  */
#line 2361 "cf-parse.y"
    { OSPF_PATT->ptp_netmask = (yyvsp[(3) - (3)].i); if (OSPF_VERSION != 2) cf_error("Real netmask option requires OSPFv2"); }
    break;

  case 557:
/* Line 1792 of yacc.c  */
#line 2362 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 558:
/* Line 1792 of yacc.c  */
#line 2363 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); }
    break;

  case 559:
/* Line 1792 of yacc.c  */
#line 2364 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; }
    break;

  case 560:
/* Line 1792 of yacc.c  */
#line 2365 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; }
    break;

  case 561:
/* Line 1792 of yacc.c  */
#line 2366 "cf-parse.y"
    { OSPF_PATT->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 562:
/* Line 1792 of yacc.c  */
#line 2367 "cf-parse.y"
    { OSPF_PATT->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
    break;

  case 564:
/* Line 1792 of yacc.c  */
#line 2369 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
    break;

  case 565:
/* Line 1792 of yacc.c  */
#line 2370 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
    break;

  case 566:
/* Line 1792 of yacc.c  */
#line 2371 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
    break;

  case 567:
/* Line 1792 of yacc.c  */
#line 2372 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_LARGE ; }
    break;

  case 568:
/* Line 1792 of yacc.c  */
#line 2373 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_NORMAL ; }
    break;

  case 569:
/* Line 1792 of yacc.c  */
#line 2374 "cf-parse.y"
    { OSPF_PATT->rxbuf = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i) < OSPF_RXBUF_MINSIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
    break;

  case 570:
/* Line 1792 of yacc.c  */
#line 2375 "cf-parse.y"
    { OSPF_PATT->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 571:
/* Line 1792 of yacc.c  */
#line 2376 "cf-parse.y"
    { OSPF_PATT->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 572:
/* Line 1792 of yacc.c  */
#line 2377 "cf-parse.y"
    { OSPF_PATT->ttl_security = (yyvsp[(3) - (3)].i); }
    break;

  case 573:
/* Line 1792 of yacc.c  */
#line 2378 "cf-parse.y"
    { OSPF_PATT->ttl_security = 2; }
    break;

  case 578:
/* Line 1792 of yacc.c  */
#line 2390 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (1)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (1)].px).len;
 }
    break;

  case 580:
/* Line 1792 of yacc.c  */
#line 2400 "cf-parse.y"
    { this_pref->hidden = 1; }
    break;

  case 581:
/* Line 1792 of yacc.c  */
#line 2401 "cf-parse.y"
    { this_pref->tag = (yyvsp[(2) - (2)].i); }
    break;

  case 584:
/* Line 1792 of yacc.c  */
#line 2410 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 585:
/* Line 1792 of yacc.c  */
#line 2411 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 586:
/* Line 1792 of yacc.c  */
#line 2415 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=(yyvsp[(2) - (3)].i);
 }
    break;

  case 587:
/* Line 1792 of yacc.c  */
#line 2424 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
    break;

  case 589:
/* Line 1792 of yacc.c  */
#line 2449 "cf-parse.y"
    { set_instance_id((yyvsp[(2) - (2)].i)); }
    break;

  case 594:
/* Line 1792 of yacc.c  */
#line 2463 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 596:
/* Line 1792 of yacc.c  */
#line 2468 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 597:
/* Line 1792 of yacc.c  */
#line 2474 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); }
    break;

  case 598:
/* Line 1792 of yacc.c  */
#line 2477 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 599:
/* Line 1792 of yacc.c  */
#line 2480 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 600:
/* Line 1792 of yacc.c  */
#line 2485 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0, 1); }
    break;

  case 601:
/* Line 1792 of yacc.c  */
#line 2488 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 0, 0); }
    break;

  case 602:
/* Line 1792 of yacc.c  */
#line 2493 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1, 1); }
    break;

  case 603:
/* Line 1792 of yacc.c  */
#line 2496 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 1, 0); }
    break;

  case 604:
/* Line 1792 of yacc.c  */
#line 2500 "cf-parse.y"
    { ospf_sh_lsadb((yyvsp[(4) - (5)].ld)); }
    break;

  case 605:
/* Line 1792 of yacc.c  */
#line 2503 "cf-parse.y"
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
    break;

  case 606:
/* Line 1792 of yacc.c  */
#line 2506 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
    break;

  case 607:
/* Line 1792 of yacc.c  */
#line 2507 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[(3) - (3)].i32); }
    break;

  case 608:
/* Line 1792 of yacc.c  */
#line 2508 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
    break;

  case 609:
/* Line 1792 of yacc.c  */
#line 2509 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->type = (yyvsp[(3) - (3)].i); }
    break;

  case 610:
/* Line 1792 of yacc.c  */
#line 2510 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->lsid = (yyvsp[(3) - (3)].i32); }
    break;

  case 611:
/* Line 1792 of yacc.c  */
#line 2511 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
    break;

  case 612:
/* Line 1792 of yacc.c  */
#line 2512 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->router = (yyvsp[(3) - (3)].i32); }
    break;

  case 613:
/* Line 1792 of yacc.c  */
#line 2513 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->name = (yyvsp[(2) - (2)].s); }
    break;

  case 614:
/* Line 1792 of yacc.c  */
#line 2519 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config), (yyvsp[(1) - (2)].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
    break;

  case 617:
/* Line 1792 of yacc.c  */
#line 2528 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   }
    break;

  case 618:
/* Line 1792 of yacc.c  */
#line 2533 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; }
    break;

  case 619:
/* Line 1792 of yacc.c  */
#line 2534 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
    break;

  case 620:
/* Line 1792 of yacc.c  */
#line 2540 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config), (yyvsp[(1) - (2)].i));
     rip_init_config(RIP_CFG);
   }
    break;

  case 623:
/* Line 1792 of yacc.c  */
#line 2549 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(3) - (4)].i); }
    break;

  case 624:
/* Line 1792 of yacc.c  */
#line 2550 "cf-parse.y"
    { RIP_CFG->port = (yyvsp[(3) - (4)].i); }
    break;

  case 625:
/* Line 1792 of yacc.c  */
#line 2551 "cf-parse.y"
    { RIP_CFG->period = (yyvsp[(3) - (4)].i); }
    break;

  case 626:
/* Line 1792 of yacc.c  */
#line 2552 "cf-parse.y"
    { RIP_CFG->garbage_time = (yyvsp[(4) - (5)].i); }
    break;

  case 627:
/* Line 1792 of yacc.c  */
#line 2553 "cf-parse.y"
    { RIP_CFG->timeout_time = (yyvsp[(4) - (5)].i); }
    break;

  case 628:
/* Line 1792 of yacc.c  */
#line 2554 "cf-parse.y"
    {RIP_CFG->authtype = (yyvsp[(3) - (4)].i); }
    break;

  case 630:
/* Line 1792 of yacc.c  */
#line 2556 "cf-parse.y"
    { RIP_CFG->honor = HO_ALWAYS; }
    break;

  case 631:
/* Line 1792 of yacc.c  */
#line 2557 "cf-parse.y"
    { RIP_CFG->honor = HO_NEIGHBOR; }
    break;

  case 632:
/* Line 1792 of yacc.c  */
#line 2558 "cf-parse.y"
    { RIP_CFG->honor = HO_NEVER; }
    break;

  case 634:
/* Line 1792 of yacc.c  */
#line 2563 "cf-parse.y"
    { (yyval.i)=AT_PLAINTEXT; }
    break;

  case 635:
/* Line 1792 of yacc.c  */
#line 2564 "cf-parse.y"
    { (yyval.i)=AT_MD5; }
    break;

  case 636:
/* Line 1792 of yacc.c  */
#line 2565 "cf-parse.y"
    { (yyval.i)=AT_NONE; }
    break;

  case 637:
/* Line 1792 of yacc.c  */
#line 2570 "cf-parse.y"
    { (yyval.i)=IM_BROADCAST; }
    break;

  case 638:
/* Line 1792 of yacc.c  */
#line 2571 "cf-parse.y"
    { (yyval.i)=0; }
    break;

  case 639:
/* Line 1792 of yacc.c  */
#line 2572 "cf-parse.y"
    { (yyval.i)=IM_QUIET; }
    break;

  case 640:
/* Line 1792 of yacc.c  */
#line 2573 "cf-parse.y"
    { (yyval.i)=IM_NOLISTEN; }
    break;

  case 641:
/* Line 1792 of yacc.c  */
#line 2574 "cf-parse.y"
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; }
    break;

  case 643:
/* Line 1792 of yacc.c  */
#line 2578 "cf-parse.y"
    { RIP_IPATT->metric = (yyvsp[(2) - (2)].i); }
    break;

  case 644:
/* Line 1792 of yacc.c  */
#line 2579 "cf-parse.y"
    { RIP_IPATT->mode |= (yyvsp[(2) - (2)].i); }
    break;

  case 645:
/* Line 1792 of yacc.c  */
#line 2580 "cf-parse.y"
    { RIP_IPATT->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 646:
/* Line 1792 of yacc.c  */
#line 2581 "cf-parse.y"
    { RIP_IPATT->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 647:
/* Line 1792 of yacc.c  */
#line 2582 "cf-parse.y"
    { RIP_IPATT->ttl_security = (yyvsp[(3) - (3)].i); }
    break;

  case 648:
/* Line 1792 of yacc.c  */
#line 2583 "cf-parse.y"
    { RIP_IPATT->ttl_security = 2; }
    break;

  case 653:
/* Line 1792 of yacc.c  */
#line 2597 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
     RIP_IPATT->tx_tos = IP_PREC_INTERNET_CONTROL;
     RIP_IPATT->tx_priority = sk_priority_control;
     RIP_IPATT->ttl_security = RIP_DEFAULT_TTL_SECURITY;
   }
    break;

  case 655:
/* Line 1792 of yacc.c  */
#line 2616 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config), (yyvsp[(1) - (2)].i));
     static_init_config((struct static_config *) this_proto);
  }
    break;

  case 658:
/* Line 1792 of yacc.c  */
#line 2625 "cf-parse.y"
    { STATIC_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 659:
/* Line 1792 of yacc.c  */
#line 2626 "cf-parse.y"
    { STATIC_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 661:
/* Line 1792 of yacc.c  */
#line 2630 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
  }
    break;

  case 662:
/* Line 1792 of yacc.c  */
#line 2639 "cf-parse.y"
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[(2) - (3)].a);
     this_srt_nh->via_if = (yyvsp[(3) - (3)].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
   }
    break;

  case 663:
/* Line 1792 of yacc.c  */
#line 2647 "cf-parse.y"
    {
     this_srt_nh->masklen = (yyvsp[(3) - (3)].i) - 1; /* really */
     if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
    break;

  case 664:
/* Line 1792 of yacc.c  */
#line 2654 "cf-parse.y"
    { this_srt->mp_next = this_srt_nh; }
    break;

  case 665:
/* Line 1792 of yacc.c  */
#line 2655 "cf-parse.y"
    { last_srt_nh->mp_next = this_srt_nh; }
    break;

  case 666:
/* Line 1792 of yacc.c  */
#line 2659 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (4)].a);
      this_srt->via_if = (yyvsp[(4) - (4)].iface);
   }
    break;

  case 667:
/* Line 1792 of yacc.c  */
#line 2664 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
    break;

  case 668:
/* Line 1792 of yacc.c  */
#line 2670 "cf-parse.y"
    {
      this_srt->dest = RTD_MULTIPATH;
   }
    break;

  case 669:
/* Line 1792 of yacc.c  */
#line 2673 "cf-parse.y"
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[(3) - (3)].a);
   }
    break;

  case 670:
/* Line 1792 of yacc.c  */
#line 2678 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 671:
/* Line 1792 of yacc.c  */
#line 2679 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 672:
/* Line 1792 of yacc.c  */
#line 2680 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 673:
/* Line 1792 of yacc.c  */
#line 2681 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 674:
/* Line 1792 of yacc.c  */
#line 2682 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; }
    break;

  case 675:
/* Line 1792 of yacc.c  */
#line 2686 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); }
    break;

  case 738:
/* Line 1792 of yacc.c  */
#line 2694 "cf-parse.y"
    { bgp_check_config(BGP_CFG); }
    break;

  case 739:
/* Line 1792 of yacc.c  */
#line 2694 "cf-parse.y"
    { ospf_proto_finish(); }
    break;

  case 741:
/* Line 1792 of yacc.c  */
#line 2694 "cf-parse.y"
    { RIP_CFG->passwords = get_passwords(); }
    break;

  case 750:
/* Line 1792 of yacc.c  */
#line 2697 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
    break;

  case 751:
/* Line 1792 of yacc.c  */
#line 2697 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
    break;

  case 752:
/* Line 1792 of yacc.c  */
#line 2697 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
    break;

  case 753:
/* Line 1792 of yacc.c  */
#line 2697 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
    break;

  case 754:
/* Line 1792 of yacc.c  */
#line 2698 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
    break;

  case 755:
/* Line 1792 of yacc.c  */
#line 2698 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 756:
/* Line 1792 of yacc.c  */
#line 2699 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
    break;

  case 757:
/* Line 1792 of yacc.c  */
#line 2700 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
    break;

  case 758:
/* Line 1792 of yacc.c  */
#line 2701 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
    break;

  case 759:
/* Line 1792 of yacc.c  */
#line 2702 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
    break;

  case 760:
/* Line 1792 of yacc.c  */
#line 2703 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
    break;

  case 761:
/* Line 1792 of yacc.c  */
#line 2704 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
    break;

  case 762:
/* Line 1792 of yacc.c  */
#line 2705 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
    break;

  case 763:
/* Line 1792 of yacc.c  */
#line 2706 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
    break;

  case 764:
/* Line 1792 of yacc.c  */
#line 2707 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
    break;

  case 765:
/* Line 1792 of yacc.c  */
#line 2708 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
    break;

  case 766:
/* Line 1792 of yacc.c  */
#line 2709 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
    break;

  case 767:
/* Line 1792 of yacc.c  */
#line 2709 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
    break;

  case 768:
/* Line 1792 of yacc.c  */
#line 2709 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
    break;

  case 769:
/* Line 1792 of yacc.c  */
#line 2709 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
    break;

  case 770:
/* Line 1792 of yacc.c  */
#line 2709 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
    break;

  case 771:
/* Line 1792 of yacc.c  */
#line 2709 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
    break;

  case 772:
/* Line 1792 of yacc.c  */
#line 2709 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
    break;


/* Line 1792 of yacc.c  */
#line 8151 "cf-parse.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 2711 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

